# DO NOT MODIFY THIS FILE
#
# Clutter uses the Git commit log to generate the ChangeLog files when
# creating the tarball for releases and snapshots. This file is maintained
# only for historical reasons.

2008-12-10  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/cogl/gl/cogl-context.h:
	* clutter/cogl/common/cogl-mesh.c: Rename the glBufferDataSub
	function to glBufferSubData. When calling glXGetProcAddress with
	the former Mesa returns a stub dispatch function which will
	segfault if you try to use it. With NVIDIA it returns NULL so
	_cogl_features_init decides the card doesn't have VBO support.

2008-12-10  Neil Roberts  <neil@linux.intel.com>

	Bug 1323 - ClutterBehaviorDepth conflicts with other behaviors

	* clutter/clutter-behaviour-ellipse.c (actor_apply_knot_foreach):
	Don't set the depth if there is no x or y tilt. That way it can
	still be used in conjunction with ClutterBehaviourDepth. Thanks to
	Tonny Tzeng.

2008-12-08  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-binding-pool.h: Fix the ActivateFunc
	documentation by adding a "return value" annotation.

2008-12-08  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/Makefile.am:
	* clutter/clutter.h: Add ClutterBindingPool to the build.

	* clutter/clutter-binding-pool.c:
	* clutter/clutter-binding-pool.h: Add ClutterBindingPool, a data
	structure meant to hold (key symbol, modifiers) pairs and associate
	them to a closure. The ClutterBindingPool can be used to install
	key bindings for actors and then execute closures inside the
	key-press-event signal handlers, removing the need for big
	switch() or if() blocks for each key.

	* clutter/clutter-event.c: Consistently use "key symbol" instead
	of "key value".

	* clutter/clutter-event.h: Add more modifier masks.

	* clutter/clutter-marshal.list:

	* tests/conform/Makefile.am:
	* tests/conform/test-binding-pool.c:
	* tests/conform/test-conform-main.c: Add ClutterBindingPool
	conformance test.

	* tests/interactive/Makefile.am:
	* tests/interactive/test-binding-pool.c: Add interactive test (and
	example code) for the ClutterBindingPool usage.

2008-12-08  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-main.c (_clutter_do_pick): Restore the GL_DITHER
	state after reading the pixel value instead of before. Suggested
	in bug 1328 thanks to Guy Zadickario.

2008-12-05  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1309 - clutter_timeline_new and clutter_timeline_set_speed
	have two standard of the fps limitation

	* clutter/clutter-timeline.c:
	(clutter_timeline_class_init): Set the maximum value of the
	:fps property to be G_MAXUINT. (Zhang Wei)

2008-12-05  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-entry.c: Fix the 'Since' annotation in the
	gtk-doc.

2008-12-05  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-timeline.c:
	* clutter/clutter-texture.c:
	* clutter/clutter-stage.c:
	* clutter/clutter-label.c:
	* clutter/clutter-behaviour-path.c:
	* clutter/clutter-actor.c: Fix the 'Since' annotation in the
	gtk-doc.

2008-12-05  Neil Roberts  <neil@linux.intel.com>

	Bug 1252 - Merge ClutterBehaviourPath and ClutterBehaviourBspline

	* clutter/clutter-path.h:
	* clutter/clutter-path.c: Implementation of new ClutterPath object
	to represent a path combining straight line and bezier curve
	elements.

	* clutter/clutter.h: Include clutter-path.h and remove
	clutter-behaviour-bspline.h

	* tests/interactive/test-threads.c (test_threads_main):
	* tests/interactive/test-script.c:
	* tests/interactive/test-behave.c (test_behave_main): Use new path
	API

	* clutter/clutter-effect.c: Use the new ClutterBehaviourPath API.

	* clutter/clutter-bezier.h:
	* clutter/clutter-bezier.c: Moved bezier curve handling code out
	from clutter-behaviour-bspline.c to a separate file.

	* clutter/clutter-behaviour-path.h:
	* clutter/clutter-behaviour-path.c: Reimplemented to work with a
	ClutterPath

	* clutter/clutter-behaviour-bspline.h:
	* clutter/clutter-behaviour-bspline.c: Removed

	* clutter/Makefile.am: Add clutter-path and clutter-bezier, remove
	clutter-behaviour-bspline.

	* tests/conform/test-path.c: New automatic test for ClutterPath
	consistency

	* tests/conform/test-conform-main.c (main): Add test_path

	* tests/conform/Makefile.am (test_conformance_SOURCES): Add
	test-path.c

	* clutter/clutter-sections.txt: Add ClutterPath docs

	* clutter/clutter.types:
	* clutter/clutter-docs.xml:
	* doc/reference/clutter/clutter-animation-tutorial.xml: Remove
	mention of ClutterBehaviourBspline

	* clutter/clutter-marshal.list: Add VOID:UINT

2008-12-04  Neil Roberts  <neil@linux.intel.com>

	Bug 1297 - Bring back support for GL_ARB_texture_rectangle

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_new_from_foreign,
	(_cogl_texture_quad_hw, cogl_texture_polygon),
	(_cogl_texture_quad_sw): Support GL_ARB_texture_rectangle textures

	* clutter/glx/clutter-glx-texture-pixmap.c: Use rectangle textures
	when NPOTs are not available or it is forced by the
	CLUTTER_PIXMAP_TEXTURE_RECTANGLE environment variable.

	* clutter/cogl/gl/cogl.c (cogl_enable): Allow enabling
	GL_TEXTURE_RECTANGLE_ARB.

2008-12-04  Neil Roberts  <neil@linux.intel.com>

	Bug 1172 - Disjoint paths and clip to path

	* clutter/cogl/cogl-path.h:
	* clutter/cogl/common/cogl-primitives.c:
	* clutter/cogl/common/cogl-primitives.h:
	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gles/cogl-primitives.c: Changed the semantics of
	cogl_path_move_to. Previously this always started a new path but
	now it instead starts a new disjoint sub path. The path isn't
	cleared until you call either cogl_path_stroke, cogl_path_fill or
	cogl_path_new. There are also cogl_path_stroke_preserve and
	cogl_path_fill_preserve functions.

	* clutter/cogl/gl/cogl-context.c:
	* clutter/cogl/gl/cogl-context.h:
	* clutter/cogl/gles/cogl-context.c:
	* clutter/cogl/gles/cogl-context.h: Convert the path nodes array
	to a GArray.

	* clutter/cogl/gl/cogl-texture.c:
	* clutter/cogl/gles/cogl-texture.c: Call cogl_clip_ensure

	* clutter/cogl/common/cogl-clip-stack.c:
	* clutter/cogl/common/cogl-clip-stack.h: Simplified the clip
	stack code quite a bit to make it more maintainable.  Previously
	whenever you added a new clip it would go through a separate route
	to immediately intersect with the current clip and when you
	removed it again it would immediately rebuild the entire clip. Now
	when you add or remove a clip it doesn't do anything immediately
	but just sets a dirty flag instead.

	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/cogl.c: Taken away the code to intersect
	stencil clips when there is exactly one stencil bit. It won't work
	with path clips and I don't know of any platform that doesn't have
	eight or zero stencil bits. It needs at least three bits to
	intersect a path with an existing clip. cogl_features_init now
	just decides you don't have a stencil buffer at all if you have
	less than three bits.

	* clutter/cogl/cogl.h.in: New functions and documentation.

	* tests/interactive/test-clip.c: Replaced with a different test
	that lets you add and remove clips. The three different mouse
	buttons add clips in different shapes. This makes it easier to
	test multiple levels of clipping.

	* tests/interactive/test-cogl-primitives.c: Use
	cogl_path_stroke_preserve when using the same path again.

	* doc/reference/cogl/cogl-sections.txt: Document the new
	functions.

2008-12-03  Robert Bragg  <robert@linux.intel.com>

	Bug 1303 - clutter_glx_texture_pixmap_using_extension doesn't check if
	fallbacks are being used

	* glx/clutter-glx-texture-pixmap.c:
	clutter_glx_texture_pixmap_using_extension now checks to see if
	priv->use_fallback is TRUE not just that the tfp extension is
	available.

2008-12-01  Neil Roberts  <neil@linux.intel.com>

	Bug 1305 - NPOT textures unaligned to a pixel sometimes have
	border artifacts

	* clutter/cogl/gl/cogl-texture.c: Set the wrap mode of a texture
	on demand

	Instead of setting the wrap mode once per texture at creation, it
	is now changed whenever the texture is drawn. The previous value
	is cached so that it isn't changed if the value is the same.

	This is used in _cogl_texture_quad_hw to only enable GL_REPEAT
	mode when the coordinates are not in the range [0,1]. Otherwise it
	can pull in pixels from the other edge when the texture is
	rendered off-pixel.

2008-11-28  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-backface-culling.c (TEXTURE_SIZE): Don't set
	to a funny size on GLES because it will break cogl_texture_polygon

2008-11-28  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-backface-culling.c: New test for backface
	culling

	* tests/conform/test-conform-main.c (main): Add
	/texture/test_backface_culing

	* tests/conform/Makefile.am (test_conformance_SOURCES): Add
	test-backface-culling.c

2008-11-28  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-mesh-mutability.c:
	* tests/conform/test-mesh-interleved.c:
	* tests/conform/test-mesh-contiguous.c: Remove the idle source
	after the test is complete so that it won't interfere with other
	tests.

2008-11-26  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-group.c:
	(clutter_group_real_raise), (clutter_group_real_lower): Repaint
	the Group on raise and lower.

2008-11-26  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_rectangle): Fixed
	the test for whether to use hardware tiling. Previously it assumed
	that texture coordinates are in increasing order but this is not
	the case since bug 1057 was fixed. The texture coordinates are now
	sorted later. It also allowed negative coordinates which doesn't
	make sense if the texture has waste.

2008-11-25  Emmanuele Bassi  <ebassi@linux.intel.com>

	* configure.ac: Remove stray dependency on gdk-pixbuf-xlib; we
	don't use the xlib specific API anymore. (thanks to Matthias
	Clasen)

2008-11-25  Neil Roberts  <neil@linux.intel.com>

	Bug 1299 - clutter_score_remove will segmentation fault if
	timelines are more than 52 and continue to remove them

	* clutter/clutter-score.c (traverse_children): Don't destroy the
	entry in the handler for REMOVE_BY_ID. It will be removed again
	anyway in the call to g_node_traverse. This was causing a
	crash. Thanks to zhangwei for spotting.

2008-11-24  Neil Roberts  <neil@linux.intel.com>

	Add a wrapper library to help testing without NPOTs.

	* tests/tools/Makefile.am: Optionally build the
	libdisable-npots.la library depending on whether libdl was
	detected in the configure script. A helper script is also
	generated to setup the LD_PRELOAD.

	* tests/conform/Makefile.am: There are now two versions of the
	test-report and full-report rules. test-report-normal is the same
	as before and test-report-disable-npots runs the tests with the
	disable-npots wrapper script. The full-report rule runs both of
	them and displays two separate HTML files. The test-report rule
	just runs the normal version as before.

	* configure.ac: Add a test for libdl

	* tests/tools/disable-npots.sh.in: New file. Template for the
	helper script

	* tests/tools/disable-npots.c: New file

2008-11-24  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_polygon): Fix the
	equation for calculating texture coordinates when using sliced
	textures. This became broken in revision 3520.

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	Bug 1270 - Update to mingw-cross-compile.sh

	* build/mingw/mingw-cross-compile.sh: Update to download latest
	binaries. Patch thanks to David Kedves.

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	Bug 1271 - mingw compiling failed: undefined reference to
	`_glDrawRangeElements@24'

	Resolve glDrawRangeElements with cogl_get_proc_address instead of
	calling it directly because functions defined in GL > 1.1 are not
	directly exported under Windows.

	* clutter/cogl/common/cogl-mesh.c: Use the function pointer from
	the context

	* clutter/cogl/gl/cogl-context.c (cogl_create_context): Initialise
	function pointer.

	* clutter/cogl/gl/cogl-context.h (CoglContext): Add a function
	pointer

	* clutter/cogl/gl/cogl-defines.h.in: Add a typedef for the
	function pointer.

	* clutter/cogl/gl/cogl.c (_cogl_features_init): Resolve
	glDrawRangeElements

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	* tests/interactive/Makefile.am:
	* tests/conform/Makefile.am: Use $(EXEEXT) when specifying a
	dependency on an executable otherwise there won't be a rule to
	build it on Windows.

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	Bug 1269 - mingw32 building failed at clutter-media.c

	* clutter/clutter-media.c: Rename the 'ERROR' signal enum to
	'ERROR_SIGNAL' otherwise it clashes with windgi.h. Thanks to David
	Kedves

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	* clutter/pango/cogl-pango.h: Include pango/pango.h to get
	pango-renderer.h. In versions prior to 1.18.4 pangocairo.h does
	not include pango-renderer.h

2008-11-21  Neil Roberts  <neil@linux.intel.com>

	Bug 1280 - clutter_score_append_at_marker lead to segmentation
	fault in trunk and incorrect appearance in clutter-0.8

	* clutter/clutter-score.c (start_children_entries): Check whether
	the child timeline is actually attached at a marker before
	comparing whether the marker's name matches the marker
	reached. This fixes a crash that happens when a marker is reached
	on a timeline that also has child timelines attached at the
	end. Thanks to zhangwei for spotting.

2008-11-20  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_property): Add sanity checks for NULL
	boxed values when setting the rotation center.

	* tests/interactive/test-animation.c:
	(on_button_press): Add an example on how to use the rotation
	properties to animate an actor.

2008-11-18  Neil Roberts  <neil@linux.intel.com>

	Fixed some trivial compiler warnings

	* tests/interactive/test-pixmap.c (create_pixmap): Use a format
	string instead of passing the error message directly to g_error.

	* tests/interactive/test-easing.c (test_easing_main)
	(on_button_press):
	* tests/interactive/test-animation.c (on_button_press): Use
	unsigned variables for the results from clutter_actor_get_size
	otherwise it complains about the pointer signedness being
	different.

	* clutter/clutter-script.c (clutter_script_add_search_paths): Use
	G_GSIZE_FORMAT instead of %d for a gsize parameter otherwise it
	gets upset on 64-bit.

2008-11-18  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-timeline.c (test_timeline): Remove the delay
	idle handler after the test is finished, otherwise it will
	continue running during subsequent tests. This was breaking
	test_timeline_interpolate.

2008-11-18  Robert Bragg  <robert@linux.intel.com>

	* clutter/cogl/common/cogl-mesh.c:
	Re-works validate_custom_attribute_name() so it doesn't access an
	un-initialised variable.

2008-11-18  Robert Bragg  <robert@linux.intel.com>

	A comparison of gl/cogl-texture.c and gles/cogl-texture.c, to reduce
	differences and improve maintainability.

	* clutter/cogl/gl/cogl-context.h:
	Adds a CoglTextureGLVertex typedef + texture_vertices and
	texture_vertices_size members to CoglContext for using vertex arrays
	like GLES does

	* clutter/cogl/gl/cogl-context.c:
	Initializes texture_vertices + texture_vertices_size members

	* clutter/cogl/gl/cogl-internal.h:
	Adds COGL_ENABLE_COLOR_ARRAY

	* clutter/cogl/gl/cogl.c:
	Add COGL_ENABLE_COLOR_ARRAY support to cogl_enable

	* clutter/cogl/gles/cogl-context.h:
	Change the CoglTextureGLVertex to use GLfloat for the position
	and texture coord attributes and GLubyte for the color.

	* clutter/cogl/gles/cogl-texture-private.h:
	Adds a wrap_mode member like GL has.

	* clutter/cogl/gl/cogl-texture.c
	* clutter/cogl/gles/cogl-texture.c:
	Improves the comparability of the files, such that the remaining
	differences, better reflect the fundamental differences needed
	between GL and GLES. Notably GL no longer uses glBegin/glEnd for
	submitting vertices, it uses vertex arrays like GLES and this gives
	a small but measurable fps improvement for test-text.

2008-11-18  Robert Bragg  <robert@linux.intel.com>

	* clutter/cogl/gl/cogl-internal.h
	* clutter/cogl/gles/cogl-internal.h:
	Removes semicolon after the GE() macro since that breaks using it as a
	single statement.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter.h: Add clutter-shader.h and
	clutter-shader-types.h to the global include.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/cogl/cogl-shader.h: Add a function for setting an
	integer uniform, similar to cogl_program_uniform_1f().

	* clutter/cogl/gl/cogl-program.c: Implement the GL version
	of cogl_program_uniform_1i().

	* clutter/cogl/gles/cogl-program.c: Implement the GLES version
	of cogl_program_uniform_1i().

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1049 - Clutter doesn't support most GLSL uniforms (patch
	by Chris Lord and Neil Roberts)

	* README: Update release notes.

	* clutter/Makefile.am:
	* clutter/clutter-shader-types.[ch]: Add GValue types for
	shader values.

	* clutter/clutter-actor.[ch]: Update the shader API to use
	the newly added GValue support for GLSL shader uniform
	setters.

	* clutter/clutter-shader.[ch]: Add float and integer convenience
	API for single value GLSL uniform setters.

	* clutter/cogl/cogl-shader.h: Add new uniform setters.

	* clutter/cogl/gl/cogl-context.c:
	* clutter/cogl/gl/cogl-context.h:
	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/cogl/gl/cogl-program.c:
	* clutter/cogl/gl/cogl.c: Update the GL implementation of COGL
	to handle the GLSL uniform setters.

	* clutter/cogl/gles/cogl-gles2-wrapper.c:
	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-internal.h:
	* clutter/cogl/gles/cogl-program.c: Update the GLES 2.0 implementation
	of COGL to handle the GLSL uniform setters.

	* doc/reference/clutter/clutter-sections.txt:
	* doc/reference/cogl/cogl-sections.txt: Update the documentation.

	* tests/interactive/test-fbo.c:
	* tests/interactive/test-shader.c: Update the shader tests.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-texture.c:
	(clutter_texture_get_preferred_width): Fix the usage of the
	fixed point division macro.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/conform/test-conform-main.c (main): Do not run the
	conformance test suite if we are on X11 but we do not have
	a DISPLAY available. Some of the tests require a DISPLAY,
	and everything passes through a clutter_init() call which will
	fail anyway. If we are running make distcheck on an headless
	box we might as well just skip the conformance test suite
	without a meaningless error.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/conform/test-mesh-contiguous.c:
	* tests/conform/test-mesh-interleved.c:
	* tests/conform/test-mesh-mutability.c: Remove the last bare
	g_print() from the conformance test suite.

2008-11-18  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-alpha.h:
	* clutter/clutter-alpha.c:
	(clutter_alpha_set_mode): Use a lookup table to find the alpha
	function given the animation mode.

	(clutter_exp_in_func),
	(clutter_exp_out_func),
	(clutter_exp_in_out_func): Add new exponential functions.

	* clutter/clutter-script.c: Update the lookup table with the
	new animation modes; match "linear" to the ramp-inc alpha
	function.

	* clutter/clutter-types.h: Add new AnimationMode values.

	* tests/interactive/test-easing.c: Update the easing functions
	test.

2008-11-18  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-pick.c (test_pick): The final result message
	when --verbose is used was the wrong way around

2008-11-18  Neil Roberts  <neil@linux.intel.com>

	* tests/conform/test-conform-main.c (main): Fixed a typo in the
	name of the path for test_realized.

2008-11-17  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1014 - Clutter Animation API Improvements

	* clutter/Makefile.am:
	* clutter/clutter.h: Update the build

	* clutter/clutter-types.h: Add AnimationMode, an enumeration
	for easing functions.

	* clutter/clutter-alpha.[ch]: Add the :mode property to
	control the function bound to an Alpha instance using an
	enumeration value. Also add six new alpha functions:

		- ease-in, ease-out, ease-in-out
		- sine-in, sine-out, sine-in-out

	* clutter/clutter-deprecated.h: Deprecate the #defines for
	the alpha functions. They will be replaced by entries in the
	ClutterAnimationMode.

	* clutter/clutter-interval.[ch]: Add ClutterInterval, an
	object for defining, validating and computing an interval
	between two values.

	* clutter/clutter-animation.[ch]: Add ClutterAnimation, an
	object responsible for animation the properties of a single
	actor along an interval of values. ClutterAnimation memory
	management is automatic. A simple wrapper method for
	ClutterActor is provided:

		clutter_actor_animate()

	which will create, or update, an animation for the passed
	actor.

	* clutter/clutter-debug.h:
	* clutter/clutter-main.c: Add a new 'animation' debug note.

	* clutter/clutter-script.c: Clean up the alpha functions
	whitelist, and add the new functions.

	* doc/reference/clutter/Makefile.am:
	* doc/reference/clutter/clutter-sections.txt: Update the
	API reference.

	* doc/reference/clutter/clutter-animation.xml: Renamed to
	doc/reference/clutter/clutter-animation-tutorial.xml to
	avoid clashes with the ClutterAnimation section.

	* doc/reference/clutter/clutter-docs.sgml: Renamed to
	doc/reference/clutter/clutter-docs.xml, as it was an XML
	file and not a SGML file.

	* tests/Makefile.am:
	* tests/interactive/Makefile.am:
	* tests/interactive/test-animation.c:
	* tests/interactive/test-easing.c: Add two tests for the
	new simple animation API and the easing functions.

	* tests/interactive/test-actors.c:
	* tests/interactive/test-behave.c:
	* tests/interactive/test-depth.c:
	* tests/interactive/test-effects.c:
	* tests/interactive/test-layout.c:
	* tests/interactive/test-multistage.c:
	* tests/interactive/test-paint-wrapper.c:
	* tests/interactive/test-rotate.c:
	* tests/interactive/test-scale.c:
	* tests/interactive/test-texture-quality.c:
	* tests/interactive/test-threads.c:
	* tests/interactive/test-viewport.c: Update interactive tests
	to the deprecations and new alpha API.

2008-11-17  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-entry.c:
	* clutter/clutter-label.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-script.c:
	* clutter/clutter-stage.c: Use the ParamSpecColor and GValue
	API for ClutterColor-based properties.

2008-11-14  Robert Bragg  <ebassi@linux.intel.com>

	* tests/interactive/Makefile.am
	* tests/interactive/test-pixmap.c:
	test-pixmap + test-devices accidentally got dropped from the makefiles
	when changing the unit test layout; this puts them back.

2008-11-14  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1265 - ClutterScore doesn't emit 'started' signal (Bastian
	Winkler)

	* clutter/clutter-score.c: Emit the ::started signal.

	* tests/interactive/test-score.c: Check the emission of the
	Score signals.

2008-11-13  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-gles2-wrapper.c:
	Initialise the 'tex' sampler uniform to 0. The GLSL spec
	specifically says that you must initialize sampler uniforms. This
	fixes texturing for GLES 2 when using the PowerVR simulator via
	software Mesa.

2008-11-13  Robert Bragg  <robert@linux.intel.com>

	Gets the mesh API working with GLES2

	* clutter/cogl/common/cogl-mesh.c:
	Make sure we use the appropriate cogl_wrap_gl* funcs as appropriate

	* clutter/cogl/gles/cogl-gles2-wrapper.c
	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	In our glColorPointer wrapper we needed to mark our color attribute
	as normalized.

	* tests/conform/Makefile.am:
	When creating unit test symlinks we use the -l gtester option to
	list tests, but when using the PVR SDK the test binary also spews
	out some extra info that caused lots of random symlinks to be
	created. We now grep for lines starting with a '/'

	* tests/conform/test-mesh-contiguous.c
	* tests/conform/test-mesh-mutability.c:
	Use cogl_set_source_color instead of directly calling glColor4ub

2008-11-13  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-actor.c (clutter_actor_get_paint_visibility):
	Fix logic so that it won't return TRUE for a hidden stage.

2008-11-13  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-behaviour-ellipse.c:
	(clutter_behaviour_ellipse_applied): Do not reset the depth
	of the actors to which the Ellipse behaviour has been applied
	to, unless the behaviour is going to update it because it has
	a tilt on the X or Y axis.

2008-11-13  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-actor.c (clutter_actor_get_reactive)
	(clutter_actor_get_paint_visibility): Be sure to return exactly
	TRUE or FALSE instead of zero or some non-zero value in these
	functions that return a gboolean. Thanks to Kai Wei for spotting.

2008-11-12  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/conform/Makefile.am:
	* tests/conform/test-conform-main.c:
	* tests/conform/test-paint-opacity.c: Add test unit for label,
	rectangle and paint opacity.

2008-11-12  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/cogl/cogl-color.h:
	* clutter/cogl/cogl-path.h:
	* clutter/cogl/cogl-types.h:
	* clutter/cogl/common/cogl-color.c: Deprecated cogl_color()
	in favour of cogl_set_source_color() and friends; store the
	CoglColor components as unsigned bytes instead of fixed point
	normalized values; add functions for allocating, copying and
	freeing CoglColor, for use of language bindings.

	* clutter/cogl/cogl.h.in:
	* clutter/cogl/cogl-deprecated.h: Added cogl-deprecated.h,
	an header file containing the deprecation symbols similar
	to clutter-deprecated.h.

	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gl/cogl-texture.c:
	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/Makefile.am:
	* clutter/cogl/gles/cogl-texture.c:
	* clutter/cogl/gles/cogl.c: Update the GL and GLES implementations
	of COGL after the CoglColor changes.

	* clutter/clutter-actor.c:
	* clutter/clutter-clone-texture.c:
	* clutter/clutter-entry.c:
	* clutter/clutter-label.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-texture.c: Do not use CoglColor whenever it
	is possible, and use cogl_set_source_color4ub() instead.

	* clutter/pango/cogl-pango-render.c: Ditto as above.

	* doc/reference/clutter/subclassing-ClutterActor.xml:
	* doc/reference/cogl/cogl-sections.txt: Update the documentation.

	* tests/interactive/test-cogl-offscreen.c:
	* tests/interactive/test-cogl-primitives.c:
	* tests/interactive/test-cogl-tex-convert.c:
	* tests/interactive/test-cogl-tex-foreign.c:
	* tests/interactive/test-cogl-tex-getset.c:
	* tests/interactive/test-cogl-tex-polygon.c:
	* tests/interactive/test-cogl-tex-tile.c:
	* tests/interactive/test-paint-wrapper.c: Drop the usage of
	CoglColor whenever it is possible.

2008-11-12  Neil Roberts  <neil@linux.intel.com>

	Bug 1057 - cogl_texture_rectangle doesn't support backward
	coordinates

	* clutter/cogl/gl/cogl-texture.c: Instead of sorting the vertex
	and texture coordinates passed to cogl_texture_rectangle, just
	swap both sets whenever the texture coordinates are backward.

2008-11-12  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-rectangle.c (clutter_rectangle_paint): Fixed so
	that it doesn't use the alpha value from the border colour to draw
	the rectangle

2008-11-12  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gles/Makefile.am (libclutterinclude_HEADERS):
	* clutter/cogl/gl/Makefile.am (libclutterinclude_HEADERS):
	* clutter/cogl/common/Makefile.am
	(libclutter_cogl_common_la_SOURCES): Move cogl-mesh.h into the
	headers for libclutter so that it will get installed.

2008-11-12  Neil Roberts  <neil@linux.intel.com>

	Fix warnings in mesh tests

	* tests/conform/test-mesh-mutability.c (on_paint):
	* tests/conform/test-mesh-interleved.c (on_paint):
	* tests/conform/test-mesh-contiguous.c (on_paint): Use g_usleep
	instead of sleep

	* tests/conform/test-mesh-mutability.c (queue_redraw):
	* tests/conform/test-mesh-interleved.c (queue_redraw):
	* tests/conform/test-mesh-contiguous.c (queue_redraw): Added
	missing return statement

	* clutter/cogl/cogl-mesh.h: Add a declaration for
	cogl_mesh_submit

	* clutter/cogl/common/cogl-mesh.c (cogl_mesh_submit): Move the
	documentation to cogl-mesh.h to match the rest of the functions

2008-11-10  Robert Bragg  <robert@linux.intel.com>

	Bug 1164 - Implements the proposed Mesh API

	* clutter/cogl/cogl-mesh.h
	* clutter/cogl/cogl-types.h
	* clutter/cogl/cogl.h.in
	* clutter/cogl/common/Makefile.am
	* clutter/cogl/common/cogl-mesh-private.h
	* clutter/cogl/common/cogl-mesh.c
	* clutter/cogl/gl/cogl-context.c
	* clutter/cogl/gl/cogl-context.h
	* clutter/cogl/gl/cogl-defines.h.in
	* clutter/cogl/gl/cogl.c
	* clutter/cogl/gles/cogl-context.c
	* clutter/cogl/gles/cogl-context.h:
	The Mesh API provides a means for submitting an extensible number of
	per vertex attributes to OpenGL in a way that doesn't require format
	conversions and so that the data can be mapped into the GPU (in vertex
	buffer objects) for - hopefully - fast re-use.

	There are a number of things we can potentially use this API for, but
	right now this just provides a foundation to build on. Please read
	the extensive list of TODO items in cogl-mesh.c for examples.

	Please refer to the cogl-mesh section in the reference manual for
	documentation of the API.

	* tests/conform/Makefile.am
	* tests/conform/test-conform-main.c
	* tests/conform/test-mesh-contiguous.c
	* tests/conform/test-mesh-interleved.c
	* tests/conform/test-mesh-mutability.c:
	Privides basic coverage testing for the mesh API.

2008-11-10  Robert Bragg  <robert@linux.intel.com>

	Bug 1164 - Implements the proposed Mesh API

	* clutter/cogl/cogl-mesh.h
	* clutter/cogl/cogl-types.h
	* clutter/cogl/cogl.h.in
	* clutter/cogl/common/Makefile.am
	* clutter/cogl/common/cogl-mesh-private.h
	* clutter/cogl/common/cogl-mesh.c
	* clutter/cogl/gl/cogl-context.c
	* clutter/cogl/gl/cogl-context.h
	* clutter/cogl/gl/cogl-defines.h.in
	* clutter/cogl/gl/cogl.c
	* clutter/cogl/gles/cogl-context.c
	* clutter/cogl/gles/cogl-context.h:
	The Mesh API provides a means for submitting an extensible number of
	per vertex attributes to OpenGL in a way that doesn't require format
	conversions and so that the data can be mapped into the GPU (in vertex
	buffer objects) for - hopefully - fast re-use.

	There are a number of things we can potentially use this API for, but
	right now this just provides a foundation to build on. Please read
	the extensive list of TODO items in cogl-mesh.c for examples.

	Please refer to the cogl-mesh section in the reference manual for
	documentation of the API.

	* tests/conform/Makefile.am
	* tests/conform/test-conform-main.c
	* tests/conform/test-mesh-contiguous.c
	* tests/conform/test-mesh-interleved.c
	* tests/conform/test-mesh-mutability.c:
	Privides basic coverage testing for the mesh API.

2008-11-10  Robert Bragg  <robert@linux.intel.com>

	* tests/conform/ADDING_NEW_TESTS
	* tests/conform/test-conform-common.c
	* tests/conform/test-pick.c:
	Instead of using clutter_stage_new /clutter_actor_destroy as a way to
	avoid cascading side effects between unit tests, due to left over
	actors, we now destroy all children of the default stage between
	tests instead.

	* tests/conform/wrapper.sh:
	Adds a convenience note about how to run valgrind for an individual
	unit test

2008-11-10  Neil Roberts  <neil@linux.intel.com>

	* tests/interactive/test-main.c (main): Allow more than two
	arguments so that the remaining arguments can be passed to the
	test. This is needed for test-behave for example which can take a
	--path argument.

2008-11-10  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-texture.c: Remove an unused function.

2008-11-10  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/conform/test-label-cache.c:
	* tests/conform/test-pick.c:
	* tests/conform/test-timeline.c: Show all the output messages only
	if the test was done with the verbose flag turned on.

	* tests/interactive/test-main.c: Do not use the (gpointer*) cast,
	but use a temporary gpointer instead.

2008-11-10  Robert Bragg  <robert@linux.intel.com>

	* tests/conform/Makefile.am:
	* tests/conform/wrapper.sh:
	* tests/conform/test-conform-main.c:
	* tests/conform/test-timeline.c:
	Adds Neil's updates to test-timeline.c so it now works with the new
	unit testing infrastructure.

	Also some fixes to ensure wrappers get setup correctly for the
	timeline tests.

	* tests/interactive/test-main.c:
	cast the symbol return pointer as (gpointer *) to avoid warning

	* tests/conform/test-pick.c:
	g_assert that the test passes, instead of using exit()

	* test/conform/ADDING_NEW_TESTS:
	Fixes a silly typo

2008-11-08  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/conform/Makefile.am:
	* tests/conform/test-actor-invariants.c:
	* tests/conform/test-conform-main.c: Move the actor invariants
	unit to the conform section of the test suite.

	* tests/interactive/Makefile.am:
	* tests/interactive/test-entry-auto.c:
	* tests/interactive/test-invariants.c: Remove the entry-auto
	and invariants test, since those two belong to the conform
	section.

2008-11-07  Robert Bragg  <robert@linux.intel.com>

	Bug 1162 - Re-works the tests/ to use the glib-2.16 unit testing
	framework

	* configure.ac:
	* tests/*:
	The tests have been reorganised into different categories: conformance,
	interactive and micro benchmarks.
	- conformance tests can be run as part of automated tests
	- interactive tests are basically all the existing tests
	- micro benchmarks focus on a single performance metric

	I converted the timeline tests to conformance tests and also added some
	tests from Neil Roberts and Ebassi.

	Note: currently only the conformance tests use the glib test APIs,
	though the micro benchmarks should too.

	The other change is to make the unit tests link into monolithic binaries
	which makes the build time for unit tests considerably faster. To deal
	with the extra complexity this adds to debugging individual tests I
	have added some sugar to the makefiles so all the tests can be run
	directly via a symlink and when an individual test is run this way,
	then a note is printed to the terminal explaining exactly how that test
	may be debugged using GDB.

	There is a convenience make rule: 'make test-report', that will run all
	the conformance tests and hopefully even open the results in your web
	browser. It skips some of the slower timeline tests, but you can run
	those using 'make full-report'

2008-11-07  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-media.c: Improve documentation of the
	ClutterMedia interface.

2008-11-07  Matthew Allum  <mallum@linux.intel.com>

	Bug 1238 - [PATCH] Pack bitfields in ClutterTexturePrivate

	* clutter/clutter-texture.c:

	Using 'guint my_field : 1' for booleans to save space only
	makes sense if you group all such fields together. Fix
	grouping for ClutterTexturePrivate. Thanks to Owen Taylor for
	patch.

2008-11-07  Matthew Allum  <mallum@linux.intel.com>

       Bug 1237 - clutter_texture_set_filter_quality calls
	          clutter_texture_[un]realize

	* clutter/clutter-texture.c: (clutter_texture_set_filter_quality):
	Call clutter_actor_[un]realize and keep visibility state

2008-11-07  Matthew Allum  <mallum@linux.intel.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* clutter/clutter-clone-texture.c:
	* clutter/clutter-private.h:
	* clutter/clutter-texture.c:
	* clutter/x11/clutter-x11-texture-pixmap.c:

	Attempt to lower overhead of updating TFP's (particularly mipmaped).
	Compresses mipmap updates only for visible TFPs.
	Avoiding updates for non visible TFP's whilst keeping visible
	clones working ok.

2008-11-06  Neil Roberts  <neil@linux.intel.com>

	Bug 1230 - Pick fails on low precision color buffers

	* clutter/clutter-main.c (_clutter_id_to_color): When using fuzzy
	picking to pick a color for an actor, it would previously set the
	fuzzy bit and then all but the most significant of the remaining
	unused bits. This meant that for 16-bit displays it would end up
	with a strange pattern for the unused bits like 1011 which could
	cause it to round up. Now it just sets all but the most
	significant of all of the unused bits giving a pattern like
	0111. Thanks to Guy Zadickario for the patch.

2008-11-06  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gles/cogl.c (cogl_perspective):
	* clutter/cogl/common/cogl-fixed.c (cogl_fixed_sin)
	(cogl_angle_sin, cogl_angle_tan, cogl_fixed_sqrt): Replaced uses
	of 1 + ~x with just -x which is equivalent and easier to
	understand.

2008-11-06  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1233 - CLUTTER_ALPHA_SINE_INC is broken in trunk

	* clutter/clutter-alpha.c: Fix a rollover in the sine functions.

2008-11-05  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-color.c (clutter_color_new): Remove CLAMP macros
	around the component parameters because they are guint8 anyway so
	the CLAMP is redundant and it causes a warning.

2008-11-04  Thomas Wood  <thomas@linux.intel.com>

	* clutter/clutter-color.c: Update ClutterColor documentation as
	changes have been backported to 0.8.4.

2008-11-04  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-script.c: Document the "is-default" member of
	a ClutterStage definition.

2008-11-04  Neil Roberts  <neil@linux.intel.com>

	* clutter/cogl/gl/cogl.c (cogl_perspective): Use the accurate
	64-bit multiplication macro instead of COGL_FIXED_FAST_DIV for
	calculating xmax as was done previously. This fixes
	test-perspective and other tests that had a gone a bit skewiff.

2008-11-04  Neil Roberts  <neil@linux.intel.com>

	Bug 1181 - In Score, timelines, appended at markers, are also
	called on complete

	* clutter/clutter-score.c (start_children_entries): Use the name
	of the marker to start as the data parameter and only start child
	timelines that have the same marker name. Previously the
	ClutterScore would just start all child entries when a marker was
	reached or the timeline completed regardless of whether they were
	added with a marker or not. Thanks to Mihail Naydenov for
	reporting the bug.

2008-11-03  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/cogl/gl/Makefile.am: Whitespace fixes.

	* clutter/cogl/gles/Makefile.am: Put back a missing backslash
	that broke the GLES build.

2008-11-03  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1231 - Build fails in gles flavour in revision 3442

	* clutter/cogl/gles/cogl-context.h: Fix remaining use of
	ClutterFixed over CoglFixed. (Michael Boccara)

2008-11-03  Neil Roberts  <neil@linux.intel.com>

	Bug 1207 - Timelines sometime miss markers

	* clutter/clutter-timeline.c (timeline_timeout_func): Move the
	code for firing the new-frame and marker-reached signals into a
	separate static function so that it can also be called when the
	last frame is reached. Also fix an issue where the frame numbers
	were changed in the wrong direction when detecting missed markers
	in a reversed timeline. Based on a patch by Michael Boccara.

	* tests/test-timeline.c: Now tries to automatically verify whether
	the test worked by keeping track of all the signal emissions. The
	timelines are run a second time with an extra timeout that causes
	delays to simulate skipped frames.

2008-10-31  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/pango/cogl-pango-fontmap.c:
	* clutter/pango/cogl-pango-render.c: Whitespace fixes and code
	duplication removal. Plus, start documenting the CoglPango API.

2008-10-31  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c: (clutter_texture_set_filter_quality),
	(clutter_texture_get_filter_quality):
	Fix up some logic, typos.

	* clutter/glx/clutter-glx-texture-pixmap.c:
	Improve support for mipmaped TFP textures.

2008-10-31  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1200 - Crash with invalid DISPLAY

	* clutter/clutter-main.c: Use the ClutterBackend wrapper API
	instead of directly checking the class structure.

	* clutter/glx/clutter-backend-glx.c: Return the correct value
	in case of failure.

	* clutter/x11/clutter-backend-x11.c: Bail out if XOpenDisplay()
	failed.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/cogl/cogl-color.h:
	* clutter/cogl/cogl-fixed.h:
	* clutter/cogl/cogl-offscreen.h:
	* clutter/cogl/cogl-path.h:
	* clutter/cogl/cogl-shader.h:
	* clutter/cogl/cogl-texture.h:
	* clutter/cogl/cogl-types.h: Add copyright and licensing
	notice to the newly added files.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1219 - Clean up cogl.h

	* clutter/cogl/cogl.h.in:
	* clutter/cogl/cogl-offscreen.h:
	* clutter/cogl/cogl-path.h:
	* clutter/cogl/cogl-shader.h:
	* clutter/cogl/cogl-texture.h:
	* clutter/cogl/cogl-types.h: Split up the massive cogl.h file
	into sub-header for each section of the API.

	* clutter/cogl/gl/*:
	* clutter/cogl/gles/*: Update the GL and GLES implementations
	of COGL to cope with the new header structure.

	* doc/reference/cogl/Makefile.am: Fix symbol retrieval.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1215 - Move the Pango renderer to the public API

	* clutter/pango/*: Rename PangoClutter -> CoglPango.

	* clutter/Makefile.am:
	* clutter/clutter-backend.c:
	* clutter/clutter-entry.c:
	* clutter/clutter-label.c:
	* clutter/clutter-main.[ch]:
	* clutter/clutter-private.h: Update the users of the Pango
	renderer API.

	* README: Update release notes.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1212 - Allow only a single include file for Clutter

	* clutter/*.h: Only allow including clutter.h in third
	party code.

	* clutter/cogl/cogl-color.h:
	* clutter/cogl/cogl-fixed.h:
	* clutter/cogl/cogl.h.in: Only allow including cogl.h in
	third party code.

	* clutter/cogl/common/Makefile.am:
	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gles/Makefile.am:
	* clutter/eglnative/Makefile.am:
	* clutter/eglx/Makefile.am:
	* clutter/fruity/Makefile.am:
	* clutter/glx/Makefile.am:
	* clutter/glx/clutter-glx.h:
	* clutter/osx/Makefile.am:
	* clutter/pango/Makefile.am:
	* clutter/sdl/Makefile.am:
	* clutter/win32/Makefile.am:
	* clutter/x11/Makefile.am: Fix build environment.

	* clutter/x11/clutter-x11-texture-pixmap.h:
	* clutter/x11/clutter-x11.h: Fix inclusion rules.

	* tests/test-pixmap.c: Fix inclusion of GdkPixbuf header.

	* README: Update release notes.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1211 - Drop ClutterFeatureFlags usage from COGL

	* clutter/cogl/cogl.h.in:
	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/cogl.c: Do not use ClutterFeatureFlags
	when CoglFeatureFlags will do. This removes the last usage
	of Clutter API inside COGL.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1210 - Add CoglColor API

	* clutter/cogl/cogl-color.h:
	* clutter/cogl/cogl.h.in:
	* clutter/cogl/common/Makefile.am:
	* clutter/cogl/common/cogl-color.c:
	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/Makefile.am:
	* clutter/cogl/gles/cogl-texture.c:
	* clutter/cogl/gles/cogl.c: Add a new color-type, to be used by
	COGL. CoglColor is optimized to allow the minimum amount of
	conversions possible for both GL and GLES implementations.

	* clutter/clutter-actor.c:
	* clutter/clutter-clone-texture.c:
	* clutter/clutter-entry.c:
	* clutter/clutter-main.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-stage.c:
	* clutter/clutter-texture.c: Use CoglColor when needed.

	* clutter/pango/pangoclutter-render.c: Use CoglColor when needed.

	* doc/reference/cogl/cogl-docs.sgml:
	* doc/reference/cogl/cogl-sections.txt: Update the documentation.

	* tests/test-cogl-offscreen.c:
	* tests/test-cogl-primitives.c:
	* tests/test-cogl-tex-convert.c:
	* tests/test-cogl-tex-foreign.c:
	* tests/test-cogl-tex-getset.c:
	* tests/test-cogl-tex-polygon.c:
	* tests/test-cogl-tex-tile.c:
	* tests/test-paint-wrapper.c: Update the tests.

	* README: Update release notes.

2008-10-30  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1209 - Move fixed point API in COGL

	* clutter/cogl/cogl-fixed.h:
	* clutter/cogl/cogl.h.in:
	* clutter/cogl/common/Makefile.am:
	* clutter/cogl/common/cogl-fixed.c: Add fixed point API, modelled
	after the ClutterFixed. The CoglFixed API supercedes the ClutterFixed
	one and avoids the dependency of COGL on Clutter's own API.

	* clutter/cogl/common/cogl-clip-stack.c:
	* clutter/cogl/common/cogl-primitives.c:
	* clutter/cogl/common/cogl-primitives.h: Update internal usage of
	ClutterFixed to CoglFixed.

	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gl/cogl-texture.c:
	* clutter/cogl/gl/cogl.c: Ditto, in the GL implementation of the
	COGL API.

	* clutter/cogl/gles/Makefile.am:
	* clutter/cogl/gles/cogl-fbo.c:
	* clutter/cogl/gles/cogl-gles2-wrapper.c:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/gles/cogl-texture.c:
	* clutter/cogl/gles/cogl.c: Ditto, in the GLES implementation of
	the COGL API.

	* clutter/pango/pangoclutter-glyph-cache.c:
	* clutter/pango/pangoclutter-glyph-cache.h: Ditto, in the Pango
	renderer glyphs cache.

	* clutter/clutter-fixed.c:
	* clutter/clutter-fixed.h: ClutterFixed and related API becomes
	a simple transition API for bindings and public Clutter API.

	* clutter/clutter-actor.c:
	* clutter/clutter-alpha.c:
	* clutter/clutter-backend.c:
	* clutter/clutter-behaviour-depth.c:
	* clutter/clutter-behaviour-ellipse.c:
	* clutter/clutter-behaviour-path.c:
	* clutter/clutter-behaviour-rotate.c:
	* clutter/clutter-behaviour-scale.c:
	* clutter/clutter-clone-texture.c:
	* clutter/clutter-color.c:
	* clutter/clutter-entry.c:
	* clutter/clutter-stage.c:
	* clutter/clutter-texture.c:
	* clutter/clutter-timeline.c:
	* clutter/clutter-units.h: Move from the internal usage of
	ClutterFixed to CoglFixed.

	* doc/reference/clutter/clutter-sections.txt:
	* doc/reference/cogl/cogl-docs.sgml:
	* doc/reference/cogl/cogl-sections.txt: Update the documentation.

	* tests/test-cogl-tex-tile.c:
	* tests/test-project.c: Fix tests after the API change

	* README: Add release notes.

2008-10-29  Neil Roberts  <neil@linux.intel.com>

	Bug 1074 - FBOs on GLES

	* clutter/cogl/gles/cogl-fbo.c: Copy the code from gl/cogl-fbo but
	use the API calls directly instead of loading an extension because
	it is part of the core in GLES 2.

	* clutter/cogl/gles/cogl.c (_cogl_features_init): Report
	COGL_FEATURE_OFFSCREEN.

	* clutter/cogl/gles/cogl-fbo.h (CoglFbo): Add gl_stencil_handle.

	* clutter/cogl/gles/cogl-context.h (CoglContext): Add
	viewport_store

	* tests/test-fbo.c (make_shader): Conditionally use the GLES 2
	names of the shader variables

2008-10-29  Neil Roberts  <neil@linux.intel.com>

	Bug 1206 - Picking disabled dithering

	* clutter/clutter-main.c (_clutter_do_pick): After picking is
	finished, restore the state of glEnable (GL_DITHER). Otherwise it
	will cause the scene to look different after the first pick on low
	depth displays. (Thanks to Michael Boccara for the patch)

2008-10-28  Thomas Wood  <thomas@linux.intel.com>

	* clutter/clutter-color.c (param_color_set_default): Set the no copy
	flag when setting the default param spec value to prevent invalid
	frees.

2008-10-27  Neil Roberts  <neil@linux.intel.com>

	Bug 1189 - Backface culling

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_polygon)
	(_cogl_texture_quad_sw, _cogl_texture_quad_hw):
	* clutter/cogl/gles/cogl-texture.c (cogl_texture_polygon)
	(_cogl_texture_quad_sw, _cogl_texture_quad_hw): Enable backface
	culling in GL if it is requested.

	* clutter/cogl/gles/cogl-texture.c (_cogl_texture_quad_sw)
	(_cogl_texture_quad_hw):
	* clutter/cogl/gl/cogl-texture.c (_cogl_texture_quad_sw)
	(_cogl_texture_quad_hw): Reorder the
	vertices so that they are counter-clockwise.

	* clutter/cogl/gles/cogl-context.h (CoglContext):
	* clutter/cogl/gl/cogl-context.h (CoglContext): Added a flag to
	store whether backface culling is currently enabled.

	* clutter/cogl/gles/cogl.c (cogl_enable_backface_culling):
	* clutter/cogl/gl/cogl.c (cogl_enable_backface_culling): New
	function

	* doc/reference/cogl/cogl-sections.txt: Add
	cogl_enable_backface_culling

2008-10-27  Neil Roberts  <neil@linux.intel.com>

	Bug 1196 - Texture border drawing problems

	* clutter/cogl/gl/cogl-texture.c (_cogl_texture_upload_subregion_to_gl)
	(_cogl_texture_upload_to_gl):

	* clutter/cogl/gles/cogl-texture.c (_cogl_texture_upload_to_gl)
	(_cogl_texture_upload_subregion_to_gl):

	When uploading data to a sliced texture, fill the waste pixels
	with copies of the edge of the real texture data. Otherwise the
	value of the waste pixels are undefined so it will show artifacts
	when the texture is scaled with GL_LINEAR and the pixels are
	blended in.

2008-10-22  Thomas Wood  <thomas@linux.intel.com>

	* tests/test-actors.c: Don't adjust the radius based on the number of
	actors

2008-10-21  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-color.[ch] (clutter_value_set_color): Constify
	colors and values where needed.

2008-10-21  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1197 - Missing const for clutter_init_with_args *

	* clutter/clutter-main.[ch] (clutter_init_with_args): Constify
	the string parameters. (Owen Taylor)

2008-10-20  Emmanuele Bassi  <ebassi@linux.intel.com>

	* configure.ac: Use gmodule-no-export-2.0, not gmodule-2.0,
	to avoid breaking the symbol hiding. (thanks to Ross Burton
	and Laurent Bigonville)

2008-10-20  Neil Roberts  <neil@linux.intel.com>

	Bug 1043 - COGL calls glTexSubImage2D() with out-of-bounds
	values (SIGSEGV)

	* clutter/cogl/gl/cogl-texture.c
	(_cogl_texture_upload_subregion_to_gl): When iterating over the
	slices, discard ones that don't intersect immediatly otherwise it
	will call glTexSubImage2D with a negative width/height and then
	move the source position incorrectly. Thanks to Gwenole
	Beauchesne.

2008-10-20  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-color.h: Declare clutter_color_new() in the
	installed header.

2008-10-20  Neil Roberts  <neil@linux.intel.com>

	Bug 1195 - ClutterBehaviourBspline only works for very short paths

	* clutter/clutter-behaviour-bspline.c: Changed the CBZ_T_POW3 and
	CBZ_T_MUL functions so that they preserve more of the least
	significant bits. This fixes some of the jaggy behaviour with
	longer paths.

2008-10-17  Thomas Wood  <thomas@linux.intel.com>

	reviewed by: Emmanuele Bassi <ebassi@linux.intel.com>

	* clutter/clutter-color.[ch]: Add GParamSpec and GValue integration
	for ClutterColor. With ClutterParamSpecColor it is possible to define
	color properties; with the GValue integration it's possible to
	automatically transform strings into colors and vice versa.

	(clutter_color_free): Allow NULL parameter to match other boxed
	types destructors.

	(clutter_color_new): Add a constructor for the ClutterColor boxed
	type, mostly for bindings.

2008-10-17  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-color.c (clutter_color_parse): Add checks
	for the arguments, to avoid trying to parse NULL strings.

2008-10-16  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-container.[ch]: Add checks to the Container
	interface invocation methods, to avoid crashing or corrupting
	the stack when an actor does not implement every virtual
	function of the Container interface vtable. GObject allows this
	to happen so we must handle the case gracefully. This also means
	that we can classify some virtual function as mandatory (as is
	the case for ::add, ::remove and ::foreach) and some other
	optional.

2008-10-08  Emmanuele Bassi  <ebassi@linux.intel.com>

	* tests/test-depth.c (raise_top), (main): Fix a shadowing
	with raise() from signal.h.

2008-10-01  Øyvind Kolås  <pippin@linux.intel.com>

	Bug 1108 - Enter/Leave events logics wrt. skipped motion events

	Handle dropped motion events when computing crossing events,
	based on a patch from Gwenole Beauchesne.

	* clutter/clutter-main.c: (clutter_event_get_device): internal static
	utility function.
	(clutter_do_event): generate enter/leave events for all pointer
	events.
	(generate_enter_leave_events): modified enter/leave events generator
	to work for all pointer event types. Enter/leave events are now
	delivered before the motion/button event that caused the crossing to
	happen.
	* clutter/clutter-event.c: (clutter_event_copy), (clutter_event_free):
	removed reference counting logic that is not needed when the crossing
	events are directly delivered.

2008-09-29  Emmanuele Bassi  <ebassi@linux.intel.com>

	* configure.ac: Post branch bump to 0.9.0

2008-09-25  Emmanuele Bassi  <ebassi@linux.intel.com>

	* configure.ac: Post release bump to 0.8.3

======== Release 0.8.2 ========================================================

2008-09-25  Emmanuele Bassi  <ebassi@linux.intel.com>

	* configure.ac:
	* README:
	* NEWS: Release 0.8.2

2008-09-25  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-event.h: Fix missing documentation.

2008-09-24  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1130 - CLUTTER_MOTION is not emitted when time goes backwards.

	* clutter/clutter-main.c (clutter_do_event): Check for time
	rollbacks inside the motion event throttling. (Pierce Liu)

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-timeout-pool.c: Reword previous commit.

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-timeout-pool.c:
	(clutter_timeout_pool_new): Fix previous commit: g_source_unref()
	is not needed. (Thanks to Neil Roberts)

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1154 - clutter_timeout_pool_new() documentation doesn't say
	how to free

	* clutter/clutter-timeout-pool.c: Update the documentation to
	note that you must use g_source_unref() to free the timeout
	pool. (Murray Cumming)

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1124 - Clutter causes an additional size request in each
	allocation

	* clutter/clutter-actor.c:
	(clutter_actor_store_old_geometry): Store the allocation instead
	of causing a new size-request cycle. (Johan Bilien)

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1125 - Save an extra pango_layout_get_size in many cases

	* clutter/clutter-label.c:
	(clutter_label_create_layout_no_cache): Add a simple check
	before calling pango_layout_get_size(). (Johan Bilien)

2008-09-23  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-alpha.c:
	(clutter_alpha_get_alpha): Do not return the cached value but
	just compute the current alpha value. The use case is pretty
	much straightforward: stop a timeline, advance it, and retrieve
	the alpha value before starting the timeline to adjust an
	animation dependent on the alpha. Caching the alpha value is
	not needed because the behaviours will always pass the alpha
	value inside the ::alpha-notify virtual function anyway, so
	there is no need for them to call clutter_alpha_get_alpha().

	This change makes it also possible to reliably unit-test
	ClutterAlpha.

	(timeline_new_frame_cb): Call clutter_alpha_get_alpha().

2008-09-23  Tomas Frydrych  <tf@linux.intel.com>

	* clutter/clutter-main.c:
	* clutter/clutter-main.h:
	* clutter/clutter-private.h:
	* clutter/x11/clutter-backend-x11.c:
	(clutter_get_option_group_without_init):
	Function to obtain clutter option group without opening display
	(for use with foreign display and gtk_clutter_init). Bug 1033.

	Stripped trailing whitespace.

2008-09-22  Neil Roberts  <neil@linux.intel.com>

	Bug 856 - Teardown sequence is borked

	* clutter/clutter-main.c: Don't free the ClutterMainContext so
	that the main loop can be restarted.

	* clutter/eglx/clutter-backend-egl.c:
	* clutter/eglnative/clutter-backend-egl.c: Register an atexit
	handler which disposes the backend object so that we are still
	guaranteed to call eglTerminate on GLES.

2008-09-22  Neil Roberts  <neil@linux.intel.com>

	* tests/test-unproject.c (on_event):
	* tests/test-project.c (on_event): Use a return value for the
	'event' signal handler, otherwise it might accidentally return
	TRUE for unhandled events and you won't be able to close the
	window.

2008-09-19  Emmanuele Bassi  <ebassi@linux.intel.com>

	Bug 1033 - Manually parsing command line options prevents
	initializing clutter

	* clutter/clutter-main.c:
	(post_parse_hook), (clutter_init_with_args),
	(clutter_parse_args), (clutter_init): Move the initialization
	of Clutter at the end of the post-parse hook of Clutter's
	GOptionGroup. Clutter must be initialized at the end of the
	argument parsing.

2008-09-19  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/clutter-main.c: Properly document the
	clutter_get_option_group() function and the invariant that
	after parsing Clutter's option group the library will be
	initialized. (Thanks to Tomas Frydrych for pointing this
	out)

2008-09-19  Emmanuele Bassi  <ebassi@linux.intel.com>

	* clutter/x11/clutter-backend-x11.c: Properly document the
	usage of clutter_x11_set_display().

	* clutter/x11/clutter-x11.h: clutter_x11_set_display() is
	public API and should be declared in the header we install.

2008-09-18  Neil Roberts  <neil@linux.intel.com>

	Bug 1048 - SIGFPE in cogl_texture_set_region() with nvidia

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_set_region):
	* clutter/cogl/gles/cogl-texture.c (cogl_texture_set_region):
	Don't attempt to upload any data if the width or height of the
	subregion is zero. Thanks to Gwenole Beauchesne.

2008-09-18  Neil Roberts  <neil@linux.intel.com>

	Bug 1044 - cogl_get_viewport error

	* clutter/cogl/gles/cogl.c (cogl_get_viewport): Use glGetIntegerv
	instead of glGetFixedv to read the viewport because the latter
	converts incorrectly on some hardware.

2008-09-18  Neil Roberts  <neil@linux.intel.com>

	Bug 1080 - clutter_stage_read_pixels has upside-down y coordinate

	* clutter/clutter-stage.c (clutter_stage_read_pixels): Use
	OpenGL's coordinate system for the arguments to glReadPixels (so
	that y zero is the bottom of the window). Use clutter_redraw
	instead of clutter_stage_paint to ensure the right GL context is
	selected. Set some of the glPixelStore parameters that might have
	been changed by Cogl.

	* tests/test-stage-read-pixels.c: Replace with a different test
	that gets a sub-region of the stage around the cursor.

2008-09-17  Neil Roberts  <neil@linux.intel.com>

	Bug 1145 - Flicker on resize the window

	* clutter/glx/clutter-stage-glx.c (clutter_stage_glx_realize):
	Don't set a backing pixel on the X window. Otherwise when the
	window resizes it will flicker when X paints the background
	immediatly before Clutter repaints the whole stage.

2008-09-17  Neil Roberts  <neil@linux.intel.com>

	* clutter/clutter-types.h: Swap left and right in the
	documentation for ClutterGravity.

2008-09-17  Neil Roberts  <neil@linux.intel.com>

	Bug 1121 - Setting anchor point doesn't work if set too early

	* clutter/clutter-actor.c
	(clutter_actor_set_anchor_point_from_gravity)
	(clutter_actor_move_anchor_point_from_gravity): Add documentation
	to make it clear that the anchor point won't move when the actor
	is resized.

2008-09-16  Neil Roberts  <neil@linux.intel.com>

	Bug 1100 - WM_SIZE not handled correctly, user_resize and
	window_style correction.

	* clutter/win32/clutter-stage-win32.c (get_window_style): Remove
	the WS_MAXIMIZEBOX style if the stage isn't resizable.
	(clutter_stage_win32_set_user_resize): Queue a redraw of the
	window frame when the user_resize property is changed.

	* clutter/win32/clutter-event-win32.c (message_translate): Don't
	update the size of the stage when handling WM_SIZE messages that
	result from the stage being minimized. Thanks to Roman Yazmin.

2008-09-16  Tomas Frydrych  <tf@linux.intel.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	TFP resyncing on MapNotify/ConfigureNotify (bug  1020; patch by
	Andy Wingo <wingo@pobox.com>).

2008-09-15  Øyvind Kolås  <pippin@linux.intel.com>

	* clutter/clutter-main.c: amended typo in gtk-doc.

2008-09-12  Neil Roberts  <neil@linux.intel.com>

	Bug 1034 - Picking doesn't work on Eee PC

	* clutter/clutter-main.c (_clutter_id_to_color): When choosing a
	pick color, set all but the most significant of the unused
	bits. This should make make it more likely that the GL
	implementation will round down to the right value.

	* tests/test-pick.c: Test case for picking. It creates 192 actors
	at known positions and stores their gids. It then calls
	clutter_stage_get_actor_at_pos with each position to check that
	the right gid is returned.

	* tests/Makefile.am (noinst_PROGRAMS): Add test-pick

2008-09-12  Neil Roberts  <neil@linux.intel.com>

	Bug 1010 - ClutterLabel does not update the layout (again)

	* clutter/clutter-label.c: Bring back layout caching. This time it
	will cache up to three different layouts. The width for which each
	layout was generated is stored so that if the same width is
	requested again it can use the cached version. If no cached
	version is available it will try to replace the oldest
	layout. 'Age' is determined by a counter which is incremented
	every time a layout is created. The cache is cleared after any
	property changes that might affect the layout.
	(struct _ClutterLabelPrivate): Removed extents_width,
	extents_height and context because they weren't used anywhere.

	* tests/test-label-cache.c: Add a test which checks whether the
	label is using a different layout when properties are
	changed. Also compares the extents of the label's layout with an
	independent layout and fails if they aren't the same.

	* tests/Makefile.am (noinst_PROGRAMS): Add test-label-cache

2008-09-10  Neil Roberts  <neil@o-hand.com>

	Bug 1137 - Setting the anchor point does not trigger a re-paint

	* clutter/clutter-actor.c (clutter_actor_set_property): When
	changing the anchor point properties, use set_anchor_pointu
	instead of changing the value directly so that a redraw will be
	queued.
	(clutter_actor_set_anchor_pointu): Queue a redraw when the anchor
	point is changed. Thanks to Johan Bilien.

2008-08-27  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1082 - Texture bitmap is destroyed in wrong way

	* clutter/cogl/common/cogl-bitmap-pixbuf.c:
	(_cogl_bitmap_from_file): Make a copy of the pixbuf data in
	the internal image loader so that we can keep working under
	the assumption that we are using the GLib memory allocation
	and deallocation functions.

2008-08-27  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1099 - No ClutterScript API to get a list of IDs in a given file

	* clutter/clutter-script.[ch]: Add clutter_script_list_objects(),
	a function for retrieving all the objects built by a ClutterScript
	instance. (Based on a patch by Noah Gibbs)

2008-08-26  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1090 - Label somtimes returns natural_width < min_width

	* clutter/clutter-label.c:
	(clutter_label_get_preferred_width): Check that the width of the
	layout is always greater than 0. (Johan Bilien)

2008-08-19  Neil Roberts  <neil@o-hand.com>

	Bug 1103 - Two typos in clutter documentation

	* doc/reference/clutter/subclassing-ClutterActor.xml: Update the
	custom actor example since the Cogl API was changed to namespace
	all of the path related functions in cogl_path_*. Thanks to Nati
	Berkover.

	* clutter/clutter-score.c: Add missing parameter in example of
	calling clutter_score_start().

2008-08-18  Neil Roberts  <neil@o-hand.com>

	Bug 1085 - Cursor is in wrong position on ClutterEntry if set
	x-align property

	* clutter/clutter-entry.c (clutter_entry_paint): When calculating
	the position to draw the cursor at, take into account the
	alignment of the text. Queue a redraw when the x-align property is
	changed.

2008-08-07  Neil Roberts  <neil@o-hand.com>

	Bug 1091 - WM_MOUSEWHEEL (scroll-event) not handled correctlly

	* clutter/win32/clutter-event-win32.c (message_translate): The
	coordinates in a WM_MOUSEWEEL message are given relative to the
	screen so they need to be converted to client coordinates before
	use. Thanks to Roman Yazmin.

2008-08-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-child-meta.c:
	(clutter_child_meta_set_property),
	(clutter_child_meta_class_init): Make the :container and
	:actor properties of ChildMeta construct-only, to allow
	bindings to actually use ChildMeta without abusing the API.

	* clutter/clutter-container.c (create_child_meta): Instead of
	setting the members of the ChildMeta structure, use the
	constructor properties.

2008-08-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-keysyms.h: Resync with keysymdef.h inside Xorg.

2008-08-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script.c:
	(clutter_script_default_connect): Improve wording and debug
	messages in the default autoconnection for signal handlers.

2008-08-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script-parser.c:
	* clutter/clutter-script-private.h: Clean up the code; add a
	conversion function for reading a ClutterColor out of a
	JSON object or array definition.

	* clutter/clutter-script.c: Clean up the code; document properly
	how we translate from type name to type function.

2008-08-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c: Rework and improve the documentation
	of the thread-safe timeout and idle source installer functions.

2008-08-01  Neil Roberts  <neil@o-hand.com>

	Bug 945 - Clipping+fbo cloning bugs

	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/cogl.c:
	* clutter/cogl/cogl.h.in: Add cogl_clip_stack_save,
	cogl_clip_stack_restore, cogl_viewport and cogl_frustum.

	* clutter/cogl/gl/cogl-fbo.h:
	* clutter/cogl/gl/cogl-fbo.c: Try to attach a stencil buffer when
	creating an FBO.

	* clutter/cogl/common/cogl-clip-stack.c: Add functions to save and
	restore the whole state of the stack.

	* clutter/clutter-texture.c (clutter_texture_paint): When
	rendering the FBO source, setup a temporary asymmetric perspective
	projection matrix to render it as it would appear on screen.

	* clutter/clutter-private.h:
	* clutter/clutter-actor.c
	(_clutter_actor_apply_modelview_transform_recursive): No longer
	static and exported in clutter-private.h

2008-08-01  Neil Roberts  <neil@o-hand.com>

	Bug 1071 - clutter_timeline_get_duration doesn't always work

	* clutter/clutter-timeline.c: Calculate the 'duration' property
	on-demand instead of storing it as a member variable. Notify
	duration property changes whenever the fps or num_frames changes.

2008-08-01  Neil Roberts  <neil@o-hand.com>

	Bug 1069 - Warnings with ClutterScore

	* clutter/clutter-score.c (clutter_score_is_playing): Check
	whether priv->running_timelines is NULL before checking its
	length.
	(foreach_running_timeline): Remove the completed signal handler
	when stopping the score. Otherwise the completed callback will get
	called multiple times if the timeline is started later.

2008-07-31  Neil Roberts  <neil@o-hand.com>

	Bug 1075 - Difficult to bind clutter_stage_new

	* clutter/clutter-stage.c (clutter_stage_dispose): Unrealize the
	stage before removing the update idle handler. Otherwise
	unrealizing causes another redraw to be queued and if the stage
	object remains alive it will cause an assert and abort.

2008-07-30  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-stage.c (clutter_stage_class_init): Added the
	'perspective' property. All of the machinery was there to
	implement the property but somehow the call that actually installs
	it was missing.

2008-07-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-fixed.h:
	* clutter/clutter-units.h: Fix the upper and lower boundaries of
	ClutterFixed and ClutterUnit types; G_MAXINT16 and G_MININT16
	were not enough to describe those values.

2008-07-30  Ross Burton  <ross@openedhand.com>

	* clutter/clutter-main.c:
	Destroy the debugging timer when the context is freed.

	* clutter/clutter-stage.c:
	Free the stage title when the stage is finalized.

2008-07-30  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-model.c (clutter_model_set_sorting_column): This
	function is supposed to accept -1 to disable sorting. However it
	checks for whether the column is >= the number of columns, but
	clutter_model_get_n_columns() returns an unsigned int so the
	column number also gets promoted to unsigned for the
	comparison. Therefore -1 is always greater than the number of
	columns so it wouldn't let you set it.

2008-07-26  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-timeline.c (clutter_timeline_list_markers): When
	requesting the list of markers it was returning the marker data as
	a string instead of the name so it was copying garbage.

2008-07-25  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c (clutter_actor_remove_clip)
	(clutter_actor_set_clipu): Queue a redraw when the clip is
	changed.

2008-07-24  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-script.c: The example in the documentation
	showed a color being specified as '0xff0000ff' but it should be
	'#ff0000ff'

2008-07-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1062 - clutter_actor_query_coords() replacement in 0.8

	* clutter/clutter-deprecated.h: Fix the deprecation warning
	for clutter_actor_query_coords(). (Gwenole Beauchesne)

2008-07-17  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1047 -  API documentation from release tarball is not
		    installed by "make install"

	* configure.ac:
	* Makefile.am: Make the recursion into the documentation
	directory depend on on whether we explicitly enable it or
	if we are not inside an SVN checkout.

2008-07-17  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-texture.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-group.c:
	* clutter/clutter-entry.c:
	* clutter/clutter-clone-texture.c: Remove unnecessary calls to
	cogl_{push,pop}_matrix. The matrix is preserved in
	clutter_actor_paint whenever the actor's transformation is applied
	so there should be no need to push the matrix in actor paint
	implementations unless it does some additional transformations
	itself.

2008-07-16  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.pc.in: Add a variable containing the COGL backend
	inside the pkg-config file, for configure-time checks.

2008-07-14  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/common/cogl-primitives.c (cogl_path_rel_curve_to):
	Fixed a typo in the second parameter which meant the curve was
	drawn incorrectly.

2008-07-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter.h: Include missing installed files.

2008-07-14  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-stage.c:
	(clutter_stage_hide_cursor):
	Fixed C&P bug that made it impossible to show cursor once hidden.

	Stripped trailing whitespace.

2008-07-13  Matthew Allum  <mallum@openedhand.com>

	* clutter/x11/clutter-x11-texture-pixmap.c:
	Call XSync in unredirect X error trap (Thanks to Andy Wingo)

2008-07-13  Neil Roberts  <neil@o-hand.com>

	* build/mingw/mingw-cross-compile.sh: Avoid using the --strip
	option to tar because it isn't supported in the version shipped
	with MSYS.

2008-07-11  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.c:
	Move G_IMPLEMENT_INLINES before all other #include statements (bug
	#1038).

2008-07-11  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.c:
	Changed #define G_IMPLEMENTS_INLINES to G_IMPLEMENT_INLINES (bug
	#1038).

2008-07-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.3.1.

======== Release 0.8.0 ========================================================

2008-07-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* NEWS: Release 0.8.0.

2008-07-10  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gles/cogl-fbo.c:
	* clutter/cogl/gles/cogl-texture.c:
	Fix warnings with eglnative build

2008-07-10  Matthew Allum  <mallum@openedhand.com>

	* README:
	Sync up/improve ready for 0.8 release.

	* AUTHORS:
	Sync up to date - hope I havn't missed anyone..

2008-07-10  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	Assume TFP npots sized textures are always supported if TFP ext is!
	(Based on patch from James Ketrenos)

2008-07-08  Matthew Allum  <mallum@openedhand.com>

	Bug 1011 - Fix TFP fallback mechanism (take 2)

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* tests/test-pixmap.c:
	Slightly modified patch from Gwenole Beauchesne applied
	to better handle both falling back to non accelerated tfp
	and improvements to the test case.

2008-07-07  Matthew Allum  <mallum@openedhand.com>

	Bug 1016 - Changing window-redirect-automatic property after
		   creating ClutterX11TexturePixmap doesn't work.

	* clutter/x11/clutter-x11-texture-pixmap.c:
	(clutter_x11_texture_pixmap_set_window):
	Sync up redirection prop correctly (Jason Tackaberry)

2008-07-07  Matthew Allum  <mallum@openedhand.com>

	Bug 1019 - clutter-frame-source.h not included by clutter.h

	* clutter/clutter.h:
	Add missing header include.

2008-07-05  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.h: Remove redundant duplicate declaration
	of clutter_actor_allocate_preferred_size

2008-07-05  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1033 - Manually parsing command line options prevents
		   initializing clutter (Armin Burgmeier)

	* clutter/clutter-main.c:
	(post_parse_hook), (clutter_init_real): Set the is_initialized
	flag inside the real initialization function.

2008-07-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c: Properly document the behaviour
	of the :alignment property.

2008-07-04  Neil Roberts  <neil@o-hand.com>

	* build/mingw/mingw-cross-compile.sh: Default to the win32 flavour
	instead of the SDL flavour

2008-07-04  Neil Roberts  <neil@o-hand.com>

	Bug 1015 - Cloning unparented actors with FBOs doesn't work with
	new layout code

	* clutter/clutter-texture.c (clutter_texture_new_from_actor): Now
	parents the source actor if it doesn't already have a parent so
	that it will get an allocation during layout.

	* tests/test-fbo.c: One of the tests tries to ensure that the
	ClutterTexture clone keeps the source actor alive by derefing
	it. However as actors have a floating reference then test-fbo
	doesn't have its own reference once the source is parented so
	unrefing just steals the parent's reference and causes
	badness. The test now claims the floating reference before cloning
	the source so that it can safely be unref'd later.

2008-07-03  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/Makefile.am: Fix distchecking by adding the
	generated enum types files to DISTCLEANFILES.

2008-07-03  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.h:
	* clutter/clutter-fixed.c
	Fixed inlining of clutter_qmulx() and clutter_qdivx() (bug 1022).

2008-07-03  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-shader.c (bind_glsl_shader): Fix a cut-and-paste
	error which broke vertex shaders

2008-07-03  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/common/cogl-bitmap-pixbuf.c:
	(_cogl_bitmap_from_file): removed debug g_printf that announces each
	successful image load done by the internal image backend.

2008-07-02  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c
	(clutter_actor_get_abs_allocation_vertices): The initialization of
	the local stage pointer got moved away in revision 3081 so it was
	crashing if the function is called before the layout is run.

2008-07-02  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c:
	(clutter_label_create_layout_no_cache),
	(clutter_label_create_layout): Split the layout creation in two
	functions: one creating the layout, the other creating the layout
	and hitting the glyphs cache. The first one is for the offscren
	operations - like requesting the preferred size; the second one
	is for paint and allocation.

	(clutter_label_allocate): Try to aggressively cache the PangoLayout
	between allocations - to avoid recreating it even when the label
	just moved because of an animation. See bug #1010.

2008-07-02  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/fruity/clutter-fruity.c: made the multi touch code more
	robust. There are situations though where the device seems to stop
	generating any touch events until all fingers have been lifted and
	a new interaction session is started.

2008-07-02  Neil Roberts  <neil@o-hand.com>

	* clutter/eglx/clutter-stage-egl.c (clutter_stage_egl_realize):
	Use clutter_x11_has_event_retrieval() instead of
	!backend_x11->no_xevent_retrieval to reflect the changes to the
	GLX backend in revision 3078

2008-07-02  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1010 - ClutterLabel does not update the layout (Lee Jusung)

	* clutter/clutter-actor.c:
	(clutter_actor_queue_relayout): Remove some pointer dereferencing.

	* clutter/clutter-label.c:
	(clutter_label_allocate): Revert the change of r2883 and remove the
	layout width cache and force a recreation of the layout every time
	we receive an allocation.

2008-07-01  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c (clutter_actor_get_transformed_sizeu):
	This is now do-what-I-mean like clutter_actor_get_size so that if
	the allocation box is available it will use that, otherwise it
	will use the preferred size. clutter_actor_transform_vertices has
	been converted to clutter_actor_transform_and_project_box so that
	it can be used by both functions. Based on a patch by Emmanuele
	Bassi.
	(clutter_actor_get_abs_allocation_vertices)
	(clutter_actor_get_allocation_vertices): These two functions now
	force a relayout if the allocation box is not available.

	* tests/test-fbo.c: Fixed the shader to use texture2D instead of
	texture2DRect now that GL_EXT_texture_rectangle is no longer used.

2008-07-01  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-stage.c:
	Add a note to the clutter_stage_read_pixels doc that the alpha channel
	isn't guaranteed to contain sensible data

	* tests/test-stage-read-pixels.c: (update_snapshot):
	Overwrite the alpha data when using clutter_stage_read_pixels; fixes
	this test on non-nvidia drivers

2008-07-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-stage-glx.c:
	* clutter/x11/clutter-backend-x11.c:
	* clutter/x11/clutter-backend-x11.h:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-x11.h:
	* tests/test-devices.c:
	Disable use of XInput and add an explicit clutter_x11_enable_xinput
	to enable it.
	Also fix up the x11 pre-init calls to not need g_type_init.

2008-07-01  Øyvind Kolås  <pippin@o-hand.com>

	Bug 1013 - Per device grabs are not obeyed in pointer device
		   propagation.

	* clutter/clutter-event.c: (clutter_event_get_device_id): swap
	arguments of g_return_val_if_fail around.
	* clutter/clutter-event.h: added *device field to crossing events as
	well.
	* clutter/clutter-main.c: (emit_pointer_event): added a device
	argument and check for per device grabs if this device is passed.
	(clutter_do_event): pass the device if present for all pointer event
	emissions.
	(generate_enter_leave_events): copy the device from the motion events
	when generating enter/leave events.

2008-07-01  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-texture.c:
	Correct documentation about accepted pixel formats

	* tests/test-stage-read-pixels.c: (main):
	Don't try to free a ClutterTexture after main, fixes segfault on quit

2008-07-01  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-bspline.h:
	* clutter/clutter-behaviour.h:
	* clutter/clutter-event.h:
	* clutter/clutter-texture.h: Add missing documentation and
	change the copyright and licensing notice to use the FSF
	website instead of its address. (#512)

2008-06-30  Matthew Allum  <mallum@openedhand.com>

	Bug 1008 - tfp still a bit borked

	* clutter/x11/clutter-x11-texture-pixmap.c:
	Fix from Andy Wingo for sync_window borkage

2008-06-30  Neil Roberts  <neil@o-hand.com>

	Bug 985 - MSC math.h / M_PI issue

	* clutter/cogl/gl/cogl.c (set_clip_plane):
	* clutter/clutter-alpha.c (sinc_func): Use G_PI instead of M_PI
	because M_PI isn't defined in MSVC without a special
	#define. Thanks to Haakon Sporsheim

2008-06-30  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-backend-win32.c (check_vblank_env): Use
	g_ascii_strcasecmp instead of strcasecmp because strcasecmp isn't
	available in MSVC.

2008-06-30  Matthew Allum  <mallum@openedhand.com>

	 Bug 1007 - Fix TFP fallback mechanism

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	Add some extra safety to glx pixmap creations and tidy up some notes.
	Patch from Gwenole Beauchesne.

2008-06-30  Neil Roberts  <neil@o-hand.com>

	* clutter/x11/clutter-event-x11.c:
	* clutter/win32/clutter-event-win32.c: Use the HAVE_CONFIG_H guard
	around #include "config.h"

2008-06-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/Makefile.am:
	* clutter/eglx/Makefile.am:
	* clutter/glx/Makefile.am: Build the X11 base backend before
	the backends that depend on it.

2008-06-30  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 1000 - clutter-x11 should define gtypes for its enumerations

	* clutter/x11/Makefile.am:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-x11-enum-types.c.in:
	* clutter/x11/clutter-x11-enum-types.h.in:
	* clutter/x11/clutter-x11.h: Add the GTypes for the X11-specific
	enumerations, so that they can be used by the bindings. (Andy
	Wingo)

2008-06-30  Chris Lord  <chris@openedhand.com>

	* tests/test-shader.c:
	Fix edge-detect shader on ATI, thanks Gwenole Beauchesne

2008-06-30  Matthew Allum  <mallum@openedhand.com>

	Bug 997 - automatic updates not working for named TFP pixmaps,
		  at least in x11

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/glx/clutter-glx-texture-pixmap.h:
	* clutter/x11/clutter-backend-x11.c:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	* clutter/x11/clutter-x11-texture-pixmap.h:
	* clutter/x11/clutter-x11.h:
	* configure.ac:
	* tests/test-pixmap.c:
	Rework Andy Wingos patch a little adding more safety for now also
	handling redirect Windows (as well as pixmaps)

2008-06-30  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 980 - cogl-bitmap-fallback.c compiler error/warning due to
		  cast issue (Haakon Sporsheim)

	* clutter/cogl/common/cogl-bitmap-fallback.c:
	(_cogl_unpremult_alpha_last),
	(_cogl_unpremult_alpha_first): Cast to avoid a compiler warning
	with MSC.

2008-06-30  Chris Lord  <chris@openedhand.com>

	* tests/test-shader.c: (main):
	Add a new shader to test-shaders (Sobel operator edge-detect)

2008-06-30  Øyvind Kolås  <pippin@o-hand.com>

	Disable XInput handling for keyboard events, re-enabling key press and
	release events when pointer is outside window as well as re-enabling
	keyrepeat.

	* clutter/glx/clutter-stage-glx.c: (clutter_stage_glx_realize): select
	for KeyPressMask and KeyReleaseMask even with XInput enabled.
	* clutter/x11/clutter-backend-x11.c: (_clutter_x11_register_xinput):
	Disabled the XInput keyboard code paths (comments and #if 0's)
	* clutter/x11/clutter-event-x11.c: (event_translate): always handle
	keyboard events without regard to XInput.

2008-06-29  Matthew Allum  <mallum@openedhand.com>

	* clutter/x11/clutter-event-x11.c:
	ifdef convert_xdevicekey_to_xkey () with XINPUT check.
	(fix via Andy Wingo)

2008-06-29  Tommi Komulainen  <tommi.komulainen@iki.fi>

	* clutter/osx/clutter-osx.h (_clutter_event_osx_put)
	* clutter/osx/clutter-event-osx.c (clutter_event_osx_translate,
	NSEvent:clutterStage:)
	* clutter/osx/clutter-stage-osx.c (EVENT_HANDLER): Since events are
	delivered to ClutterGLView, pass the associated ClutterStage directly
	to event translation. Avoids relying on being embedded in
	ClutterGLWindow, which makes it easier to implement clutter-gtk.

2008-06-29  Tommi Komulainen  <tommi.komulainen@iki.fi>

	* clutter/osx/clutter-event.osx.c (NSEvent:clutterKeyVal:): Add
	comment, on OSX backend the Shift modifier is included in 'keyval'
	making it identical to 'unicode_value'  Instead of <Shift>a or
	<Shift>3 you'd get <Shift>A and <Shift>#

2008-06-27  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gl/cogl.c:
	Temp workaround for 10.4 ATI card OSX folks, see #929
	(Tommi Komulainen)

	Bug 998 - clutter always captures X input events

	* clutter/eglx/clutter-stage-egl.c:
	* clutter/glx/clutter-stage-glx.c:
	When we disable X event retrival, dont still select for window
	events.

2008-06-27  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-event.h:
	* clutter/clutter-main.c:
	* clutter/x11/clutter-backend-x11.c: Add further documentation,
	and increase the coverage to 94%.

2008-06-27  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.7.7.

======== Release 0.7.6 ========================================================

2008-06-27  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* NEWS: Release 0.7.6.

2008-06-27  Neil Roberts  <neil@o-hand.com>

	Bug 993 - Underline colors are sometimes wrong

	* clutter/pango/pangoclutter-render.c: Fixed so that instead
	of trying to set the color in prepare_run it uses draw_glyphs
	to draw groups of glyphs and requests the color for each part
	from Pango.

2008-06-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_min_width),
	(clutter_actor_set_min_height),
	(clutter_actor_set_natural_width),
	(clutter_actor_set_natural_height): Ignore any override of the
	minimum and natural size of the stage on backends that only
	support static stages.

	* clutter/clutter-stage.c (clutter_stage_allocate): Use the
	preferred size of the ClutterStage implementation instead of
	the display size.

	* clutter/clutter-backend.[ch]: Remove get_display_size() and
	clutter_backend_get_display_size().

	* clutter/eglnative/clutter-backend-egl.c:
	* clutter/fruity/clutter-backend-fruity.c:
	* clutter/osx/clutter-backend-osx.c:
	* clutter/sdl/clutter-backend-sdl.c:
	* clutter/win32/clutter-backend-win32.c:
	* clutter/x11/clutter-backend-x11.c: Remove get_display_size()
	implementations.

2008-06-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-shader.c (bind_glsl_shader): Verify that the
	vertex shader has been successfully compiled, like we do with
	the fragment shader.

2008-06-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/osx/clutter-backend-osx.c:
	(clutter_backend_osx_get_display_size): Fix the allocation pool
	macro name.

2008-06-26  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	Move the gl extension probe into the regular object init() rather than
	class_init. Should be a little safer.

2008-06-26  Matthew Allum  <mallum@openedhand.com>

	* tests/test-pixmap.c: (main):
	Use strtol on arg as to take hex values. Tweak from James Ketrenos

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.7.5.

======== Release 0.7.4 ========================================================

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* NEWS: Release 0.7.4.

2008-06-25  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-backend-win32.c
	(clutter_backend_win32_get_display_size): Implement
	get_display_size on the Win32 backend.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.h: Make the priority constants public.

	* clutter/clutter-stage.c: Use CLUTTER_PRIORITY_REDRAW.

	* clutter/clutter-timeline.c: Use CLUTTER_PRIORITY_TIMELINE.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/osx/clutter-backend-osx.c:
	(clutter_backend_osx_get_display_size),
	(clutter_backend_osx_class_init): Implement the get_display_size
	function.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_min_width),
	(clutter_actor_set_min_height),
	(clutter_actor_set_natural_width),
	(clutter_actor_set_natural_height): Add a comment explaining
	the override in place for backends providing a fixed size
	on a stage.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_min_width),
	(clutter_actor_set_min_height),
	(clutter_actor_set_natural_width),
	(clutter_actor_set_natural_height): If setting the minimum
	and natural width and height on a top-level actor, and on
	a backend that provides only static stages, then override
	the value and use the size of the display as returned by
	the backend.

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_realize): Remove the setting of the
	minimum and natural width and height.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-stage.c:
	(clutter_stage_allocate): Minor optimization.

	(clutter_stage_init): Do not set the minimum size of the
	stage wrapper, and require that the backends set the size
	themselves.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_realize): Try to force the minimum and
	natural size on realization.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-backend.c:
	(clutter_backend_get_display_size): Provide a fallback for
	backends not implementing get_display_size().

	* clutter/clutter-stage.c:
	(clutter_stage_allocate): Add debug messages.

	* clutter/sdl/clutter-backend-sdl.c:
	(clutter_backend_sdl_get_display_size),
	(clutter_backend_sdl_class_init): Implement get_display_size()
	on the SDL backend.

2008-06-25  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-fixed.c: (clutter_sinx):
	Fix clutter_sinx for angles > CFX_2PI - CFX_ONE. Also add note to
	documentation about being able to use modulus with ClutterFixed

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-backend.h:
	* clutter/clutter-backend.c:
	(clutter_backend_get_display_size): Add a function for getting the
	display size out of the backend.

	* clutter/clutter-stage.c:
	(clutter_stage_allocate): When allocating on a backend with a
	static stage, we simply ignore the passed box and override it with
	the size of the display.

	* clutter/eglnative/clutter-backend-egl.c:
	(clutter_backend_egl_get_display_size),
	(clutter_backend_egl_class_init): Implement get_display_size() by
	returning the size of the EGL surface.

	* clutter/fruity/clutter-backend-fruity.c:
	(clutter_backend_egl_get_display_size),
	(clutter_backend_egl_class_init): Ditto as above.

	* clutter/x11/clutter-backend-x11.c:
	(clutter_backend_x11_get_display_size),
	(clutter_backend_x11_class_init): Implement get_display_size() by
	returning the DisplayWidth and DisplayHeight of the current
	screen.

2008-06-25  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-stage-win32.c
	(clutter_stage_win32_realize): Use a more direct method to choose
	the best pixel format instead of ChoosePixelFormat because
	otherwise if the display's depth is 16 then it will prefer the
	non-accelerated software implementation when the requested depth
	is 24.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-stage.c (clutter_stage_allocate): Fix condition;
	should always test before committing.

2008-06-25  Matthew Allum  <mallum@openedhand.com>

	* clutter/x11/clutter-backend-x11.c: (_clutter_x11_register_xinput)
	Add extra safety and fallback if no useable pointing devices are
	found.

2008-06-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-stage.c:
	(clutter_stage_allocate): Check if the stage provided by the
	backend is static (i.e. a framebuffer that cannot be resized)
	and interrupt the allocation chain there.

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_class_init): Remove the ::allocate empty
	stub.

2008-06-25  Matthew Allum  <mallum@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c:
	* clutter/eglx/clutter-stage-egl.c:
	Disable passing of attribs to eglCreateContext() on GLES 1.1 h/w

2008-06-25  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c (clutter_actor_paint): Guard against the
	actor clip being enabled or disabled in an actor paint
	method. Otherwise the clip stack can be become unbalanced. This
	was happening in ClutterEntry until it was fixed in revision 2983.

2008-06-24  Neil Roberts  <neil@o-hand.com>

	Bug 979 - Wrong call convension for SwapIntervalProc in win32 backend

	* clutter/win32/clutter-backend-win32.c: Use the correct calling
	convention for SwapInterval. Thanks to Haakon Sporsheim.

2008-06-24  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 989 - Add a search path for clutter script assets

	* clutter/clutter-script.h:
	* clutter/clutter-script.c:
	(clutter_script_finalize),
	(clutter_script_add_search_paths),
	(clutter_script_lookup_filename): Add the ability to define multiple
	search paths inside ClutterScript and to look up a specific filename
	inside those search paths. This is useful to define a set of
	directories where the assets for a UI definition are and still
	reference those assets by their name instead of the full path. (989,
	based on a patch by Matthew Allum)

	* clutter/clutter-texture.c:
	(clutter_texture_set_custom_property): Use the newly added
	clutter_script_lookup_filename() function.

2008-06-24  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-gles2-wrapper.c: All of the settings and
	uniforms are now proxied into COGL variables instead of setting
	the GL uniforms directly. Just before glDrawArrays is executed a
	shader is generated using the given settings to avoid using 'if'
	statements. The shaders are cached.

	* clutter/cogl/gles/cogl-fixed-vertex-shader.glsl:
	* clutter/cogl/gles/cogl-fixed-fragment-shader.glsl: The shaders
	are now split into parts using comments instead of 'if' statements
	so that the simplest shader can be generated on the fly.

	* clutter/cogl/gles/stringify.sh: Now splits up the shader sources
	into separate C strings where deliminated by special comments.

	* clutter/cogl/gles/cogl-program.h:
	* clutter/cogl/gles/cogl-program.c: A custom shader can no longer
	be directly linked with the fixed-functionality replacement
	because the replacement changes depending on the settings. Instead
	the bound shader is linked with the appropriate replacement shader
	just before glDrawArrays is executed. The custom uniform variables
	must also be proxied through COGL variables because their location
	can change when relinked.

2008-06-24  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/fruity/clutter-fruity.c: removed dead code and unused
	variables.

2008-06-24  Øyvind Kolås  <pippin@o-hand.com>

	* configure.ac: better alignment of list of enabled experimental
	features.

2008-06-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* doc/clutter-actor-invariants.txt: Fix grammar and spelling,
	document the ::parent-set signal emission.

2008-06-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-entry.c:
	(clutter_entry_ensure_layout): Convert the invisible char
	to UTF-8 to avoid Pango barfing on us.

2008-06-24  Matthew Allum  <mallum@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c:
	Add an extra debug note.
	* configure.ac:
	Generate version.xml for COGL API docs

2008-06-24  Chris Lord  <chris@openedhand.com>

	Bug 988 - cursor position wrong with multibyte invisible char

	* clutter/clutter-entry.c: (clutter_entry_ensure_cursor_position):
	Fix cursor position calculation when using invisible text

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-event-x11.c (event_translate): Set the
	event type explicitly in the union members as well for the
	key events, like we do for all the other events.

2008-06-23  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-entry.c (clutter_entry_paint): Set the clip
	using COGL directly instead of setting the actor clip. Otherwise
	the clip stack will be unbalanced after the first draw. This also
	frees up the actor clip to be set by an application.

2008-06-23  Matthew Allum  <mallum@openedhand.com>

	* NEWS:
	Add a quick note on fruity multiple deivce support.
	* README:
	Add multiple device support details and some tweaks on
	Clutter requirements (i.e GdkPixbuf).

2008-06-23  Matthew Allum  <mallum@openedhand.com>

	Bug 987 - clutter-event.c c99 variable declaration

	* clutter/clutter-event.c:
	Remove c99ism.

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.7.3.

======== Release 0.7.2 ========================================================

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* NEWS: Release 0.7.2.

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c:
	(clutter_texture_get_preferred_width),
	(clutter_texture_get_preferred_height),
	(clutter_texture_set_property),
	(clutter_texture_get_property),
	(clutter_texture_class_init),
	(clutter_texture_init): Add the new :keep-aspect-ratio property
	to ClutterTexture; when set to TRUE the texture will return a
	preferred width maintaining the aspect ratio with the given height
	and a preferred height maintaining the aspect ratio with the
	given width. This allows to set the width or the height and have
	the texture automatically request the height or the width respectively
	while maintaining the aspect ratio of the original image.

	* tests/test-script.json: Update to test the new :keep-aspect-ratio
	property.

2008-06-23  Neil Roberts  <neil@o-hand.com>

	Bug 918 - Group doesn't clip if it's children are clipped

	* clutter/cogl/common/cogl-clip-stack.h:
	* clutter/cogl/common/cogl-clip-stack.c: Added functions to
	maintain a stack of clipping rectangles.

	* clutter/cogl/gles/cogl.c:
	* clutter/cogl/gl/cogl.c: The cogl_clip_set and unset functions
	have moved into cogl-clip-stack.c which calls back to cogl.c to
	set the actual rectangles. Multiple clip rectangles are combined
	by merging the stencil buffers.

	* clutter/cogl/gles/cogl-primitives.c (_cogl_path_fill_nodes):
	* clutter/cogl/gl/cogl-primitives.c (_cogl_path_fill_nodes): Merge
	the stencil buffer with the contents of the clipping stack after
	drawing the path.

	* clutter/cogl/gles/cogl-context.h (CoglContext):
	* clutter/cogl/gl/cogl-context.h (CoglContext): Store the number
	of available stencil bits.

	* clutter/cogl/common/Makefile.am
	(libclutter_cogl_common_la_SOURCES): Added cogl-clip-stack.c

2008-06-23  Robert Bragg  <bob@o-hand.com>

	* clutter/eglx/clutter-stage-egl.c: Makes sure the eglx backend
	passes the EGL_OPENGL_ES2_BIT surface attrib when using
	GLES2.0 under cogl

2008-06-23  Chris Lord  <chris@openedhand.com>

	* clutter/x11/clutter-event-x11.c: (convert_xdevicekey_to_xkey),
	(translate_key_event), (event_translate):
	Change the xinput event handling to use translate_key (fixes modifier
	handling with xinput key events)

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 982 - __COGL_GET_CONTEXT MS compiler issue (Haakon Sporsheim)

	* clutter/cogl/common/cogl-handle.h:
	* clutter/cogl/common/cogl-primitives.c: Remove C99-isms.

	* clutter/cogl/gl/cogl-fbo.c:
	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gl/cogl-texture.c:
	* clutter/cogl/gl/cogl.c: Ditto as above.

	* clutter/cogl/gles/cogl-fbo.c:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/gles/cogl-texture.c: Ditto as above.

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 984 - pango_clutter_render_layout() declared void, but
		  returns (Haakon Sporsheim)

	* clutter/pango/pangoclutter-render.c:
	(pango_clutter_render_layout): Do not use a return statement.

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 905 - Paint cursor directly (Xan López)

	* clutter/clutter-entry.c:
	(clutter_entry_paint_cursor),
	(clutter_entry_init),
	(clutter_entry_set_color): Directly paint the cursor on the
	entry instead of using an actor.

2008-06-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 981 - clutter_stage_read_pixels temprow fix (Haakon Sporsheim)

	* clutter/clutter-stage.c (clutter_stage_read_pixels): Allocate
	the temporary row data used to flip the buffer from glReadPixels()
	in order to fix compilation under MSVC. Also validate the input
	parameters to avoid random segfaults.

2008-06-23  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* clutter/clutter-event.c:
	* clutter/clutter-event.h:
	* clutter/clutter-main.c:
	* clutter/clutter-main.h:
	* clutter/clutter-private.h:
	* clutter/eglx/clutter-stage-egl.c:
	* clutter/fruity/clutter-backend-fruity.c:
	* clutter/fruity/clutter-backend-fruity.h:
	* clutter/fruity/clutter-fruity.c:
	* clutter/glx/clutter-stage-glx.c:
	* clutter/x11/clutter-backend-x11.c:
	* clutter/x11/clutter-backend-x11.h:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-stage-x11.h:
	* clutter/x11/clutter-x11.h:
	* configure.ac:
	* tests/Makefile.am:
	* tests/test-devices.c:
	Merge of 'xinput' branch giving initial basic support of
	multiple input devices.

2008-06-23  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* clutter/clutter-group.c:
	Remove uneeded (at least for now) paint_area method (#970)

2008-06-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script.c: Be more explicit about the fact that
	the script id is not the name of an actor, and that it is retrieved
	by using clutter_get_script_id().

2008-06-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	(clutter_actor_allocate_preferred_size): Add more documentation
	and notes on where it's appropriate to call this function.

2008-06-17  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-texture.c: (clutter_texture_get_preferred_width),
	(clutter_texture_get_preferred_height):
	Maintain aspect ratio with natural width/height when for_width/height
	are specified

2008-06-17  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	Clean up of parenting code (see #972)
	Doc updates to section intro.
	Add clutter_actor_allocate_preferred_size () utility call

	* clutter/clutter-group.c: (clutter_fixed_layout_allocate):
	Use clutter_actor_allocate_preferred_size ()

	* doc/clutter-actor-invariants.txt:
	Add some more notes

2008-06-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_parent): Do not emit ::parent-set when
	reparenting.

	(clutter_actor_unparent): Ditto, as above.

	(clutter_actor_reparent): Emit ::parent-set with the old
	parent and set the IN_REPARENT flag unconditionally.

2008-06-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* doc/clutter-actor-invariants.txt: Document the flags, the
	invariants, the state changes and the minimum requirements for
	actor implementations. Needs to be tweaked and fleshed out
	before 0.8.0, and we obviously need to enforce the invariants.

2008-06-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_parent): Document and maintain the invariant
	that after setting a realized parent on an actor, the actor is
	also going to be realized.

	(clutter_actor_unparent): Change the invariant that an unparented
	actor is also unrealized: the paint is fast enough to avoid
	unrealizing, since it also causes more problems that what it's
	worth.

	* tests/test-invariants.c (test_show_on_set_parent): Update the
	invariants test because we changed the invariants.

2008-06-17  Jussi Kukkonen  <jku@o-hand.com>

	* clutter/clutter-score.c (clutter_score_append):
	initialize "marker" string and "complete_id" signal id when creating a
	ClutterScoreEntry.

2008-06-16  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_move_anchor_point_from_gravity):
	Fixed incorrect sign of position adjustment (revert of earlier
	change).

2008-06-16  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_unparent): Reset the
	:show-on-set-parent property to TRUE when unparenting.

	* tests/Makefile.am: Add test-invariant to the build.

	* tests/test-invariants.c: Test the invariants that we are going
	to honour (and document, at some point).

2008-06-16  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c: Ignore any size allocation
	we receive from the user.

	* clutter/fruity/clutter-stage-fruity.c: Ditto as above.

2008-06-16  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_move_anchor_point):
	(clutter_actor_move_anchor_pointu):
	(clutter_actor_move_anchor_point_from_gravity):
	Fixed incorrect sign of position adjustment.
	Fixed replace call to _move_by with move_byu in
	_move_anchor_pointu.

	Stripped trailing whitespace.

2008-06-15  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #967 - Mismatch of Timeline::marker-reached signal signature

	* clutter/clutter-marshal.list:
	* clutter/clutter-timeline.c:
	(clutter_timeline_class_init): Fix the type of the frame_num
	argument in the ::marker-reached signal creation to match the
	signal class handler. (Armin Burgmeier)

2008-06-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: We depend on PangoCairo, now; also add all the missing
	release notes entries and the missing backends configuration notes.

2008-06-14  Matthew Allum  <mallum@openedhand.com>

	* README:
	Make needed GL version 1.4, note GLES2 support, add some notes
	for COGL.

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.7.1.

======== Release 0.7.0 ========================================================

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* README:
	* NEWS:
	* configure.ac: Release 0.7.0, "Booska".

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-cogl-offscreen.c:
	* tests/test-cogl-primitives.c:
	* tests/test-cogl-tex-convert.c:
	* tests/test-cogl-tex-foreign.c:
	* tests/test-cogl-tex-getset.c:
	* tests/test-cogl-tex-tile.c:
	* tests/test-layout.c:
	* tests/test-pixmap.c:
	* tests/test-texture-quality.c: Miscellaneous fixes for distcheck
	to pass.

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* tests/test-cogl-primitives.c:
	* tests/test-events.c:
	* tests/test-multistage.c:
	* tests/test-textures.c:
	* tests/test-timeline.c: Miscellaneous fixes for distcheck to
	pass.

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c:
	(clutter_texture_unrealize), (clutter_texture_dispose): Add a
	guard against reading back memory during the unrealization on
	dispose.

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #953 - Actors are not hidden before unrealized or
		   disposed (Tommi Komulainen)

	* clutter/clutter-actor.c:
	(clutter_actor_unrealize): Hide a visible actor when unrealizing
	it.

	(clutter_actor_dispose): Make sure to unrealize an actor when
	disposing it.

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_dispose), (clutter_actor_destroy),
	(clutter_actor_unparent): Clean up the actor's destruction
	sequence, making sure that every operation is performed
	under the CLUTTER_ACTOR_IN_DESTRUCTION internal flag. (thanks
	to Tomas Frydrych, Neil Roberts and Matthew Allum)

2008-06-13  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #960 - PangoContext creation code should not be duplicated

	* clutter/clutter-private.h:
	* clutter/clutter-main.c:
	(_clutter_context_create_pango_context): Abstract the creation
	of the PangoContext inside its own function, to avoid code and
	bugs duplication. (Tommi Komulainen)

	* clutter/clutter-entry.c (clutter_entry_init): Use the newly
	added PangoContext creation function.

	* clutter/clutter-label.c (clutter_label_init): Ditto as above.

2008-06-12  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #964 - "unrealized" signal of ClutterActor wrongly named

	* clutter/clutter-actor.c (clutter_actor_class_init): Fix typo
	in the ::unrealize signal name. (Armin Burgmeier)

2008-06-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* doc/reference/cogl/Makefile.am: Ignore cogl/gl and cogl/gles
	when building the documentation.

	* clutter/cogl/cogl.h.in: Add sections in the header file.

2008-06-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Add more clarifications on the
	size and position accessors and the distinction between
	transformed and untransformed actor box inside the actor's
	description.

2008-06-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Clarify the documentation of the
	accessors of the width and height.

2008-06-12  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-stage-win32.c: Updated to the new layout
	API. All code to do with positioning the stage has been removed so
	the window is left where Windows wants to put it and it can not be
	moved with clutter_actor_set_position.

	* clutter/win32/clutter-stage-win32.h (ClutterStageWin32): Remove
	win_xpos and win_ypos.

	* clutter/win32/clutter-event-win32.c (message_translate): Remove
	the handler for WM_MOVE because the stage no longer cares where it
	is positioned.

2008-06-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.[ch]: Documentation fixes.

	* clutter/clutter-backend.c: Documentation fixes.

	* clutter/clutter-container.h: Documentation fixes.

	* clutter/clutter-fixed.c (clutter_qdivx): Fix the return
	value to be after the description.

	* clutter/clutter-texture.[ch]: Documentation fixes.

	* clutter/clutter-timeline.c: Documentation fixes.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-layout.c: Take into account the origin of the
	parent, if it has changed, and queue a relayout if we are
	using the transformed box when computing the layout.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c: Remove a duplicate
	get_preferred_width() implementation. (thanks to Iain Holmes)

2008-06-11  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c (clutter_actor_allocate): Fixed the
	logic when detecting whether the actor has moved.

2008-06-11  Iain Holmes  <iain@openedhand.com>

	* configure.ac: Detect the GL headers in flavour=fruity

	* clutter/fruity/clutter-stage-fruity.c: Update the Fruity backend to
	use the new size negotiation API.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c (clutter_label_allocate): Keep the
	layout if the size of the allocation is the same as the last
	allocation received by the label.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Notify :x, :y, :width and :height
	properties using ClutterUnits, not pixels.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-stage-egl.c: Update the EGL native
	backend to use the new size negotiation API.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/sdl/clutter-stage-sdl.c: Update the SDL backend to
	use the new size negotiation API.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #961 - Fails to build on OSX

	* clutter/osx/clutter-stage-osx.c: Update the OSX backend to
	use the new size negotiation API.

2008-06-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* autogen.sh: Force overwriting when glib-gettextize is
	invoked by autogen.sh.

2008-06-10  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-main.c: Include <locale.h> for setlocale()

2008-06-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-child-meta.c: Fix section name

	* clutter/clutter-container.c:
	(clutter_container_child_set_property),
	(clutter_container_child_get_property): Fix gtk-doc parameter
	name.

	* clutter/clutter-container.h: Fix documentation of the
	interface vfuncs.

	* clutter/clutter-event.h: Fix documentation.

	* clutter/clutter-feature.h: Fix documentation.

	* clutter/clutter-types.h: Add ClutterRequestMode.

	* clutter/x11/clutter-event-x11.c: Fix documentation.

	* tests/test-fullscreen.c: Verify that the stage size has been
	changed by clutter_stage_fullscreen().

2008-06-10  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #815 - Split up request, allocation, and paint box

	* clutter/clutter-actor.[ch]: Rework the size allocation,
	request and paint area. Now ::request_coords() is called
	::allocate(), and ::query_coords() has been split into
	::get_preferred_width() and ::get_preferred_height(). See
	the documentation and the layout test on how to implement
	a container and layout manager with the new API. (#915,
	based on a patch by Havoc Pennington, Lucas Rocha and Johan
	Bilien)

	* clutter/clutter-clone-texture.c: Port CloneTexture to
	the new size negotiation API; it just means forwarding
	the requests to the parent texture.

	* clutter/clutter-deprecated.h: Add deprecated and replaced
	API.

	* clutter/clutter-entry.c: Port Entry to the new size
	negotiation API.

	* clutter/clutter-group.c: Port Group to the new size
	negotiation API; the semantics of the Group actor do not
	change.

	* clutter/clutter-label.c: Port Label to the new size
	negotiation API, and vastly simplify the code.

	* clutter/clutter-main.[ch]: Add API for executing a
	relayout when needed.

	* clutter/clutter-private.h: Add new Stage private API.

	* clutter/clutter-rectangle.c: Update the get_abs_opacity()
	call to get_paint_opacity().

	* clutter/clutter-stage.c:
	(clutter_stage_get_preferred_width),
	(clutter_stage_get_preferred_height),
	(clutter_stage_allocate),
	(clutter_stage_class_init): Port Stage to the new size
	negotiation API.

	* clutter/clutter-texture.c: Port Texture to the new size
	negotiation API.

	* clutter/clutter-types.h: Add ClutterRequestMode enumeration.

	* clutter/x11/clutter-stage-x11.c: Port the X11 stage
	implementation to the new size negotiation API.

	* tests/Makefile.am: Add the layout manager test case.

	* tests/test-opacity.c: Update.

	* tests/test-project.c: Update.

	* tests/test-layout.c: Test case for a layout manager implemented
	using the new size negotiation API; the layout manager handles
	both transformed and untransformed children.

2008-06-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* Makefile.am: Add the po/ directory to the build.

2008-06-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* autogen.sh: Check for, and run glib-gettextize.

	* configure.ac: Set up the localization support.

	* clutter/clutter-main.c: Do not define the GETTEXT_PACKAGE,
	but use the one from the configure script.

	* po/POTFILES.in: Template for the translatable files.

2008-06-10  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-main.c: (pre_parse_hook):
	Call setlocale on init

	* clutter/x11/clutter-event-x11.c: (translate_key_event):
	Fix typo and use the same buffer size as xev

2008-06-10  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-texture.c: improved documentation for
	clutter_texture_set_filter_quality.

2008-06-10  Chris Lord  <chris@openedhand.com>

	Bug #916 - ClutterKeyEvent:unicode_value is ignored
	Bug #950 - AltGr not handled

	* clutter/osx/clutter-event-osx.c: (clutter_event_osx_translate):
	* clutter/x11/clutter-event-x11.c: (translate_key_event):
	* tests/test-events.c: (fill_keybuf), (input_cb):
	Apply patch from Tommi Komulainen, fill the unicode_value attribute of
	the ClutterKeyEvent struct. Also use XKeycodeToKeysym, as suggested in
	bug #950, comment #2

2008-06-10  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c:
	Minor reformatting cleanups. Emit filter-quality prop on change.
	* clutter/glx/clutter-glx-texture-pixmap.c:
	Support mipmaps via filter quality prop.

2008-06-10  Chris Lord  <chris@openedhand.com>

	* tests/Makefile.am:
	* tests/test-entry-auto.c:
	Add automatic test for ClutterEntry, by Tommi Komulainen

2008-06-10  Chris Lord  <chris@openedhand.com>

	* clutter/cogl/common/cogl-primitives.c: (_cogl_path_arc):
	Draw as expected when end angle is lower than start angle (i.e. do not
	swap the angles). This aligns with cairo behaviour.

2008-06-10  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug#959 - Multiple minor improvements

	* configure.ac: pick up GDKPIXBUF_PREFIX from gdk-pixbuf-2.0
	module, not pango

	* clutter/clutter-keysyms-table.h: cosmetic fix for ifdef guard
	name in the comment (leftover from earlier commit)

	* tests/test-textures.c: don't depend on GdkPixbuf as we're not
	using any actual features from it, just plain pixel buffer
	manipulation

	* clutter/clutter-timeline.c
	* clutter/clutter-timeline.h (clutter_timeline_list_markers): Use
	gsize* to return number of items, not guint*
	* tests/test-paint-wrapper.c: use correct type (guint*) in call
	to clutter_actor_get_size()

	* tests/test-depth.c (janus_group): properly take height2 into
	account when calculating needed height for the rectangle

	* tests/test-cogl-tex-getset.c: use rowstride, not width*4, when
	calculating pixel offsets

	* tests/test-cogl-tex-getset.c: Don't assume/force RGBA format,
	also support ARGB format (needed with quartz imageloader.)

2008-06-09  Tommi Komulainen  <tommi.komulainen@iki.fi>

	* clutter/osx/clutter-backend-osx.c (clutter_backend_osx_post_parse):
	Print GL_VENDOR, GL_RENDERER, GL_VERSION and GL_EXTENSIONS to aid
	debugging.

2008-06-09  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug #930 - add support for quartz imagebackend

	* clutter/cogl/common/cogl-bitmap-pixbuf.c
	(_cogl_bitmap_from_file): When USE_QUARTZ is defined implement
	using Core Graphics.
	* configure.ac: support --with-imagebackend=quartz and print
	which imagebackend is selected. Make quartz default on OSX

2008-06-09  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/common/cogl-primitives.c: (cogl_path_rel_curve_to):
	fixed naming of implementation of cogl_path_rel_curve_to (it was
	called just cogl_rel_curve_to).

2008-06-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Clean up a bit the X11 and X extensions
	checks with PKG_CHECK_EXISTS(). Since we are filling up the
	X11_CFLAGS and X11_LIBS variables ourselves there is no
	point in polluting the Makefiles with unused variables.

	* clutter/Makefile.am: Remove the pkg-config variable
	evaluation and use the values retrieved from the configure
	script.

2008-06-09  Chris Lord  <chris@openedhand.com>

	Bug #914 - ClutterEntry is confused about characters vs. bytes

	* clutter/clutter-entry.c: (clutter_entry_ensure_layout),
	(clutter_entry_handle_key_event_internal),
	(clutter_entry_set_text):
	Fix mix-up of character and byte counts, handle unicode correctly.
	Use clutter_key_event_unicode() instead of
	clutter_keysym_to_unicode().

	* clutter/clutter-event.c: (clutter_key_event_unicode):
	Don't ignore ClutterKeyEvent.unicode_value

	* clutter/clutter-keysyms-table.h:
	Rename header define so as not to conflict with clutter-keysyms.h

	Patch originally by Emmanuele Bassi, with input from Tommi Komulainen.

2008-06-07  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-texture.c: made the filter-quality proeprty also
	control the use of mipmapping.
	* clutter/clutter-texture.h: added ClutterTextureQuality enum.
	* tests/test-texture-quality.c: new test.
	* tests/Makefile.am: added test-texture-quality

2008-06-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c:
	(clutter_texture_class_init): Do not unrealize on hide(), and
	do not realize() on show. By default, clutter_actor_show() will
	realize ourselves, and we don't want to unrealize when hidden
	to avoid paying the penalty of reading back the texture data
	from the video memory.

	* tests/test-actors.c: Show all textures again when pressing
	the 'r' key.

2008-06-06  Neil Roberts  <neil@o-hand.com>

	* tests/test-shader.c: Use the special wrapper vars when building
	for GLES 2 and automatically cycle the shaders because it's
	difficult to right-click.

2008-06-06  Neil Roberts  <neil@o-hand.com>

	* tests/test-shader.c: Fixed to use sampler2D instead of
	sampler2DRect now that GL_TEXTURE_RECTANGLE support is disabled in
	revision 2834. The ClutterTexture actor now has the
	'disable-slicing' property set. The distance in texture
	coordinates between pixels is passed in as a uniform so that the
	box-blur shader can still work.

2008-06-06  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #952 - Fix test-textures in trunk

	* tests/test-textures.c: Use USE_GDKPIXBUF instead of
	USE_PIXBUF. (#952, Gwenole Beauchesne)

2008-06-06  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #951 - Fix clutter_entry_init() in trunk

	* clutter/clutter-entry.c (clutter_entry_init): Remove a
	variable shadowing another one. (#951, Tommi Komulainen)

2008-06-06  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #955 - ClutterLabel is missing fallback resolution handling

	* clutter/clutter-label.c (clutter_label_init): Handle
	clutter_backend_get_resolution() return value -1 similar to
	ClutterEntry (falling back to 96.0). (#955, Tommi Komulainen)

2008-06-06  Neil Roberts  <neil@o-hand.com>

	* clutter/eglnative/clutter-stage-egl.c
	(clutter_stage_egl_realize): Use ES 2 renderable type when
	building for GLES 2.

	* clutter/eglnative/clutter-event-egl.c (get_backend_time): Added
	a NULL for the microseconds parameter of g_timer_elapsed.

	* clutter/eglnative/clutter-stage-egl.h:
	* clutter/eglnative/clutter-egl.h:
	* clutter/eglnative/clutter-backend-egl.h: Include
	clutter-egl-headers.h instead of including the GL headers directly
	so it can include gl2.h when building for GLES 2.

	* clutter/eglnative/clutter-egl-headers.h:
	* clutter/eglnative/Makefile.am (libclutter_eglnative_la_SOURCES):
	Added clutter-egl-headers.h

	* clutter/cogl/gles/cogl-fixed-fragment-shader.glsl: GLES 2
	doesn't provide a default precision for floats in the fragment
	shader and it will reject the shader if there isn't one.

2008-06-06  Matthew Allum  <mallum@openedhand.com>

	Bug #948 - Remove texture rectangle support

	* clutter/clutter-feature.c:
	* clutter/clutter-feature.h:
	* clutter/clutter-texture.c:
	* clutter/cogl/gl/cogl.c:
	* clutter/glx/clutter-glx-texture-pixmap.c:
	Remove support for GL_TEXTURE_RECTANGLE_ARB (now using just regular
	2D textures, with optional npots extension). Simplifys code, + makes
	mipmap & shader support much more sane.

2008-06-06  Øyvind Kolås  <pippin@o-hand.com>

	Bug #931 - suspicious size allocation for pixel data.

	* clutter/cogl/common/cogl-bitmap-pixbuf.c:
	(_cogl_bitmap_from_file): allocate height×rowstride and not duplicate
	gdkpixbuf's strange optimization saving some bytes at the end of the
	pixbuf.

2008-06-05  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug 913 - cogl fails to build on OSX

	* clutter/cogl/gl/cogl-fbo.c: define GL_READ_FRAMEBUFFER_EXT and
	GL_DRAW_FRAMEBUFFER_EXT if not defined in the build system. The
	#ifdef can fail if they're not #defines but variables or enums.
	As the values are supposed to be industry standard even then
	it shouldn't have ill effects.

2008-06-05  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug #911 - OSX: add multistage support

	* clutter/osx/clutter-backend-osx.{c,h}
	(clutter_backend_osx_init_stage, clutter_backend_osx_get_stage,
	clutter_backend_osx_redraw, clutter_backend_osx_create_stage,
	clutter_backend_osx_ensure_context, clutter_backend_osx_class_init,
	clutter_backend_osx_dispose, ClutterGLView:drawRect:):
	* clutter/osx/clutter-stage-osx.{c,h} (clutter_stage_osx_realize,
	ClutterGLWindow:setFrameSize:):
	Adapt to new multistage backend API. Don't keep a pointer to
	default stage. Derive from ClutterActor instead of ClutterStage.
	Implement ClutterStageWindow interface. Paint, resize and
	otherwise manipulate the wrapper rather than self when necessary.

	(clutter_backend_post_parse): Create our singleton GL context
	here. We could probably create the context when the default
	stage is created, but I think this is more clean.

	* clutter/osx/clutter-event-osx.c (clutter_event_osx_translate)
	* clutter/osx/clutter-stage-osx.c (clutter_stage_osx_state_update,
	ClutterGLWindow:windowShouldClose:):
	* clutter/osx/clutter-stage-osx.h: Export ClutterGLWindow interface
	for clutter-event-osx.c to easily get the stage for NSWindow.
	Fill in ClutterEventAny::stage on our events.

2008-06-05  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug #910 - OSX: missing memory pool

	* clutter/osx/clutter-backend-osx.c (clutter_backend_osx_redraw):
	Add missing memory pool wrapup.

2008-06-05  Tommi Komulainen  <tommi.komulainen@iki.fi>

	Bug #909 - OSX: missing NULL pointer handling

	* clutter/osx/clutter-stage-osx.c (ClutterGLWindow,
	clutter_stage_osx_set_title): NSString:stringWithUTF8String:
	does not accept NULL values, use empty string ("") instead.
	Avoids potential crash.

2008-06-05  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/Makefile.am:
	* tests/test-paint-wrapper.c: Add a test case (merely, a copy
	of test-actors.c) that verifies that handlers to the ::paint
	signal are called in the right order.

2008-06-05  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #840 - Implement prepare-paint and finish-paint signals.

	* clutter/clutter-actor.c:
	(clutter_actor_class_init): Add the ::paint, ::realize and
	::unrealize signals to ClutterActor. It is possible to
	override the paint, realization and unrealization of an
	actor without subclassing it. The ::paint signal handlers
	have the same limitations of a ClutterActor::paint implementation
	inside a subclass.

	(clutter_actor_realize),
	(clutter_actor_unrealize),
	(clutter_actor_paint): Emit the signals instead of calling
	the functions from the class vtable.

2008-06-05  Emmanuele Bassi  <ebassi@openedhand.com>

	* ChangeLog-ivan: Remove the ChangeLog of the clutter-ivan
	branch; the branch already contains it.

2008-06-05  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.h:
	Actually export clutter_glx_texture_pixmap_using_extension ()

2008-06-05  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-entry.c:
	Correct the documentation for clutter_entry_set_max_length, fixes bug
	#915.

2008-06-04  Robert Bragg  <bob@o-hand.com>

	* tests/test-clip.c:
	Removes a spurious #include <gdk-pixbuf/gdk-pixbuf.h> which may not
	be found if using --with-imagebackend=internal

2008-06-04  Robert Bragg  <bob@o-hand.com>

	* configure.ac:
	Checks that for pangocairo >= 1.18, since
	pangocairo-font.c uses pango_cairo_font_get_scaled_font which isn't
	otherwise available.

2008-06-03  Neil Roberts  <neil@o-hand.com>

	Applied patch from bug #947

	* clutter/clutter-stage.c (clutter_stage_get_default): Don't grab
	the floating reference when creating the default stage. The stage
	manager will take a reference to it so it will behave as any other
	stage.
	(clutter_stage_new): Don't take the floating reference to the new
	stage but let the stage manager keep it instead.

	* clutter/clutter-stage-manager.c
	(_clutter_stage_manager_add_stage): Take a reference to the stage
	when it is added to the list.
	(_clutter_stage_manager_remove_stage): Unref the stage when it is
	removed from the list.
	(clutter_stage_manager_dispose): Keep track of the 'next' pointer
	as a separate variable so we can cope when the stage being
	destroyed removes itself from the list as the list is being
	iterated.

	* clutter/clutter-actor.c (clutter_actor_destroy): Take a
	reference at the beginning of the function even if there is no
	parent container so that overall the reference count is not
	changed when the actor is unref'd again at the bottom of the
	function. Previously it would have a net effect of leaving the
	reference count alone unless it is a top level actor in which case
	it would unref it.

2008-06-03  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	Dont always fallback to x11 (slow) updates for a single
	failed pixmap.
	Minor cleanups.
	* clutter/x11/clutter-x11-texture-pixmap.c:
	Move shm allocation to only area updates.

2008-06-03  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-container.c: (container_get_child_property):
	s/g_object_set_property/g_object_get_property/

2008-06-02  Neil Roberts  <neil@o-hand.com>

	* clutter/pango/pangoclutter-glyph-cache.c
	(pango_clutter_glyph_cache_set): When creating a new band, make
	sure the texture is wide enough for the glyph, not just tall
	enough.

2008-06-02  Neil Roberts  <neil@o-hand.com>

	Applied 'final patch' from bug #874

	* clutter/cogl/gles/cogl.c:
	* clutter/cogl/gl/cogl.c: The clip planes are now set using the
	inverse projection matrix as the modelview matrix so that they can
	be specified in screen coordinates.

	* clutter/cogl/gles/cogl-context.h (CoglContext):
	* clutter/cogl/gl/cogl-context.h (CoglContext): Added a member to
	cache the inverse projection matrix

	* clutter/clutter-fixed.h: Added a constant for converting from
	radians to degrees.

	* clutter/clutter-fixed.c (clutter_atani, clutter_atan2i): Added
	fixed-point versions of atan and atan2.

	* tests/test-clip.c: Added a test for clipping with various
	rotations and depths.

	* tests/Makefile.am (noinst_PROGRAMS): Added test-clip

2008-06-02  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.h: The uniform numbers are
	now stored in a separate struct so they can be stored for
	application program objects as well.

	* clutter/cogl/gles/cogl.c: Moved stub shader functions into
	separate files.
	(_cogl_features_init): Report support for the shaders feature on
	GLES 2

	* clutter/cogl/gles/cogl-shader.h:
	* clutter/cogl/gles/cogl-shader.c:
	* clutter/cogl/gles/cogl-program.h:
	* clutter/cogl/gles/cogl-program.c: Separate files to handle
	shaders on programs on GLES. If version 1.1 is being used then the
	stub functions which all fail are still used.

	* clutter/cogl/gles/cogl-gles2-wrapper.c
	(cogl_gles2_wrapper_init, cogl_gles2_wrapper_bind_attributes),
	(cogl_gles2_wrapper_get_uniforms): Move the uniforms and attribute
	bindings into a separate function so they can be used to bind on
	application shaders as well.
	(cogl_gles2_wrapper_update_matrix): Now takes a parameter and is
	no longer static so that it can be used to update all of the
	matrices when a new shader is bound.

	* clutter/cogl/gles/cogl-defines.h.in: Use GL_COMPILE_STATUS for
	CGL_OBJECT_COMPILE_STATUS if the latter isn't available (for
	example on GLES 2).

	* clutter/cogl/gles/cogl-context.h (CoglContext): Added handle
	arrays for programs and shaders.

	* clutter/cogl/gles/cogl-context.c (cogl_create_context)
	(cogl_destroy_context): Initialize and destroy program and shader
	handle array.

	* clutter/cogl/gles/Makefile.am (libclutter_cogl_la_SOURCES): Add
	cogl-{shader,program}.{c,h}

2008-06-02  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gl/cogl-context.c (cogl_destroy_context): Fix
	cut-and-paste error where the wrong arrays were being freed.

2008-06-01  Emmanuele Bassi  <ebassi@openedhand.com>

	Merge from clutter-0-6:

	* clutter/clutter-model.c:
	(clutter_model_iter_set_internal_valist): Add an internal function
	wrapping ClutterModelIter::set_value that does not emit the
	::row-changed signal. Emitting this signal before the ::row-added
	one is wrong: a row cannot change before being inserted.

	(clutter_model_append), (clutter_model_prepend),
	(clutter_model_insert): Use the non-signal emitting variant of
	clutter_model_iter_set_valist().

	(clutter_model_iter_set_valist): Use the internal version and emit
	the ::row-changed signal at the end.

2008-05-31  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #943 - Signals are only emitted within a certain area of
		   the stage

	* clutter/clutter-main.c (clutter_do_event): Use the proper
	API and not the macros for the default stage, in case we are
	using a backend supporting multiple stages. (Julian Aron Prenner)

2008-05-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/pango/pangoclutter-fontmap.c:
	* clutter/pango/pangoclutter-renderer.c:
	* clutter/pango/pangoclutter.h
	* clutter/pango/pangoclutter-private.h: Add a function retrieving
	the font mipmapping setting.

2008-05-29  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.h (CoglGles2Wrapper): Added
	uniforms for alpha testing.

	* clutter/cogl/gles/cogl-gles2-wrapper.c
	(cogl_gles2_wrapper_init): Get the uniforms for alpha testing
	settings.
	(cogl_wrap_glEnable, cogl_wrap_glDisable): Enable/disable alpha
	testing.
	(cogl_wrap_glAlphaFunc): Filled in the wrapper.

	* clutter/cogl/gles/cogl-fixed-fragment-shader.glsl: Added alpha
	testing.

	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-gles2-wrapper.c
	(cogl_wrap_glGetIntegerv): Added a wrapper for glGetIntegerv so
	that it can report zero clip planes.

	* clutter/cogl/gles/cogl.c:
	* clutter/cogl/gles/cogl-texture.c: Use the wrapped version of
	glGetIntegerv

	* clutter/cogl/gles/cogl-primitives.c (_cogl_path_fill_nodes): Use
	_cogl_features_available to check for the stencil buffer instead
	of an #ifdef. The stencil buffer is available in the default
	profile for the GLES 2 simulator.

2008-05-29  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Check the --with switches as soon as we have them,
	to avoid further checks that will fail anyway.

2008-05-29  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: Update the configure arguments list.

2008-05-28  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.c
	(cogl_gles2_wrapper_init): Get uniforms for fog parameters and
	initialise them.
	(cogl_wrap_glDrawArrays): Store the modelview matrix in a uniform
	as well so that it can be used for fogging calculations.
	(cogl_wrap_glEnable, cogl_wrap_glDisable): Enable/disable fogging.
	(cogl_wrap_glFogx, cogl_wrap_glFogxv): Fill in wrapper to set
	fogging parameters.

	* clutter/cogl/gles/cogl-fixed-vertex-shader.glsl: Calculate the
	fog amount if fogging is enabled.

	* clutter/cogl/gles/cogl-fixed-fragment-shader.glsl: Mix with fog
	color.

	* clutter/cogl/gles/cogl-gles2-wrapper.h (CoglGles2Wrapper): Add
	uniforms for fogging.

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/pango/pangoclutter-font.c: Remove unneeded file.

	* tests/Makefile.am:
	* tests/test-random-text.c: Add a test for checking the
	glyph cache.

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #919 - Replacement pango renderer (Neil Roberts)

	* clutter/clutter-backend.h:
	* clutter/clutter-backend.c:
	(clutter_backend_set_font_options),
	(clutter_backend_get_font_options): Add the ability to set
	the cairo_font_options_t* for the backend at construction
	time, so that backend implementations can have their own
	options.

	* clutter/clutter-color.c: Include pango/pango-attributes.h
	for the pango_color_parse() function.

	* clutter/clutter-label.c:
	(clutter_label_ensure_layout),
	(clutter_label_init), (clutter_label_set_text),
	(clutter_label_set_font_name), (clutter_label_set_ellipsize),
	(clutter_label_set_use_markup): Ensure that the cache is
	always primed when the Label changes; this makes sure that
	the cache is rebuilt outside the paint run, which should
	make the painting perform better especially on embedded
	devices.

	* clutter/clutter-entry.c:
	(clutter_entry_ensure_layout),
	(clutter_entry_init), (clutter_entry_set_text),
	(clutter_entry_set_font_name): Ditto as above.

	* clutter/clutter-private.h:
	* clutter/clutter-main.[ch]: Create the font-map inside the
	main context; add two new functions:

	  clutter_clear_glyph_cache()
	  clutter_set_use_mipmapped_text()

	that control the glyphs cache.

	* clutter/pango/Makefile.am:
	* clutter/pango/pangoclutter-fontmap.c:
	* clutter/pango/pangoclutter-private.h:
	* clutter/pango/pangoclutter-render.c:
	* clutter/pango/pangoclutter.h: Rewrite the Pango renderer
	using a PangoCairo context and saving the glyphs inside a
	more efficient cache.

	* configure.ac: Depend on pangocairo instead of pangoft2.

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 882 - Allow child properties for containers implementing the
		  ClutterContainer interface (Øyvind Kolås)

	* clutter/clutter-child-meta.[ch]: Base class for the metadata
	of a ClutterActor inside a ClutterContainer; the ChildMeta
	object implements a wrapper for storing data that is attached
	to a ClutterActor only when it's part of a ClutterContainer.
	The ChildMeta object is used to store the child properties
	accessible through the ClutterContainer API.

	* clutter/clutter-container.[ch]: Creates the ChildMeta for
	each actor, in case the Container specifies the ChildMeta
	type to use.

	* clutter/Makefile.am: Add clutter-child-meta.[ch] to the build.

	* clutter/clutter-marshal.list: Add the marshaller for the
	ClutterContainer::child-notify signal.

	* clutter/clutter-types.h: Declare ClutterContainer and
	ClutterChildMeta to avoid recursive inclusion.

2008-05-28  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/Makefile.am: Use old-style Makefile rules for
	the stringify script so that automake won't complain.

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-script.c:
	* tests/test-script.json: Test merging the same actor from two
	different sources.

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	Fix merging of objects with the same id.

	* clutter/clutter-script.c:
	(json_object_end): If there already is an ObjectInfo under the
	parsed id, merge the construction with the currently stored
	state.

	(parse_children), (parse_signals),
	(parse_behaviours): Append the newly parsed children, signals
	and behaviours, in case the ObjectInfo already has unresolved
	items.

	(clutter_script_construct_object): Fix a typo in the type check.

	(clutter_script_init): Do not copy the key inside the hash
	table holding the objects - we are already holding it inside
	the value.

2008-05-28  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-gles2-wrapper.c (cogl_wrap_glGetFixedv):
	Filled in the wrapper for glGetFixedv

2008-05-28  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gles/cogl-texture.c: Use the wrapper for
	glTexParameteri. Call glGenerateMipmap after every change to the
	texture image data.

	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-gles2-wrapper.c: Added a wrapper for
	glTexParameteri so that it can ignore requests to set
	GL_GENERATE_MIPMAP. Added a wrapper for glGenerateMipmap that does
	nothing on GLES 1

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script.c:
	(clutter_script_construct_object): Mark top-level objects,
	that is objects that don't have their ownership transferred
	when building up a ClutterScript.

	(object_info_free): Merge a fix from the stable branch, but
	do not check the type - check whether the object is a top
	level (we still need the ClutterActor type check in order to
	call clutter_actor_destroy()).

2008-05-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-rectangle.c:
	(clutter_rectangle_paint): Remove commented out call to
	cogl_enable(); the call is not needed and the comment is
	in C99.

2008-05-27  Neil Roberts  <neil@o-hand.com>

	* clutter/eglx/clutter-stage-egl.h:
	* clutter/eglx/clutter-egl-headers.h:
	* clutter/eglx/clutter-backend-egl.h:
	* clutter/eglx/Makefile.am: Include the GLES and EGL headers via
	clutter-egl-headers.h so that the right version can be used
	depending on whether the GLES 2 wrapper is being used.

	* configure.ac: Added an automake conditional for whether the GLES
	2 wrapper should be used.

	* clutter/eglx/clutter-stage-egl.c (clutter_stage_egl_realize):
	Remove the call to glGetIntegerv to get the max texture size. It
	was being called before the GL context was bound so it didn't work
	anyway and it was causing trouble for the GLES 2 simulator.

	* clutter/cogl/gles/stringify.sh: Shell script to convert the
	shaders into a C string.

	* clutter/cogl/gles/cogl-gles2-wrapper.h:
	* clutter/cogl/gles/cogl-gles2-wrapper.c: Wrappers for most of the
	missing GL functions in GLES 2.

	* clutter/cogl/gles/cogl-fixed-fragment-shader.glsl:
	* clutter/cogl/gles/cogl-fixed-vertex-shader.glsl: New shaders for
	GLES 2

	* clutter/cogl/gles/cogl-defines.h.in: Use the @CLUTTER_GL_HEADER@
	macro instead of always using the GLES 1 header.

	* clutter/cogl/gles/cogl-context.h (CoglContext): Include a field
	for the state of the GLES 2 wrapper.

	* clutter/cogl/gles/cogl-texture.c:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/gles/cogl.c: Use wrapped versions of the GL
	functions where neccessary.

	* clutter/cogl/gles/Makefile.am: Add sources for the GLES 2
	wrapper and an extra build step to put the GLSL files into a C
	string whenever the files change.

2008-05-26  Matthew Allum  <mallum@openedhand.com>

	* clutter/x11/clutter-stage-x11.c: (clutter_stage_x11_request_coords):
	Dont allow the window to be resize to 0 dimentions. (fixes #933)

2008-05-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #912 - Invalid use of int* as parameter for glGetIntegerv

	* clutter/cogl/gl/cogl.c (_cogl_features_init): Use GLint
	instead of int. (#912, Tommi Komulainen)

2008-05-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #928 - Reparenting a child that itself is a container
	doesn't work

	* clutter/clutter-actor.c (clutter_actor_set_parent): Realize
	an actor when setting its parent, if the parent is realized.

	* clutter/clutter-group.c:
	(clutter_group_realize), (clutter_group_class_init): Add the
	missing implementation of the ::realize() virtual function; this
	makes sure that the children of a Group are realized if the Group
	is realized. (#928)

2008-05-21  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/gl/cogl.c (error_string):
	* clutter/cogl/gles/cogl.c (error_string): Rename to
	_cogl_error_string and remove the static scoping so that it can be
	called in cogl-texture etc.

	* clutter/cogl/gl/cogl-texture.c (cogl_texture_new_from_foreign):
	* clutter/cogl/gles/cogl-texture.c (cogl_texture_new_from_foreign):
	GE(*) can't be used to wrap around calls that use the return
	value.

	* clutter/cogl/gl/cogl-texture.c (_cogl_texture_quad_sw)
	(_cogl_texture_quad_hw, cogl_texture_polygon): Remove GE(*)
	wrapper around calls in the middle of a glBegin/glEnd pair which
	otherwise always generate an error because glGetError can only be
	called outside of the pair.

	* clutter/cogl/gl/cogl-internal.h: Include stdio.h when definig
	COGL_DEBUG and declare a prototype for _cogl_error_string.

	* clutter/cogl/gles/cogl-internal.h: Match GE(*) macro to GL
	version.

2008-05-21  Ivan Leben  <ivan@o-hand.com>

	* clutter/cogl/gles/cogl-texture.c:
	(_cogl_texture_download_from_gl:) Only comment out the broken
	check for framebuffer alpha bits, not the check for alpha in
	texture format.

2008-05-20  Øyvind Kolås  <pippin@o-hand.com>

	Decouple actor opacity from fill opacity in ClutterRectangle (fixes
	race when both are set from clutter script also makes it more
	consistent with the behavior of other actors.)

	* clutter/clutter-rectangle.c: (clutter_rectangle_set_color): stop
	setting the opacity of the actor from the specified color.
	(clutter_rectangle_paint): combine the absolute opacity of the actor
	with the alpha of the color when painting.

2008-05-20  Ivan Leben  <ivan@o-hand.com>

	* clutter/cogl/gles/cogl-texture.c:
	(cogl_texture_download_from_gl:) Implemented a workaround
	for missing alpha framebuffer channel. There are still
	some issues with detecting whether alpha is present in the
	framebuffer. See comments in code. Test-cogl-tex-getset now
	successfully retrieves a RGBA texture image data.

2008-05-19  Ivan Leben  <ivan@o-hand.com>

	* clutter/cogl/gles/cogl-texture.c:
	(cogl_texture_download_from_gl:) Store old blending factors
	and restore them when done. The lack of ability to retrieve
	the alpha channel now more noticable in test-cogl-tex-getset
	since the edges of the hand are not antialiased.

	* clutter/cogl/gl(es)/cogl-internal.h: Declare
	cogl_blend_func to avoid "implicit implementation" compile
	warning.

2008-05-19  Ivan Leben  <ivan@o-hand.com>

	* clutter/cogl/gl(es)/cogl.c: New internal function
	cogl_blend_func caches blending setup much like cogl_enable
	does with the enable flags. This separates blending factors
	setup from the enable/disable operation in preparation of
	the texture image retrieval fix for alpha channel on GLES.
	(cogl_enable:) Does not modify blending factors anymore.

	* clutter/cogl/gl(es)/cogl-context.h: CoglContext holds two
	new variables to cache blending src and dst factors.

	* clutter/cogl/gl(es)/cogl-context.c:
	(cogl_create_context:) Initialize blending factors.

	* clutter/cogl/gles/cogl-texture.c:
	(cogl_texture_download_from_gl:) Set blending factors to
	CGL_ONE, CGL_ZERO which fixes the slighlty improper behavior
	where source colour was actually multiplied with its alpha
	value in the result (not noticable on current tests).

2008-05-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglx/Makefile.am: Fix the INCLUDE directives to
	properly include the X11 backend headers.

	* clutter/glx/Makefile.am: Add the libclutter-x11.la static
	library to the LDADD directives.

2008-05-19  Tomas Frydrych  <tf@openedhand.com>

	* clutter/x11/clutter-x11.h:
	* clutter/glx/clutter-glx.h:
	Include texture pixmap headers.

2008-05-16  Neil Roberts  <neil@o-hand.com>

	* clutter/eglx/clutter-stage-egl.c (clutter_stage_egl_realize):
	Fix name of parent class variable which otherwise breaks the
	build.

2008-05-16  Neil Roberts  <neil@o-hand.com>

	Use the Mesa headers instead of depending on GLee for Win32
	builds.

	* configure.ac: No longer check for GLee

	* clutter/cogl/gl/cogl-defines.h.in: Don't bother including GLee.h

	* build/mingw/mingw-cross-compile.sh: No longer downloads libGLee
	but downloads the Mesa library instead and installs the headers
	from that. Fixed the libpng version.

2008-05-16  Tomas Frydrych  <tf@openedhand.com>

	* clutter/glx/Makefile.am:
	* clutter/x11/Makefile.am:
	Install glx and x11 specific includes into clutter/glx and
	clutter/x11 so that header files that include glx/*.h or x11/*.h
	when installed.

2008-05-16  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-event-win32.c (message_translate): Fix
	signedness of old_xpos and old_ypos to get rid of compiler
	warnings.

	* clutter/win32/clutter-backend-win32.c
	(clutter_backend_win32_get_features): Cast the result of
	glGetString to a signed char pointer to avoid compiler warnings.

2008-05-15  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-stage-win32.c:
	* clutter/win32/clutter-backend-win32.c: Reflect changes to the
	GLX/X11 backend in revisions 2708-2709 and 2713-2715 which
	simplify the backend a little.

2008-05-15  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-backend-x11.c:
	* clutter/clutter-event.h:
	* clutter/clutter-feature.h:
	* clutter/clutter-fixed.c:
	* clutter/clutter-model.h: Fix documentation.

	* clutter/eglnative/clutter-backend-egl.[ch]:
	* clutter/eglnative/clutter-event-egl.c: Add the same solution
	used for the SDL backend in order to get the time of an event.
	This should fix the motion event throttling and the click count
	on button press. (#906)

	* tests/test-pixmap.c (create_pixmap), (main): Fix preprocessor
	directives.

2008-05-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-threads.c: Add a "progress bar" actor and
	make the test take less amount of time to complete.

2008-05-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-events.c: Clean up a bit, and print out more
	messages when pressing one of the rectangles.

	* tests/test-threads.c: Be more verbose in the console, and
	apply another behaviour on the rectangle, to show that we
	are not blocking.

2008-05-14  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gles/cogl.c: (_cogl_features_init): do not set
	COGL_FEATURE_TEXTURE_READ_PIXELS, since it is not available.

2008-05-14  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-main.c:
	* clutter/clutter-private.h:
	Rejid Øyvind's previous commit a little moving more into
	clutter-main.c and using ClutterContext.
	Also Refactor clutter_init & clutter_init_with_args to share
	same core init code.

2008-05-13  Øyvind Kolås  <pippin@o-hand.com>

	Made it possible to do picking when the colors stored in the
	framebuffer are only approximately the correct value.

	* clutter/clutter-actor.c:
	(init_bits): initialize constants about how many bits are
	available/will be used for r,g,b components.
	(_clutter_pix_to_id): now own function, compute an id from a
	pixel into its own function (used from _clutter_do_pick).
	(_clutter_id_to_col): now own function, computes the color to use for
	a given id.
	(clutter_actor_paint): use clutter_id_to_col.
	* clutter/clutter-main.c:
	(_clutter_do_pick): use _clutter_pix_to_id
	(clutter_main): re-enable invocation of fruity app shell.

2008-05-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/fruity/clutter-stage-fruity.c:
	(clutter_stage_egl_show), (clutter_stage_egl_hide): Don't chain
	up and set flags, as it is not needed anymore.

	(clutter_stage_egl_realize): Set the REALIZED flag.

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_show), (clutter_stage_egl_hide): Don't chain
	up and set flags, as it is not needed anymore.

2008-05-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/glx/clutter-stage-glx.c:
	(clutter_stage_glx_unrealize): Move the shaders release from here...

	* clutter/glx/clutter-backend-glx.c:
	(clutter_backend_glx_dispose): ... to here. Shaders should be
	released when the GL context is being destroyed, and that only
	happens when the backend is being disposed, now that we support
	multiple stages.

2008-05-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-backend.c:
	(_clutter_backend_create_stage): Call _clutter_stage_set_window()
	ourselves, thus removing yet another action that backends must
	implement and might get wrong; also cuts a backend-agnostic piece
	of code duplication.

	* clutter/eglnative/clutter-backend-egl.c:
	(clutter_backend_egl_create_stage): Update the EGL native backend.

	* clutter/eglx/clutter-backend-egl.c:
	(clutter_backend_egl_create_stage): Update the EGLX backend.

	* clutter/fruity/clutter-backend-fruity.c:
	(clutter_backend_egl_create_stage): Update the fruity backend

	* clutter/glx/clutter-backend-glx.c:
	(clutter_backend_glx_create_stage): Update the GLX backend.

	* clutter/sdl/clutter-backend-sdl.c:
	(clutter_backend_sdl_create_stage): Update the SDL backend.

	* HACKING.backends: Update the ::create_stage() description.

2008-05-13  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-event-x11.c (event_translate): Remove the
	cheap Expose event compression, as it seems to play games when a
	composite manager is running. It's also not really needed, as
	the redraw queue will avoid redraws too close to each other
	anyway.

	* clutter/x11/clutter-stage-x11.c:
	(clutter_stage_x11_show), (clutter_stage_x11_hide): Do not chain
	up just to set the flags. This fixes a critical warning coming
	from ClutterActor::hide() default implementation.

2008-05-13  Ivan Leben  <ivan.leben@o-hand.com>

	* clutter/cogl/gl/cogl-defines.h.in:
	Fix GL function prototypes on OS X by #definining APIENTRY and
	APIENTRYP if missing.

2008-05-12  Ivan Leben  <ivan.leben@o-hand.com>

	* clutter/cogl/gl/cogl-defines.h.in:
	Defined GL extension functions used by Cogl inside the COGL_
	namespace.

	* clutter/cogl/gl/cogl-context.h:
	* clutter/cogl/gl/cogl.c:
	Use COGL_ extension function prototypes instead of relying
	on glext.h to define them. Should fix the mac compilability
	bug, but haven't tested it yet.

2008-05-12  Matthew Allum  <mallum@openedhand.com>

	* clutter/x11/clutter-x11-texture-pixmap.c:
	* configure.ac:
	* tests/Makefile.am:
	Remove the XComposite dep from Clutter itself, just use
	in test-pixmap (if available)

2008-05-12  Emmanuele Bassi  <ebassi@openedhand.com>

	Rework the stage wrapper/implementation relation: remove
	duplicated code and all the bookkeeping from the backends into
	ClutterStage whenever possible, to reduce the amount of	work a
	backend must do (and possibly get wrong). Thanks to Tommi
	Komulainen.

	* clutter/clutter-main.c:
	(clutter_init_with_args), (clutter_init): Realize the default
	stage after creation. The default stage is special, because we
	use it in the initialization sequence. This removes the burden
	from the backends and reduces the things a backend can get
	wrong.

	* clutter/clutter-stage.c:
	(clutter_stage_show): Make sure to realize the implementation if
	it hasn't been realized yet.

	(clutter_stage_realize): Set the REALIZED flag and call
	clutter_stage_ensure_current() if the implementation was
	successfully realized.

	(clutter_stage_unrealized): Call clutter_stage_ensure_current()
	on unrealize.

	* clutter/glx/clutter-backend-glx.c:
	(clutter_backend_glx_create_stage): Do not realize the stage anymore
	when creating it, and let the normal realization sequence take
	place.

	(clutter_backend_glx_ensure_context): Trap for X11 errors.

	* clutter/glx/clutter-stage-glx.c:
	(clutter_stage_glx_realize): Chain up to the X11 implementation
	so that we can set up the window state (title, cursor visibility)
	when we actually have a X window. Also, do not call
	clutter_stage_ensure_current(), and rely on the wrapper to do
	it for us. This means we can drop setting the REALIZED flag on
	the wrapper.

	(clutter_stage_glx_unrealize): Do not call
	clutter_stage_ensure_current() ourselves, and rely on the wrapper
	to do it for us.

	* clutter/x11/clutter-stage-x11.c:
	(set_wm_title),	(set_cursor_visible): Move the WM title and
	cursor visibility code inside their own functions.

	(clutter_stage_x11_realize): Set the window title and whether the
	cursor is visible or not after realizing the stage.

	(clutter_stage_x11_set_cursor_visible),
	(clutter_stage_x11_set_title): Call set_wm_title() and
	set_cursor_visible().

	(clutter_stage_x11_finalize): Free the title string.

	* clutter/x11/clutter-stage-x11.h: Save more of the stage state,
	so that we can set it even when the stage hasn't been realized
	yet.

	* clutter/eglnative/clutter-backend-egl.c:
	(clutter_backend_egl_create_stage):
	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_unrealize),
	(clutter_stage_egl_realize): Update the eglnative backend.

	* clutter/eglx/clutter-backend-egl.c:
	(clutter_backend_egl_ensure_context),
	(clutter_backend_egl_create_stage):
	* clutter/eglx/clutter-stage-egl.c:
	(clutter_stage_egl_unrealize),
	(clutter_stage_egl_realize): Update the eglx backend.

	* clutter/sdl/clutter-backend-sdl.c:
	(clutter_backend_sdl_create_stage):
	* clutter/sdl/clutter-stage-sdl.c:
	(clutter_stage_sdl_realize): Update the sdl backend.

	* clutter/fruity/clutter-backend-fruity.c:
	(clutter_backend_fruity_create_stage):
	* clutter/sdl/clutter-stage-fruity.c:
	(clutter_stage_fruity_realize): Update the fruity backend.

	* tests/test-multistage.c (on_button_press): Bail out if
	clutter_stage_new() returns NULL.

	* HACKING.backends: Update backend writing documentation.

2008-05-12  Robert Bragg  <bob@openedhand.com>

	* clutter/clutter-timeline.c:
	Adds clutter-timeline documentation RE: r2337, explaining
	the current timeline semantics.

2008-05-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* HACKING.backends: Update documentation.

	* clutter/glx/clutter-stage-glx.c:
	(clutter_stage_glx_realize): Avoid setting more flags than
	necessary.

2008-05-09  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-frame-source.c (clutter_frame_source_add)
	(clutter_frame_source_add_full): Add gtk-doc and rename the
	'function' parameter to 'func'.

	* clutter/clutter-frame-source.h: Rename the 'function' parameters
	to 'func'.

	* clutter/Makefile.am (source_h): Make clutter-frame-source.h a
	public header.

	* clutter/clutter-main.c (clutter_threads_add_frame_source_full):
	Improve gtk-doc

2008-05-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script-private.h: Add a flag for the
	default stage.

	* clutter/clutter-script.c:
	(json_object_end): If the "type" member is "ClutterStage"
	and we have a "is-default" member set to true then this
	is the default stage.

	(clutter_script_construct_object): Special case the default
	stage instead of each ClutterStage.

	(object_info_free): Ditto as above.

	* tests/test-script.json: Test the creation of a non-default
	stage and the ::destroy handler to quit.

2008-05-09  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #908 - Support transform from G_TYPE_INT to ClutterUnit

	* clutter/clutter-units.c:
	(clutter_value_transform_int_unit),
	(clutter_unit_get_type): Add GValue transformation function from
	integer values to ClutterUnit. (#908)

	(param_unit_validate): Fix validation for ClutterParamSpecUnit;
	this allows writable ClutterUnit properties.

	* clutter/clutter-fixed.c:
	(clutter_value_transform_int_fixed),
	(clutter_value_transform_double_fixed),
	(clutter_value_transform_float_fixed): Add GValue transformation
	functions from native types (int, double, float) to ClutterFixed.

	(clutter_fixed_get_type): Register the new transformation functions.

	(param_fixed_validate): Fix validation for ClutterParamSpecUnit;
	this allows writable ClutterFixed properties.

2008-05-07  Ivan Leben  <ivan@o-hand.com>

	* clutter/cogl/cogl.h.in:
	* clutter/cogl/gl(es)/cogl-texture.h:
	* clutter/cogl/gl(es)/cogl-texture.c:
	cogl_texture_new_* functions take a gboolean auto_mipmap argument.
	If TRUE automatic mipmap generation is enabled during the process
	of slice texture object creation.
	(cogl_texture_new_from_foreign:) now allows mipmap min filter
	flags.

	* clutter/clutter-texture.c:
	* clutter/glx/clutter-glx-texture-pixmap.c:
	* tests/test-cogl-offscreen.c:
	* tests/test-cogl-tex-tile.c:
	* tests/test-cogl-tex-convert.c:
	* tests/test-cogl-tex-polygon.c:
	* tests/test-cogl-tex-getset.c:
	Pass FALSE for auto_mipmap to cogl_texture_new_*.

	* clutter/pango/pangoclutter-render.c:
	(tc_get:) Pass TRUE to cogl_texture_new_with_size and use mipmap
	min filter for nicer glyphs at small scales. As a result test-text
	has gone all beautiful now.

2008-05-07  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-frame-source.h: Added the missing G_BEGIN_DECLS
	and G_END_DECLS

2008-05-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/sdl/clutter-backend-sdl.c:
	(clutter_backend_sdl_dispose): Destroy the timer that we created...
	(clutter_backend_sdl_init): ... here.

	* clutter/sdl/clutter-backend-sdl.h: Add a GTimer for time-based
	operations, like the event time.

	* clutter/sdl/clutter-event-sdl.c:
	(get_backend_time): Get the elapsed milliseconds for the SDL
	backend.

	(_clutter_events_init): Start the timer provided by the backend...
	(_clutter_events_uninit): ... and the stop it.

	(key_event_translate), (event_translate): Use the backend time
	to fill out the time field of the event structures. This fixes
	the motion notification throttling on the SDL backend.

2008-05-06  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	More cleanups, safety additions.

2008-05-05  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/common/cogl-primitives.c: moved declaration of
	gegl_rectangle and gegl_rectanglex here to satisfy linking
	requirements when building the fruity backend.

2008-05-05  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/cogl.h.in: api review touch ups.
	* clutter/cogl/common/cogl-primitives.c: api review touch ups.
	* clutter/cogl/gl/cogl-primitives.c: (cogl_path_fill),
	(cogl_path_stroke): indentation.
	* clutter/cogl/gles/cogl-primitives.c:
	(_cogl_path_fill_nodes): free allocated resources.

	* tests/test-cogl-primitives.c: updated to new API, added rotation to
	test to show that cogl renders paths correct under perspective
	distortion.

2008-05-02  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #900 - clutter_actor_lower() and friends do not queue redraw

	* clutter/clutter-actor.c:
	(clutter_actor_raise),
	(clutter_actor_lower): Queue a redraw after raising and lowering
	and actor in the paint order stack. (#900)

2008-05-01  Richard Purdie  <rpurdie@openedhand.com>

	* configure.ac:
	Set CLUTTER_COGL for fruity.

2008-05-01  Emmanuele Bassi  <ebassi@openedhand.com>

	Build fixes for the SDL flavour.

	* clutter/sdl/clutter-backend-sdl.c: Remove an unused function.

	* clutter/sdl/clutter-event-sdl.c:
	(clutter_event_dispatch): Properly cast the stage pointer.

	* clutter/sdl/clutter-stage-sdl.c:
	(clutter_stage_window_iface_init): Remove the draw_to_pixbuf()
	stub and assignment.

2008-05-01  Richard Purdie  <rpurdie@openedhand.com>

	* configure.ac:
	Fix up fruity flavour configure option.

2008-05-01  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gles/cogl-primitives.c: (_cogl_path_fill_nodes): draw
	the rasterized scanlines as an array of triangles.

2008-05-01  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour.c:
	(clutter_behaviour_remove_all): Disconnect the ::destroy
	handler when removing all actors, to match the behaviour
	of clutter_behaviour_remove().

2008-05-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* tests/test-pixmap.c:
	Fix up texture-pixmap, now works.
	Thanks to Neil for spotting we were actually using
	wrong texture type in fbconfig (COGL change).

2008-04-30  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gles/cogl-primitives.c: (_cogl_path_fill_nodes):
	keep track of direction we are drawing in and make sure we leave
	two intersection points when we have changed direction.

2008-04-30  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gles/cogl-primitives.c: (_cogl_path_fill_nodes):
	scanline rasterizer fallback for GLES without working stencil
	buffer (would benefit from optimization/smarter choice of
	datastructures).

2008-04-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-effect.c:
	(clutter_effect_closure_destroy): Do not remove the actor
	from the behaviour; the behaviour is an internal detail of the
	effect, and it will remove the actors anyway when finalized
	when g_object_unref() is called. This should guard against
	actors being destroyed while an effect is running.

2008-04-30  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/common/Makefile.am:
	* clutter/cogl/common/cogl-primitives.c:
	* clutter/cogl/common/cogl-primitives.h:
	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gl/cogl-primitives.h:
	* clutter/cogl/gles/Makefile.am:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/gles/cogl-primitives.h: moved duplicated code to the
	common directory.

2008-04-30  Robert Bragg  <bob@openedhand.com>

	* clutter/clutter/x11/clutter-x11-texture-pixmap.c:
	In _update_area_real with depth=16 we weren't setting up the alpha
	channel.

2008-04-29  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/Makefile.am:
	* clutter/x11/Makefile.am:
	Revert header install locations (Mistake in previous commit,
	fixes #898)

2008-04-29  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-actor.c (clutter_actor_move_anchor_point): The
	actor position was being moved in the wrong direction. Perhaps
	this was a cut-and-paste bug from move_anchor_point_from_gravity
	because in that function ax and ay represent the old anchor
	position, but in this function they represent the new.

2008-04-29  Matthew Allum  <mallum@openedhand.com>

	* clutter/glx/Makefile.am:
	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/glx/clutter-glx-texture-pixmap.h:
	* clutter/x11/Makefile.am:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	* tests/test-pixmap.c:
	Commit newer x11 texture pixmap stuff (optionally using SHM).
	Also seemingly still broken overhauled glx-texture-pixmap
	(code by Robert and myself)

	* configure.ac:
	Minor formatting change.

2008-04-29  Neil Roberts  <neil@o-hand.com>

	Removed COGLhandle and changed shader and program functions to be
	wrapped in reference-counted CoglHandles instead.

	* clutter/cogl/gl/cogl-shader.c:
	* clutter/cogl/gl/cogl-shader.h:
	* clutter/cogl/gl/cogl-program.c:
	* clutter/cogl/gl/cogl-program.h:
	New files to hold the shader and program functions.

	* clutter/cogl/gl/cogl.c: Removed shader and program functions.

	* clutter/cogl/common/cogl-handle.h: New header to define
	COGL_HANDLE_DEFINE which helps build functions to create
	reference-counted handles. This reduces the amount of duplicated
	code.

	* clutter/cogl/gl/cogl-texture.c:
	* clutter/cogl/gles/cogl-texture.c:
	* clutter/cogl/gl/cogl-fbo.c: Converted to use COGL_HANDLE_DEFINE
	from cogl-handle.h to avoid duplicating some of the common code.

	* clutter/cogl/gles/cogl-defines.h.in:
	* clutter/cogl/gl/cogl-defines.h.in: Removed COGLhandle

	* clutter/cogl/gl/cogl-context.h: Added handle arrays for programs
	and shaders.

	* clutter/cogl/gl/cogl-context.c (cogl_create_context): Added
	initialisers for shader_handles and program_handles.
	(cogl_destroy_context): Added calls to g_array_free for all handle
	arrays.

	* clutter/cogl/gl/Makefile.am (libclutter_cogl_la_SOURCES): Added
	cogl-{program,shader}.{c,h}

	* clutter/cogl/common/Makefile.am
	(libclutter_cogl_common_la_SOURCES): Added cogl-handle.h

	* clutter/cogl/gles/cogl.c:
	* clutter/cogl/cogl.h.in: Programs and shaders are now wrapped in
	CoglHandles instead of COGLhandles. cogl_program_destroy and
	cogl_shader_destroy is now replaced with cogl_program_unref and
	cogl_shader_unref. cogl_program_ref and cogl_shader_ref are also
	added.

	* clutter/clutter-shader.c: Converted to use CoglHandles for the
	programs and shaders instead of COGLhandles.

2008-04-29  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/cogl.h.in: renaming of API's in cogl to make the
	primitives and path API a bit smaller and more resembling cairo.
	* clutter/cogl/gl/cogl-primitives.c:
	* clutter/cogl/gles/cogl-primitives.c:
	* clutter/cogl/gles/cogl.c:

	* clutter/clutter-actor.c:
	* clutter/clutter-rectangle.c:
	* tests/test-cogl-offscreen.c:
	* tests/test-cogl-primitives.c:
	* tests/test-cogl-tex-convert.c:
	* tests/test-cogl-tex-foreign.c:
	* tests/test-cogl-tex-getset.c:
	* tests/test-cogl-tex-tile.c: updated according to changes in cogl.

2008-04-29  Robert Bragg  <bob@o-hand.com>

	* clutter/x11/clutter-x11-texture-pixmap.c:
	In clutter_x11_texture_pixmap_set_pixmap, dont assume that the actor
	size should be changed to match the size of the pixmap.

2008-04-29  Robert Bragg  <bob@o-hand.com>

	* clutter/cogl/gles/cogl-texture.c:
	Replaces an malloc call with g_malloc.

2008-04-29  Robert Bragg  <bob@o-hand.com>

	* clutter/configure.ac:
	When looking for a GLES 1 library, also try the name "GLESv1_CM".

	This also reduces the xfixes version requirement to v3, since we dont
	need support for Show/HideCursor.

2008-04-28  Neil Roberts  <neil@o-hand.com>

	Fixed 'make dist'

	* clutter/cogl/Makefile.am (EXTRA_DIST): Distribute cogl.h.in
	instead of cogl.h
	(DIST_SUBDIRS): Added common folder

	* clutter/cogl/gl/Makefile.am (libclutter_cogl_la_SOURCES): Remove
	cogl-defines.h and use the right location for cogl-defines.gl.h
	(EXTRA_DIST): Distribute cogl-defines.h.in

	* clutter/cogl/gles/Makefile.am (libclutter_cogl_la_SOURCES):
	Remove cogl-defines.h and use the right location for
	cogl-defines.gles.h
	(EXTRA_DIST): Distribute cogl-defines.h.in

	* clutter/Makefile.am (DIST_SUBDIRS): Add fruity

2008-04-28  Neil Roberts  <neil@o-hand.com>

	* clutter/cogl/cogl.h.in (COGL_A_BIT): Added the missing comma
	after COGL_PIXEL_FORMAT_G_8

2008-04-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* autogen.sh: Do not just touch the gtk-doc.make file, if we
	could not find gtkdocize, but echo an empty EXTRA_DIST into it
	so that the automake won't complain later on.

2008-04-28  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/cogl.h.in: reindented.

2008-04-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(parse_rotation_array),
	(clutter_actor_set_custom_property): Use the internal, unit based
	rotation setter when parsing the rotation from a ClutterScript
	file.

	(clutter_geometry_copy),
	(clutter_vertex_copy),
	(clutter_actor_box_copy): Use the more efficient g_slice_dup().

	(clutter_actor_get_stage): Add documentation.

	* clutter/clutter-group.c: Documentation fix.

2008-04-28  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/cogl.h.in: moved the documentation of the cogl
	primitives to the main public header.
	* clutter/cogl/gl/cogl-primitives.c: from here ..
	* clutter/cogl/gles/cogl-primitives.c: .. _and_ here.

2008-04-28  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/cogl.h.in: added documentation.

2008-04-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-units.c (param_unit_init): Use the right
	macros to set the default minimum and maximum values.

	* clutter/clutter-fixed.c (param_fixed_init): Ditto as above.

2008-04-28  Matthew Allum  <mallum@openedhand.com>

	* autogen.sh:
	Dont display 'make' if configure fails.
	* configure.ac:
	Add new --with-gles version option for eventual GLES2 support
	Also minor tidyups.

2008-04-28  Neil Roberts  <neil@o-hand.com>

	* tests/test-cogl-tex-polygon.c: Added buttons to toggle whether
	slicing and linear filtering is enabled. By default slicing is
	disabled to help test on GL ES.

2008-04-28  Neil Roberts  <neil@o-hand.com>

	* tests/Makefile.am (INCLUDES): Added $(top_srcdir)/clutter to the
	include path. Otherwise the tests will fail to build trying to
	include "json/json-types.h" when building out-of-tree.

2008-04-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-backend-egl.c:
	(clutter_backend_egl_redraw): Whitespace fixes.

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_hide): Indentation fixes.

	(clutter_stage_egl_realize): Use g_critical() to report failure,
	unset the flags and bail out instead of continuing the realization
	of the stage.

2008-04-25  Neil Roberts  <neil@o-hand.com>

	Merged in the clutter-ivan branch which contained the new public
	COGL API.

2008-04-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/sdl/clutter-stage-sdl.[ch]: Port the SDL stage to
	the new stage implementation API.

	* clutter/sdl/clutter-backend-sdl.[ch]: Port the SDL backend
	to the new backend API.

	* clutter/sdl/clutter-event-sdl.c:
	(clutter_event_dispatch): Assign the default stage as the
	origin of the event.

2008-04-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Add the --with-json configure switch to
	allow building Clutter with the external dependency on
	the system JSON-GLib; the default is to use the internal
	copy unless explicitly asked to check.

2008-04-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* Makefile.am: Add HACKING.backends to the EXTRA_DIST.

2008-04-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* HACKING.backends: Add documentation on how to write a
	backend for Clutter.

2008-04-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-backend-egl.c:
	(clutter_backend_egl_create_stage): Fix checks using a
	non assigned member of the ClutterBackendEGL structure.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglnative/clutter-backend-egl.[ch]:
	* clutter/eglnative/clutter-stage-egl.[ch]:
	* clutter/eglnative/clutter-event-egl.c: Port to the new stage
	and backend APIs. *WARNING* untested and not compiled.

	* clutter/eglx/clutter-backend-egl.c:
	(clutter_backend_egl_init): Set some defaults.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-script.json: Remove the explicit "visible"
	member to test that the visibility of actors is TRUE
	by default.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* clutter/Makefile.am: Do not build the internal JSON-GLib
	copy if there is a system installed one.

	* clutter/clutter-json.h: Remove.

	* clutter/clutter-json.h.in: Template for the clutter-json.h
	header file, used to opaquely include the JSON-GLib types.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Document :show-on-set-parent and
	the fact that calling clutter_actor_show() and hide() on an
	unparented actor will change that property as well as a side
	effect.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_set_property): Use the
	internal setter for the rotation center.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.[ch]: Add units based variant of the
	rotation accessors.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 892 - Incorrect results using rotation-[center|angle] properties

	* clutter/clutter-actor.c:
	(clutter_actor_set_rotation_internal): Inline function for setting
	the rotation using fixed point for the angle and units for the
	center of rotation.

	(clutter_actor_set_property),
	(clutter_actor_set_rotationx): Use the internal setter to avoid
	loss of precision and too many conversions to and from units.

2008-04-23  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug 891 - assertion failed when test-behave exits

	* clutter/clutter-behaviour.c:
	(remove_actor_on_destroy),
	(clutter_behaviour_apply),
	(clutter_behaviour_remove): Remove the actor if it gets
	destroyed before the behaviour.

2008-04-18  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #884 - Add clutter_alpha_set_closure

	* clutter/clutter-alpha.[ch]: Add clutter_alpha_set_closure(),
	a GClosure variant of clutter_alpha_set_func(), and reimplement
	the latter as a special case of the former. (#884, Xan López)

2008-04-18  Neil Roberts  <neil@o-hand.com>

	* clutter/clutter-timeline.c (clutter_timeline_get_progressx):
	Changed to use clutter_qdiv instead of CLUTTER_FIXED_DIV otherwise
	it can't cope with timelines with more than 255 frames.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-frame-source.c: Small coding style fixes.

2008-04-17  Neil Roberts  <neil@o-hand.com>

	Applied patch from bug #881

	* clutter/clutter-frame-source.h:
	* clutter/clutter-frame-source.c:
	New files that contain a replacement for g_timeout that try to
	cope with system delays.

	* clutter/Makefile.am: Added clutter-frame-source.{c,h}

	* clutter/clutter-timeline.c (timeout_add): Use a frame source
	instead of a g_timeout.

	* clutter/clutter-main.c (clutter_threads_add_frame_source_full)
	(clutter_threads_add_frame_source): New public functions to wrap a
	frame source and grab the Clutter mutex.

	* clutter/clutter-timeout-pool.c: Now calculates the timeout
	expiration times in the same way as a frame source does so that it
	counts time in frame intervals instead of setting the next
	expiration time as an offset from the current time.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-fixed.c:
	(clutter_value_transform_fixed_int),
	(clutter_value_transform_fixed_double),
	(clutter_value_transform_fixed_float),
	(clutter_fixed_get_type): Add GValue transformation functions
	for ClutterFixed; copying a CLUTTER_TYPE_FIXED GValue into
	a G_TYPE_FLOAT/G_TYPE_DOUBLE one will automatically transform
	the fixed point representation into a floating point one. Also
	add the G_TYPE_INT transformation function to do a plain
	fixed->int copy.

	* clutter/clutter-units.c:
	(clutter_value_transform_unit_int),
	(clutter_unit_get_type): Add a unit->int transformation function.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-fixed.c (clutter_value_get_fixed): Fix typo
	in the function name.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-units.c (clutter_value_get_unit): Fix typo
	in the function name.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* HACKING: Amend coding style and tenets, as it is now possible
	to install and use unit based properties in a safe way.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-units.h:
	* clutter/clutter-fixed.h: Add boundaries for fixed point
	and units values.

	* doc/reference/clutter-sections.txt: Update the documentation.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* autogen.sh: Try to continue even if we don't have gtk-doc
	installed; this will obviously won't work if you don't pass
	--disable-docs --disable-gtk-doc to autogen.sh as well.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-fixed.[ch]: Add a ClutterFixed fundamental
	type, and wrappers for storing it into GValues; also add a
	GParamSpec subclass for defining parameters holding
	ClutterFixed values. This allows creating GObject properties
	using fixed point values.

	* doc/reference/clutter-sections.txt: Document the newly
	added API.

2008-04-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/Makefile.am: Add clutter-units.c

	* clutter/clutter-units.[ch]: Add a ClutterUnit fundamental
	type, and wrappers for storing it into GValues; also add a
	GParamSpec subclass for defining parameters holding ClutterUnit
	values. This allows creating GObject properties using units.

	* doc/reference/clutter-sections.txt: Document the newly
	added API.

2008-04-15  Matthew Allum  <mallum@openedhand.com>

	Work related to #873;

	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-backend-glx.h:
	* clutter/x11/clutter-x11-texture-pixmap.c:
	* clutter/x11/clutter-x11-texture-pixmap.h:
	General cleanup of texture pixmap code, adding;
	  - Pixmap dimentions and depth now auto probed, read only props.
	  - More X safety traps
	  - Add support for optionally tracking damage and automatically
	    updating texture.

	* clutter/glx/clutter-glx-texture-pixmap.c:
	* clutter/glx/clutter-glx-texture-pixmap.h:
	General cleanup and some safety additions. Needs more work so
	'proper' subclass - dependent on new COGL.

	* clutter/x11/clutter-backend-x11.c: (clutter_x11_remove_filter):
	Invert g_return_if check.

	* configure.ac:
	Pull in XComposite and XDamage (at least for now)

	* tests/Makefile.am:
	* tests/test-pixmap.c:
	Add a modified test from Johan for above.

2008-04-15  Neil Roberts  <neil@o-hand.com>

	Added support for foreign windows to the Win32 backend.

	* clutter/win32/clutter-stage-win32.c
	(clutter_stage_win32_request_coords): Don't resize foreign
	windows.
	(clutter_stage_win32_unrealize): Don't destroy foreign windows.
	(clutter_stage_win32_init): Added initialiser for is_foreign_win.
	(clutter_win32_get_stage_from_window): Resort to looking in the
	stage list if the window isn't the right window class so that it
	can still find stages with foreign windows.
	(clutter_win32_set_stage_foreign): New public function to set a
	foreign window for a stage.

	* clutter/win32/clutter-event-win32.c
	(clutter_win32_disable_event_retrieval): New public function to
	disable event retrieval.
	(message_translate): Don't handle WM_SIZE or WM_MOVE for foreign
	windows.

	* clutter/win32/clutter-backend-win32.h (struct
	_ClutterBackendWin32): Added a flag to disable event retrieval

	* clutter/win32/clutter-backend-win32.c
	(clutter_backend_win32_ensure_context): Update debug note to
	include whether the stage is foreign or not.

2008-04-15  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-actor.c: (clutter_actor_set_shader_param): queue a
	redraw when a shader_param is set. Normalized some gtk-doc syntax in
	some of the api documentation.

2008-04-15  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-group.c: fixed typo in docs.

2008-04-14  Matthew Allum  <mallum@openedhand.com>

	* clutter/eglx/clutter-stage-egl.c:
	Actually set wm protocols on eglx stage windows. Fixes issues with
	cloising stages and cleanup.

2008-04-14  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gles/cogl.c: (cogl_color):
	Disable use of color4ub, issues with latest MBX SDL (#857)

	* clutter/eglx/clutter-backend-egl.c:
	* clutter/eglx/clutter-stage-egl.c:
	* configure.ac:
	Fixup for the eglx backend to work with new backend/multistage code.
	Some issues remain in destroying stages.

2008-04-14  Neil Roberts  <neil@o-hand.com>

	Bug #853

	* clutter/clutter-timeline.c (clutter_timeline_get_progressx): Fix
	arithmetic for calculating the reverse progress when the timeline
	is backward. (Should subtract from one instead of taking the
	reciprocal).

2008-04-13  Neil Roberts  <neil@o-hand.com>

	Upgraded the Win32 backend to work with the multi-stage
	subclassing code.

	* clutter/win32/clutter-stage-win32.h:
	* clutter/win32/clutter-stage-win32.c: Now inherits from
	ClutterGroup and implements ClutterStageWindow instead of
	inheriting directly from ClutterStage.

	* clutter/win32/clutter-event-win32.c (message_translate): Now
	takes an extra parameter to return whether DefWindowProc should be
	called. This is needed to prevent the default WM_CLOSE handler
	from destroying the window.

	* clutter/win32/clutter-backend-win32.c
	(clutter_backend_win32_dispose): Destroy all of the stages using
	g_slist_foreach as per bug #871. Now also destroys the GL context.
	(clutter_backend_win32_get_features): Added assertions to ensure
	there is a valid GL context.
	(clutter_backend_win32_ensure_context): Accepts NULL stage. Gets
	implementation pointer from the stage.

2008-04-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-container.c:
	(clutter_container_get_type): Relax the precondition on the
	implementations of ClutterContainer from ClutterActor to
	GObject.

2008-04-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: Add a note about the Shader API changes.

	* clutter/clutter-deprecated.h: Add deprecation symbols.

	* clutter/clutter-shader.[ch]: Rename the :bound read-only
	property to :compiled. Also rename clutter_shader_bind()
	and clutter_shader_is_bound() to clutter_shader_compil() and
	clutter_shader_is_compiled(), respectively.

	* clutter/glx/clutter-stage-glx.c:
	(clutter_stage_glx_unrealize): Update after
	clutter_shader_release_all() rename.

	* tests/test-shader.c (button_release_cb), (main): Update.

2008-04-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglx/clutter-backend-egl.c:
	(clutter_backend_egl_ensure_context): Sync up with the GLX
	backend.

	(clutter_backend_egl_create_stage): Dumb compilation fix.

	* clutter/glx/clutter-backend-glx.c:
	(clutter_backend_glx_create_stage): Unref the stage if we are
	erroring out.

2008-04-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/eglx/clutter-stage-egl.c:
	(clutter_stage_egl_realize): Sync up with the GLX backend.

2008-04-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/Makefile.am: Update the regular expression to match
	all the namespaces we actually use. Thanks to Neil Roberts for
	spotting this. A make distclean is needed.

	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gles/Makefile.am:
	* clutter/json/Makefile.am:
	* clutter/pango/Makefile.am: Revert previous commit.

2008-04-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/cogl/Makefile.am:
	* clutter/cogl/gl/Makefile.am:
	* clutter/cogl/gles/Makefile.am:
	* clutter/json/Makefile.am:
	* clutter/pango/Makefile.am: Fix the visibility of all the
	symbols, for the main library and the statically linked ones.

2008-04-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* autogen.sh: Clean up a bit

	* clutter/clutter-fixed.[ch]:
	(clutter_double_to_fixed),
	(clutter_double_to_int),
	(clutter_double_to_uint): Make these functions public, as they
	are expanded by their respective macros. This fixes the errors
	from the linker trying to resolve their name.

2008-04-09  Neil Roberts  <neil@o-hand.com>

	Applied patch from bug #871

	* clutter/x11/clutter-backend-x11.c (clutter_backend_x11_dispose):
	Call g_slist_foreach instead of iterating over the stage_manager
	list manually when deleting stages. Otherwise the 'next' pointer
	of the list node can get corrupted when the actor removes itself
	from the list.

	* clutter/clutter-stage.c (clutter_stage_dispose): Call
	clutter_actor_unrealize in the dispose handler. This fixes
	problems where the dispose handler for the ClutterStageWrapper
	can't deselect the GL context until the stage is unrealized.

2008-04-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-backend.c: Add more debug messages

	* clutter/clutter-stage.h:
	* clutter/clutter-stage.c:
	(clutter_stage_is_default): Add a function to check if the
	stage is the default one.

	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-stage-glx.c:
	* clutter/x11/clutter-stage-x11.c: Keep the stage wrapper
	and implementation flags in sync, to ensure that the GL
	context is always set.

2008-04-04  Neil Roberts  <neil@o-hand.com>

	* README: Fixed typo

2008-04-04  Matthew Allum  <mallum@openedhand.com>

	* README:
	Add a note on new show-on-set-parent prop and stage subclassing.

2008-04-04  Emmanuele Bassi  <ebassi@openedhand.com>

	Bug #864 - Allow instantiating and subclassing of ClutterStage

	* clutter/Makefile.am: Add clutter-stage-window.[ch]

	* clutter/clutter-stage-manager.c:
	(_clutter_stage_manager_remove_stage): Do not warn if removing
	a stage we don't manage, as we might be invoked multiple times
	during a ClutterState dispose sequence.

	* clutter/clutter-actor.c:
	* clutter/clutter-backend.[ch]:
	* clutter/clutter-main.c:
	* clutter/clutter-private.h:
	* clutter/clutter-stage.[ch]: Make ClutterStage a proxy actor,
	with a private actor implementing the ClutterStageWindow
	interface for handling the per-backend realization, painting
	and unrealization, plus all the windowing system abstraction.

	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-stage-x11.[ch]: Port the X11 backend
	to the new backend and stage API and semantics.

	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-stage-glx.c: Port the GLX backend to
	the new backend and stage API and semantics.

	* clutter/eglx/clutter-backend-egl.[ch]:
	* clutter/eglx/clutter-stage-egl.[ch]: Port the EGLX backend
	to the new backend and stage API and semantics (untested).

	* tests/test-multistage.c (on_button_press): Rename
	clutter_stage_create_new() to clutter_stage_new().

2008-04-04  Neil Roberts  <neil@o-hand.com>

	Applied patch from bug #810.

	* clutter/x11/clutter-event-x11.c (event_translate): Set a flag
	when resizing the stage from a ConfigureNotify event.

	* clutter/x11/clutter-stage-x11.c
	(clutter_stage_x11_request_coords): Don't try to resize the window
	again if the flag is set.
	(clutter_stage_x11_init): Added initialiser for the flag.

	* clutter/x11/clutter-stage-x11.h (struct _ClutterStageX11): Added
	the flag.

2008-04-04  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	Remove uneeded stage private member.
	Add show-on-set-parent prop and make so by default Actors are
	now automatically shown when reparented (#791)

	* clutter/eglx/clutter-backend-egl.c:
	* clutter/cogl/gles/cogl.c:
	A couple of minor comments.

	* clutter/eglnative/Makefile.am:
	Add missing clutter-egl.h header (back port from trunk)

	* tests/test-actors.c:
	Modify to take advantage of new show-on-set-parent functionality.

2008-04-03  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/Makefile.am: Only export symbols matching "^clutter.*",
	to avoid exposing the library-private symbols starting with
	an underscore.

2008-04-03  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-alpha.c: ClutterAlpha is an InitiallyUnowned
	subclass. This should fix a lot of leakage. (#860, Neil Roberts)

2008-04-03  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/glx/clutter-backend-glx.c:
	(clutter_backend_glx_get_features): Assert if we don't have a
	GL context here or if it's not matched to a drawable. Asserting
	might seem too drastic, but if we don't have a valid GL context
	here then Clutter will segfault anyway, and I'll take an assert()
	over a hard to read, deep in GLX guts backtrace any day (and
	twice on a monday).

	* clutter/x11/clutter-backend-x11.c:
	(clutter_backend_x11_get_features): No need for a variable here.

2008-04-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-backend.c:
	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-stage-glx.c:
	Allow NULL to be passed to _clutter_backend_ensure_context
	which essentially clears GL context. This is hooked into stage
	unrealisation.  Isn't yet quite bulletproof.
	Fixes issues with gtk-embed crasher (thanks to Neil).

2008-04-1  Robert Bragg  <bob@o-hand.com>

	* clutter/glx/clutter-glx-texture-pixmap.c:
	In clutter_glx_texture_pixmap_dispose; trap X errors around
	glXDestroyGLXPixmap so we can't die due to BadDrawable errors.

2008-03-31  Matthew Allum  <mallum@openedhand.com>

	* README:
	Add notes on new multistage feature.

	* clutter/clutter-stage-manager.c:
	Dont ref contained stages.

	* clutter/clutter-stage.c:
	Automatically remove stage from stage manager on finalisation.
	Cleans up warnings when a stage is destroyed.

	* clutter/clutter-backend.h:
	* clutter/glx/clutter-backend-glx.c:
	Minor formatting cleanups.

	* clutter/glx/clutter-stage-glx.c:
	* configure.ac:
	* clutter/clutter-version.h.in:
	Add a general CLUTTER_STAGE_TYPE define, should be useful for
	evntual stage subclassing and creating with g_object_new()

2008-03-30  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-backend-win32.c
	(clutter_backend_win32_init): Added a call to
	timeBeginPeriod. Without this the frame rates are terrible because
	the glib timeouts are not accurate enough. However this requires
	Glib >= 2.16.0 to take any effect because of a change in the way
	g_poll is implemented. See revision 6597 of glib.
	(clutter_backend_win32_finalize): Added a call to timeEndPeriod.

	* configure.ac: Added -lwinmm to the library dependencies for the
	Win32 backend.

2008-03-30  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-win32.h:
	* clutter/win32/clutter-stage-win32.h:
	* clutter/win32/clutter-stage-win32.c:
	* clutter/win32/clutter-event-win32.c:
	* clutter/win32/clutter-backend-win32.h:
	* clutter/win32/clutter-backend-win32.c:
	Upgraded for multi-stage support.

	* clutter/win32/clutter-stage-win32.c
	(clutter_stage_win32_request_coords): Fixed so that it doesn't set
	the position or size if it hasn't changed. This was causing
	problems when the window was resized using the top left corner. In
	that case the window receives resize and move messages separately
	which caused the window to flash at a different size or position
	while one message was handled before the other.
	(clutter_stage_win32_realize): Added PFD_GENERIC_ACCELERATED to
	the list of pixel format flags to force it to use hardware
	acceleration.

2008-03-28  Matthew Allum  <mallum@openedhand.com>

	* clutter/Makefile.am:
	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* clutter/clutter-backend.c:
	* clutter/clutter-backend.h:
	* clutter/clutter-debug.h:
	* clutter/clutter-event.c:
	* clutter/clutter-event.h:
	* clutter/clutter-feature.h:
	* clutter/clutter-group.h:
	* clutter/clutter-main.c:
	* clutter/clutter-main.h:
	* clutter/clutter-private.h:
	* clutter/clutter-stage.c:
	* clutter/clutter-stage.h:
	* clutter/clutter-stage-manager.c
	* clutter/clutter-stage-manager.h
	* clutter/clutter-types.h:
	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-backend-glx.h:
	* clutter/glx/clutter-stage-glx.c:
	* clutter/glx/clutter-stage-glx.h:
	* clutter/x11/clutter-backend-x11.c:
	* clutter/x11/clutter-backend-x11.h:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-stage-x11.c:
	* clutter/x11/clutter-x11.h:
	* tests/Makefile.am:
	* tests/test-multistage.c:
	Initial commit of multi stage support (mostly a merge from the
	clutter-multistage branch).
	Note, this commit will break all backends except glx.

2008-03-26  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-win32.h: Added gtk-doc documentation for
	the Win32 backend section.

	* clutter/win32/clutter-stage-win32.c
	(clutter_win32_get_stage_window): Fixed punctuation in the
	documentation.

	* README: Added notes about the Win32 backend.

2008-03-26  Neil Roberts  <neil@o-hand.com>

	* clutter/win32/clutter-event-win32.c (clutter_event_check):
	Removed the pointless parameter in the call to check_msg_pending.
	(check_msg_pending): Fixed to use PeekMessageW instead of
	PeekMessage.

2008-03-25  Neil Roberts  <neil@o-hand.com>

	Added a native Win32 WGL backend.

	* configure.ac: Added the 'win32' flavour.

	* clutter/cogl/gl/cogl.c (cogl_get_proc_address): Added an ifdef
	to use wglGetProcAddress with the Win32 backend.

	* clutter/Makefile.am (DIST_SUBDIRS): Added the win32 directory.

	* clutter/win32/clutter-win32.pc.in:
	* clutter/win32/clutter-win32.h:
	* clutter/win32/clutter-stage-win32.h:
	* clutter/win32/clutter-stage-win32.c:
	* clutter/win32/clutter-event-win32.c:
	* clutter/win32/clutter-backend-win32.h:
	* clutter/win32/Makefile.am:
	* clutter/win32/clutter-backend-win32.c: New files.

2008-03-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.[ch]: Add a ::copy() virtual function
	for copying iterators.

	* clutter/clutter-list-model.c:
	(clutter_list_model_iter_copy),
	(clutter_list_model_iter_class_init): Implement the ::copy()
	function inside the ListModel iterator subclass.

2008-03-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-group.c:
	* clutter/clutter-texture.c: Use CLUTTER_ACTOR_IS_VISIBLE()
	and not CLUTTER_ACTOR_IS_MAPPED().

2008-03-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.[ch]: Small clean ups and refactoring.
	Use gulong instead of guint, so we have a bigger id space for
	the timelines inside a Score.

2008-03-19  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-actor.c:
	(_clutter_actor_apply_modelview_transform), (clutter_actor_paint):
	Apply clip inside paint function instead of transform function

2008-03-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.c: Update documentation.

2008-03-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.[ch]: Remove all the API changes, and
	just add a clutter_score_append_at_marker(); the implementation
	remains the same, but the marker must be explicitly created by
	the developer. The ids are no longer used to create implicit
	markers, so they can return to be unsigned integers. (#450)

	* clutter/clutter-timeline.[ch]:
	(clutter_timeline_has_marker): Add a function to query a timeline
	for a marker being set.

	* tests/test-score.c (main): Update with the API changes.

	* clutter.symbols: Update exported symbols.

2008-03-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c: Small clean ups in the coding style.

2008-03-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add new symbols

	* clutter/clutter-score.[ch]: Use the newly added marker API
	on the timelines to implement attaching timelines at specific
	points, using either milliseconds or frames.

	* tests/test-score.c (main): Test the new API.

2008-03-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-marshal.list: Add signature for the
	::marker-reached signal marshaller.

	* clutter/clutter-timeline.[ch]: Add timeline marker API;
	using markers it is possible to add a unique identifier to
	a particular frame of the timeline, and receive a signal
	notification when reaching that particular marker while
	playing the timeline. (#641)

	* tests/test-timeline.c: Update the test case to check for
	the marker-reached signal emission.

	* clutter.symbols: Add new symbols.

2008-03-10  Øyvind Kolås  <pippin@o-hand.com>

	* tests/test-shader.c: improved readability of fragment shader
	examples by factoring out common bits into FRAGMENT_SHADER_BEGIN and
	FRAGMENT_SHADER_END macros.

2008-03-09  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-id-pool.c: (clutter_id_pool_free):
	Use g_slice_free not g_free.
	* clutter/clutter-main.c: (_clutter_do_pick):
	Dont 'over read' the framebuffer when picking (#839, Neil Roberts)

2008-03-07  Øyvind Kolås  <pippin@o-hand.com>

	Refactored the integer id->ClutterActor mapping code to be a self
	contained data structure.

	* clutter/clutter-id-pool.[ch]: new files.
	* clutter/Makefile.am: added clutter-id-pool.[ch]
	* clutter/clutter-private.h: use a ClutterIDPool instead of GArray and
	GSList to keep track of the reusable ids.
	* clutter/clutter-actor.c: moved id pool logic away.
	* clutter/clutter-main.c: simplified id pool creation/finalization.

2008-03-07  Robert Bragg  <bob@o-hand.com>

	* clutter/clutter-timeline.c:
	Timeline changes to fix the issues identified in bugzilla #439

	Notably, this includes some tweaks to timeline semantics.
	So e.g. for a

	10 frame timeline here are some points about the new timeline code:

	- When you create a timeline it starts with current_frame_num == 0

	- After starting a timeline, the first timeout is for
	  current_frame_num == 1 (Notably it isn't 0 since there is a delay
	  before the first timeout signals so re-asserting the starting point
	  would give a longer than average first frame.)

	- For a non looping timeline the last timeout would be for
	  current_frame_num == 10

	- For a looping timeline the timeout for current_frame_num ==
	  10 would be followed by a timeout for current_frame_num == 1
	  and frame 0 is considered == frame 10.

	- Asking for a timeline of N frames might better be described
	  as asking for a timeline of _length_ N.

	Warning: Although I tried to test things, I guess it's quite
	likely that this breaks somthing depending on a specific quirk
	of the previous timeline code.

2008-03-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_anchor_point_from_gravity): Fix a stupid
	conversion from pixels to units that should I not have made.

2008-03-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: Update the release notes.

2008-03-06  Gwenole Beauchesne  <gbeauchesne@splitted-desktop.org>

	Signed off by: Emmanuele Bassi <ebassi@openedhand.com>

	* clutter/clutter-group.c (clutter_group_real_lower): Fix to
	actually lower the actor under the 'above' actor. (#822)

2008-03-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-entry.h:
	* clutter/clutter-entry.c:
	(clutter_entry_handle_key_event_internal),
	(clutter_entry_key_press), (clutter_entry_class_init),
	(clutter_entry_handle_key_event): Provide a default class handler
	for the key-press-event, so that giving key focus to an entry will
	automatically make it work. This deprecates the
	clutter_entry_handle_key_event() function. (#824)

	* tests/test-entry.c (main): Remove the handle_key_event()
	machinery, and just give focus to the entry.

2008-03-06  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-model.c: (clutter_model_set_sorting_column):
	Don't disable sorting on column 0

2008-03-06  Emmanuele Bassi  <ebassi@openedhand.com>

	Add support for the anchor point inside ClutterScript (#834,
	David Stanczak)

	* clutter/clutter-actor.c:
	(clutter_actor_set_property),
	(clutter_actor_get_property),
	(clutter_actor_class_init): Add the :anchor-x and :anchor-y
	properties to the ClutterActor class.

	(clutter_actor_set_anchor_point),
	(clutter_actor_set_anchor_pointu),
	(clutter_actor_set_anchor_point_from_gravity): Reimplement
	the pixel based and gravity based API using the units based
	one. Emit the ::notify signal for the :anchor-x and :anchor-y
	properties.

	(parse_units),
	(clutter_actor_parse_custom_node): Parse the :anchor-x and
	:anchor-y properties using the custom units format (mm, px,
	pt and %).

	* tests/test-script.json: Test the newly added properties.

2008-03-05  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Add "osx" the the AC_HELP_STRING of the flavour
	selection. (#831, Peter Enzerink)

2008-03-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c (clutter_do_event): Do not throttle the
	motion events if the per-actor delivery has been disabled.

2008-03-04  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/pango/pangoclutter-render.c: (draw_glyph): use g_slice_new0
	instead of g_slice_new when allocating the glyph_info, avoiding a
	branch based on uninitialized memory.

2008-03-03  Emmanuele Bassi  <ebassi@openedhand.com>

	* Makefile.am: Do not recurse into doc if we did not explicitly
	enabled the documentation build; we just recurse into doc if we
	are doing a dist or a distcheck.

2008-02-29  Øyvind Kolås  <pippin@o-hand.com>

	Reuse the numeric id's used for picking actors to avoid the potential
	of overflowing the id numbers when continusly creating and destroying
	actors on long running applications for 16bpp.

	* clutter/clutter-private.h: replaced hashtable with GArray and a
	GSList for available slots in the array.
	* clutter/clutter-actor.c: (create_actor_id): function to create an
	actor->id mapping, (release_actor_id): function to mark an existing id
	as available for reuse.
	* clutter/clutter-main.c: (clutter_context_free): added utility
	function for cleaning up the context,
	(clutter_get_actor_by_gid): use the GArray for looking up actors.

2008-02-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-alpha.c:
	(clutter_exp_inc_func),	(clutter_exp_dec_func): Clamp the value
	of the alpha function between [0, MAX_ALPHA]. (#800)

2008-02-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c (emit_event): Fix the last commit
	which inverted a condition.

2008-02-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Remove the usage of g_return_if_fail()
	from static functions: either assert or use g_warning() to check
	internal state, as g_return_if_fail() can be compiled out.

	* clutter/clutter-main.c: Ditto as above.

2008-02-25  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-texture.c:
	(texture_update_data):
	Set alignment based on actual data rowstride, not the texture
	width.

2008-02-21  Tomas Frydrych  <tf@openedhand.com>

	* clutter/x11/clutter-backend-x11.h:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-x11.h:
	(clutter_x11_handle_event):
	(clutter_x11_disable_event_retrieval):
	Functions to allow to hook into external XEvent retrieval (for
	example when using clutter with gtk); NB: this API is tentative.

2008-02-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-event-x11.c (event_translate): Ignore
	PropertyNotify events if they don't match our window.

	* clutter/x11/clutter-stage-x11.c:
	(clutter_stage_x11_request_coords): Chain up to the parent's
	request coords.

2008-02-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-event-x11.c (event_translate): Ignore
	ConfigureNotify events if we are painting on a foreign window.

	* clutter/x11/clutter-stage-x11.c:
	(clutter_stage_x11_request_coords): Reliquish control of the
	window size, if we are painting on a foreign window. This fixes
	the GtkClutterEmbed widget.

2008-02-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-timeline.c (clutter_timeline_set_delay): Relax
	the condition to allow 0 msecs of delay (meaning: no delay).

2008-02-20  Tomas Frydrych  <tf@openedhand.com>

	* clutter/Makefile.am:
	Added libclutter_ ... _la_DEPENDENCIES to fix dependency tracking.

2008-02-20  Tomas Frydrych  <tf@openedhand.com>

	* clutter/x11/clutter-x11.h:
	* clutter/x11/clutter-backend-x11.c:
	(clutter_x11_set_display):
	Function to set X display connection prior to calling
	clutter_init(); stripped loads of trailing space.

2008-02-20  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-marshal.list:
	* clutter/glx/Makefile.am:
	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-backend-glx.h:
	* clutter/glx/clutter-glx.h:
	* clutter/x11/Makefile.am:
	ClutterX11TexturePixmap and ClutterGLXTexturePixmap actors (#713;
	patch by Johan Bilien).

2008-02-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	(clutter_actor_get_abs_opacity): Add function that does what
	get_opacity() does now...

	(clutter_actor_get_opacity): ... and make get_opacity() do what
	it's supposed to be doing. The original get_opacity() returned
	a composited value, and there's no way to actually extract the
	real opacity value set with set_opacity().

	* clutter/clutter-clone-texture.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-texture.c: Update to use get_abs_opacity().

	* clutter/clutter-entry.c:
	* clutter/clutter-label.c: Ditto. Also, never change the stored
	alpha value. (#804)

	* tests/Makefile.am:
	* tests/test-opacity.c: Test suite for the get_opacity() and
	get_abs_opacity() API, and correct opacity handling.

	* README: Add note about the change in get_opacity().

2008-02-19  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-model.c: (clutter_model_resort):
	Don't return when there's no sort function set, leave that to the
	model sub-class

2008-02-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac:
	* README: Post stable release bump to 0.7.1

2008-02-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* README:
	* NEWS: Release 0.6.0

2008-02-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-list-model.c:
	(clutter_list_model_iter_set_value): Fix a typo in the conversion
	code.

2008-02-18  Chris Lord  <chris@openedhand.com>

	* README:
	Fix spelling mistake and a typo

2008-02-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_get_box_from_vertices): Avoid a masking warning
	caused by math.h utter braindamage.

2008-02-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Document the fact that ancestor can
	be NULL in the relative transformation API, and what are the
	effects.

2008-02-15  Matthew Allum  <mallum@openedhand.com>

	* clutter/pango/pangoclutter-render.c: (draw_glyph):
	More safety checks (#796, Tero Saarni)

2008-02-15  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-entry.c:
	* clutter/clutter-group.c:
	* clutter/clutter-label.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-texture.c:
	More documentation fixes

2008-02-15  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-entry.c: (clutter_entry_class_init):
	More documentation fixes

2008-02-15  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-label.c: (clutter_label_class_init):
	More documentation fixes

2008-02-15  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-clone-texture.c:
	* clutter/clutter-texture.c: (clutter_texture_class_init):
	More documentation fixes

2008-02-15  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-container.c:
	* clutter/clutter-media.c:
	* clutter/clutter-rectangle.c:
	* clutter/clutter-stage.c: (clutter_stage_class_init):
	* clutter/clutter-stage.h:
	* clutter/clutter-texture.c:
	* doc/reference/clutter-docs.sgml:
	Fix more documentation

2008-02-15  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.[ch]:
	* clutter/clutter-types.h:
	* doc/reference/clutter-docs.sgml: Fix a lot of documentation.

2008-02-15  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gles/cogl.c: (cogl_paint_init):
	Remove depth test getting turned on by default (unlike GL backend)

2008-02-15  Tomas Frydrych  <tf@openedhand.com>

	* configure.ac:
	* clutter/clutter-version.h.in:
	* build/msvc_2k5/clutter-version.h:
	Removed unused --without-fpu configure option and CLUTTER_NO_FPU
	macro

2008-02-15  Tomas Frydrych  <tf@openedhand.com>

	* build/mingw/README:
	* build/mingw/mingw-cross-compile.sh:
	Script that automates cross compilation with mingw by Neil Roberts
	<bpeeluk@yahoo.co.uk>

2008-02-15  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.[ch]: Rename
	clutter_actor_get_box_from_vertices() to
	clutter_actor_box_get_from_vertices().

	* clutter/clutter-group.c (clutter_group_query_coords): Fix the
	query_coords() implementation.

2008-02-15  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	(clutter_group_query_coords):
	Added function to translate vertex array to a bounding box.

	(clutter_actor_is_scaled):
	(clutter_actor_is_rotated):
	Fixed documentation.

2008-02-15  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-group.c: (clutter_group_query_coords):
	Disabled new code taking into account actor scale and rotation.

2008-02-14  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	(clutter_actor_is_scaled):
	(clutter_actor_is_rotated):
	Convenience functions to test whether actor is scaled or rotated.

	(clutter_actor_apply_relative_transform_to_point):
	Removed unused variable.

	* clutter/clutter-group.c:
	(clutter_group_query_coords):
	Use clutter_actor_get_relative_vertices() to calculate bounding
	boxes of children that are scaled or rotated.

2008-02-14  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	(clutter_actor_get_relative_vertices):
	(clutter_actor_apply_relative_transform_to_point):
	Functions to calculate actor vertices in the plane of a given
	ancestor.

2008-02-12  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-texture.c: (texture_get_tile_pixbuf),
	(clutter_texture_get_pixbuf):
	Fix copying textures to pixbufs for tiled textures and correct #ifndef
	typo

	* clutter/clutter-util.c:
	Amend documentation

2008-02-12  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c: (texture_get_tile_pixbuf):
	ifdef out 'leaked' GL only API call.

2008-02-12  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-texture.c (texture_update_data):
	Fixed incorrect calculation of offset into texture data (needs to
	use width of the texture, not of the updated area).

2008-02-12  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-texture.c (texture_update_data):
	Fixed incorrect aligment of texture data.

2008-02-12  Tomas Frydrych  <tf@openedhand.com>

	* clutter/x11/clutter-event-x11.c (event_translate):
	Ignore events not directed at the stage window once they have been
	passed to the filter functions.

2008-02-11  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c:
	Minor documentation tweak to class description.

	* clutter/clutter-behaviour-scale.c:
	'Force' start + end vals of scale behaviour
	(#779, Havoc Pennington)

2008-02-11  Emmanuele Bassi  <ebassi@openedhand.com>

	* README:
	* NEWS: Release 0.5.6

	* configure.ac: Post release bump to 0.5.7.

	* clutter/clutter-behaviour-scale.c:
	* tests/test-fbo.c: Fix compilation warnings.

2008-02-11  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_transform_stage_point):
	Moved part of the calculation to floating point to avoid overflow
	of ClutterFixed range for large actors (bug 613).

2008-02-10  Matthew Allum    <mallum@o-hand.com>

	* clutter/osx/clutter-stage-osx.c
	Fix up a couple of typos breaking build.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Add actor box diagram and notes.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-path.c: Move the nice graph and
	description from the Path behaviour...

	* clutter/clutter-behaviour.c: ... to the main Behaviour class.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-path.c: Add a paragraph describing
	the effects of different alpha functions on the path behaviour.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Reference the newly added event-flow.png

	* clutter/clutter-alpha.c: Ditto, with alpha-func.png

	* clutter/clutter-texture.c: Fix the XML.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-path.c: Reference the newly
	added image showing the effects of different alpha functions
	on the same path behaviour.

	* configure.ac: Find out the prefix of some of the libraries
	we depend upon, so that gtk-doc can fix the references for us.

2008-02-08  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c:
	Tidy up offscreen code, adding into realize/unrealize.
	Add more safety code.
	Improve documentation.

2008-02-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script.c:
	(resolve_alpha_func): Use a whitelist containing the alpha function
	provided by Clutter, as a fallback in case g_module_open() does not
	work.

	(clutter_script_parse_alpha): Add an explicit warning in case we
	cannot find the alpha function used inside a UI definition.

2008-02-07  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-group.c (clutter_group_query_coords):
	Take into account the anchor point when calculating the box size.

2008-02-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Add a note on clutter_actor_set_size()
	reguarding groups.

	* clutter/clutter-group.c: Clarify group sizing.

2008-02-07  Øyvind Kolås  <pippin@o-hand.com>

	* tests/test-shader.c: (button_release_cb): added simplified
	implementation of a box-blur shader from Gwenole Beauchesne that
	should work on GLSL implementing low-end IGPs not implementing
	dynamic branching. The original code used crashed some of these
	due to bugs in drivers or similar. Resolves bug #710.

2008-02-07  Tomas Frydrych  <tf@openedhand.com>

	* tests/test-actors.c:
	Reverted previous change.

2008-02-07  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_property):
	Fixed handling of PROP_ROTATE_CENTER_Y, ROTATE_CENTER_Z

	* tests/test-actors.c:
	Adjusted to use anchor point for both group and hands.

2008-02-07  Neil J. Patel  <njp@o-hand.com>

	* tests/test-actors.c: (frame_cb), (main):
	Changed set_anchor to move_anchor.
	Changed clutter_actor_rotate x & y values to 0,0.
	Switched on scaling because it seems to work without drifting.

2008-02-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-script-parser.c:
	(clutter_script_get_type_from_symbol),
	(clutter_script_get_type_from_class): Use BIND_LAZY flag
	when looking at the symbols, so we don't load them all up.

	* clutter/clutter-script.c (resolve_alpha_func): Ditto as above.

2008-02-07  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-actor.c:
	(_clutter_actor_apply_modelview_transform): perform translation as
	well as anchor point adjustment based on self not being stage (and
	not by self not being an orphan).

2008-02-07  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-stage.c:
	* clutter/clutter-stage.h:
	* clutter/eglnative/clutter-stage-egl.c:
	* clutter/eglx/clutter-stage-egl.c:
	* clutter/osx/clutter-stage-osx.c:
	* clutter/sdl/clutter-stage-sdl.c:
	* clutter/x11/clutter-stage-x11.c:
	Add at least somne basic offscreen handling into all backends.
	Remove unused clutter_stage_set_offscreen vfunc. (#549)

	* clutter/clutter-texture.c:
	Minor API doc tweak, noting rowstride source in set_area

2008-02-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.c (traverse_children): Actually implement
	clutter_score_list_timelines().

	* tests/test-score.c (main): Test clutter_score_list_timelines().

2008-02-07  Matthew Allum  <mallum@openedhand.com>

	* clutter/pango/pangoclutter-render.c:
	Warn if requested glyph is too big for underlying texture cache.
	(see #666)

2008-02-07  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c: (texture_upload_data):
	Remove random appearing 'priv->filter_quality =1' (#643)

2008-02-06  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c:
	Minor clean up from last commit.

	* tests/test-fbo.c:
	Small tweak (rotate offscreen, rather than resize)

2008-02-06  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c:
	Initial attempt at handling resizing/tranformed source textures.

	* clutter/pango/pangoclutter-render.c: (draw_glyph):
	Guards against freetype returning NULL bitmaps and
	thus causing device by zeros on NVIDIA drivers. (see ml)

2008-02-05  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c: (clutter_actor_get_vertices):
	Make sure GL related Matrices are initialised. Fixes #756

	* clutter/clutter-texture.c:
	Fix up code from Norways answer to Jean-Michel Basquiat.
	(warning on tile_get_pixbuf)

2008-02-05  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-texture.c: removed spurious left over debug printf.

2008-02-05  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-texture.c: applied modified patch from Gwenole
	Beuchesne adressing bug #635. Adressing a buffer overflow in
	clutter_texture_get_pixbuf() when tiling is forced.

2008-02-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-shader.c (clutter_shader_constructor): Keep the
	constructor line under the 80 columns using a variable.

2008-02-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-shader.c: Small documentation and style fixes

	* tests/test-scale.c: Constify the gravities array.

2008-02-04  Chris Lord  <chris@openedhand.com>

	* clutter/clutter-actor.c: (clutter_actor_transform_stage_point):
	Check that x_out and y_out != NULL before setting their contents

2008-02-04  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-timeline.c: (clutter_timeline_rewind): updated
	documentation to take direction into account.

2008-02-04  Øyvind Kolås  <pippin@o-hand.com>

	* tests/test-fbo.c: (make_shader):
	* tests/test-shader.c: (main): multiply the resulting gl_FragColor
	with gl_Color before being done to take opacity into account in the
	GLSL fragments.

2008-02-04  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-actor.[ch]: added clutter_actor_get_shader and
	renamed clutter_actor_apply_shader to be clutter_actor_set_shader.
	Reindented/aligned header.
	* clutter/clutter-texture.c: (clutter_texture_paint): temporarily
	disable the shader on top of the clutter context's shader stack while
	rendering into the FBO.
	* tests/test-fbo.c: (main): s/apply_shader/set_shader/
	* tests/test-shader.c: (button_release_cb), (main):
	s/apply_shader/set_shader/

2008-02-03  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-actor.c: (clutter_actor_set_rotationx):
	Add notify signal for set_rotate

	* clutter/clutter-texture.c:
	Add basic cleanup code for fbo's

	* tests/test-fbo.c: (main):
	Minor notes.

	* clutter/osx/clutter-stage-osx.c: (clutter_stage_osx_realize):
	Turn on vblanking.

2008-02-03  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-shader.c:
	Minor formatting cleanups to fit in 80 cols.

	* clutter/clutter-texture.c:
	More safety checks, clean ups in clutter_texture_new_from_actor()

	* clutter/cogl/gl/cogl.c:
	Always clear the FBO initially when rendering

	* tests/test-fbo.c:
	Overhall the test as to be more useful (and show current issues)

2008-02-02  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-timeline.c:
	Document frame number limits in new-frame signal.

	* clutter/x11/clutter-event-x11.c:
	Remove uneeded error trap (#751)

2008-02-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/cogl.h:
	* clutter/cogl/gl/cogl.c: (cogl_paint_init), (cogl_enable):
	* clutter/cogl/gles/cogl.c: (cogl_enable):

       Disable the depth test and buffer as has some strange side
       effects, mainly on x/y axis rotation with multiple layers at
       same depth (eg rotating text on a bg has very strange
       effect). Seems no clean 100% effective way to fix without other
       odd issues.. So for now move to application to handle and add
       cogl_enable_depth_test() as for custom actors (i.e groups) to
       enable if need be.

2008-02-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-texture.c: (clutter_texture_new_from_actor):
	Fix typo breaking FBO rendering on anything other than a cloned
	texture.

2008-02-01  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-feature.h:
	* clutter/clutter-texture.c:
	* clutter/clutter-texture.h:
	* clutter/cogl/cogl.h:
	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/cogl.c:
	* tests/Makefile.am:
	* tests/test.fbo.c:
	Add initial support for FBO's in Clutter (OpenGL only so far).
	See new clutter_texture_new_from_actor()
	Initial implementation, needs work.

	* clutter/x11/clutter-stage-x11.c:
	(clutter_stage_x11_set_cursor_visible):
	Fall back to again not relying on xfixes to hide cursor. *sigh*

	* clutter/clutter-deprecated.h:
	Add clutter_group_find_child_by_id

2008-02-01  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/cogl/gles/cogl.c: (cogl_rectangle_internal): increase size
	of GLfixed[] array to make contents fit.

2008-02-01  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h: Clean up a bit the flag-related macros.

2008-02-01  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_get_property): Use clutter_actor_get_reactive()
	instead of the IS_REACTIVE() macro.

	(clutter_actor_set_reactive): Emit the notify signal for the
	reactive property.

	* clutter/clutter-timeline.c:
	(timeline_timeout_func),
	(clutter_timeline_get_delta): Coding style fixes.

2008-01-31  Rob Bradford  <rob@openedhand.com>

	* clutter/glx/clutter-stage-glx.c:
	* clutter/glx/clutter-backend-glx.c:
	* clutter/glx/clutter-backend-glx.h:
	Fix formatting.

2008-01-31  Emmanuele Bassi  <ebassi@sprite>

	* clutter/clutter-timeline.c (clutter_timeline_skip): Don't
	add the frames outside the direction check. (thanks to benoar
	on clutter-list for spotting it)

2007-01-31  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_transform_vertices):
	Call clutter_actor_query_coords() instead of accessing the actor
	box, so that actors that calculate their bounding box on the fly
	(like ClutterGroup) work.

	* (_clutter_actor_apply_modelview_transform_recursive):
	Made to work for parentless actors.

2008-01-31  Øyvind Kolås  <pippin@o-hand.com>

	* tests/test-depth.c: added a box of cloned hands to further expand
	the scope of depth testing scenarios exercised by test-depth.

2008-01-31  Øyvind Kolås  <pippin@o-hand.com>

	* tests/test-depth.c: (timeline_completed): make use of
	clutter_timeline_set_direction instead of static state.
	(raise_top): made rectangle remain at fixed depth and raise
	above each other.
	(janus_group): added a rectangle with two faces, one red and
	one green, that spins around.

2008-01-31  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-entry.h:
	* clutter/clutter-entry.c:
	(clutter_entry_set_cursor_position),
	(clutter_entry_get_cursor_position): Rename [gs]et_position()
	to [gs]set_cursor_position(), and avoid method name collisions
	with bindings for high-level languages.

	* clutter/clutter-deprecated.h: Add replacement warnings for the
	renamed methods.

2008-01-31  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_init): Explicitly
	memset() to 0 the clip container, so if you get the clip without
	having set it, you won't get garbage.

2008-01-31  Rob Bradford  <rob@openedhand.com>

	* clutter/x11/clutter-backend-x11-private.h:
	Add missing start to comment

	* clutter/x11/clutter-backend-x11.c:
	* clutter/x11/clutter-event-x11.c:
	* clutter/x11/clutter-stage-x11.c:
	* clutter/x11/clutter-x11.h:
	Remove tabs.

2008-01-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: Add the osx flavour, and mark it experimental,
	along with the sdl backend. EGL-based backends should not be
	considered experimental anymore, even though they might require
	tweaking.

2008-01-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* HACKING: Expand the "document API" point, and the release
	process.

	* README: Update the release notes regarding the scale behaviour,
	now that the gravity has been removed.

2007-01-30  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	Added new clutter_actor_move_anchor_point_ API.

	* clutter/clutter-behaviour-scale.c:
	* clutter/clutter-behaviour-scale.h:
	* clutter/clutter-effect.c:
	* clutter/clutter-effect.h:
	* tests/test-actors.c:
	* tests/test-effects.c:
	* tests/test-scale.c:
	Removed gravity from ClutterBehaviourScale.

2008-01-27  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-depth.c (main): Use a group instead of pushing
	the actors on the stage.

2008-01-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-group.c (sort_z_order): Invert condition to
	return to the same as in revision 1976.

2008-01-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c (clutter_label_query_coords): Check
	if the layout logical rectangle size is bigger than the bounding
	box; this usually means that the bounding box changed in one
	point and the label private allocation needs to be
	updated. (#724)

2008-01-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/Makefile.am: Add the generated clutter-x11 pkg-config
	file to CLEANFILES, to pass distcheck.

	* Makefile.am:
	* clutter/Makefile.am: Tweak up the Makefiles.

	* README:
	* NEWS: Release 0.5.4

	* configure.ac: Post-release bump to 0.5.5

2008-01-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-group.c: Use a shorter Z order sorting function,
	avoiding the checks.

2008-01-25  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-shader.c: added documentation strings for
	ClutterShader.

2008-01-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* Makefile.am: Use variables, instead of substitutions.

	* clutter/clutter-private.h:
	* clutter/clutter-main.h: Make clutter_do_event() public again,
	as we need it in clutter-gtk.

	* configure.ac:
	* clutter/x11/Makefile.am:
	* clutter/x11/clutter-x11.pc.in: Add a clutter-x11 pkg-config
	file for clutter-gtk, as it depends on the X11 backend API, as
	implemented by the GLX and EGLX backends.

	* clutter/x11/clutter-event-x11.c (event_translate): Do not
	propagate DestroyNotify events if the stage doesn't own the
	window.

	* tests/test-scale.c (main): Set values different from the default.

2008-01-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-scale.c:
	(clutter_behaviour_scale_set_property),
	(clutter_behaviour_scale_class_init): Fix stupid typo in the
	y-scale-end property declaration. (#720)

2008-01-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-depth.h:
	* clutter/clutter-behaviour-depth.c:
	(clutter_behaviour_depth_set_bounds),
	(clutter_behaviour_depth_get_bounds): Add the depth-start and
	depth-end accessors.

	* tests/test-depth.c (timeline_completed): Use set_bounds()
	instead of g_object_set().

	* clutter.symbols: Add clutter_behaviour_depth_set_bounds()
	and clutter_behaviour_opacity_get_bounds() to the list of
	public symbols.

2008-01-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-scale.c: Use separate variables for
	storing the scale boundaries; apparently, using arrays broke
	the python bindings. (#720)

2008-01-21  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-group.c:
	Make sure unrealizing a group also unrealizes children.

	* clutter/glx/clutter-stage-glx.c:
	Chain up to group unrealize to make sure textures get unrealized
	when changing context (see #718)

	* clutter/clutter-texture.c:
	Formatting cleanups

2008-01-21  Øyvind Kolås  <pippin@gimp.org>

	* tests/test-shader.c: fix incompatible types in shader programs

	Apparently floats can't be multiplied or divided with ints without
	explicit type casts. Use 2.0 or float(var) where appropriate. Patch
	from Tommi Komulainen (#715).

2008-01-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c (generate_enter_leave_events): Do not
	take the explicit reference, and let clutter_event_copy() do it
	for us. (#714, Neil Roberts)

2008-01-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-event.c (clutter_event_copy): Take an extra
	reference on the related actor in ClutterEventCrossing that we
	explicitly unref in clutter_event_free(). (#714, Neil Roberts)

2008-01-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-actors.c (input_cb): Fix the callback signature;
	hide the clicked actor only if it's a hand.

2008-01-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c (clutter_do_event): Check the
	return value of the ::event signal for the CLUTTER_DELETE
	event type.

	* clutter/clutter-stage.c (clutter_stage_event): Emit the
	::event signal when receiving the CLUTTER_DELETE event; this
	allows to intercept the user's closing of the stage window.

2007-01-18  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.h:
	Added missing proto for clutter_fixed_qdivx().

2007-01-18  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.h:
	* clutter/clutter-fixed.c:
	Added CLUTTER_QDIV() for 64-bit division (bug 564, patch by
	Gwenole Beauchesne).

2008-01-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-event.h: Add a gunichar field for the Unicode
	representation of the key. (#555)

2008-01-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h:
	* clutter/clutter-script.h:
	* clutter/clutter-stage.h:
	* clutter/clutter-units.h: Documentation fixes and additions.

2008-01-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add ClutterBehaviourOpacity accessors.

	* clutter/clutter-behaviour-opacity.h:
	* clutter/clutter-behaviour-opacity.c:
	(clutter_behaviour_opacity_set_bounds),
	(clutter_behaviour_opacity_get_bounds): Add accessors for the
	opacity-start and opacity-end properties.

	* clutter/clutter-behaviour-scale.h: Fix the argument name to
	avoid complaints by gtk-doc.

2008-01-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-scale.c:
	(clutter_behaviour_scale_set_gravity): Notify on the right property
	name.

2008-01-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add new ClutterBehaviourScale setters.

	* clutter/clutter-behaviour-scale.[ch]: Split the scaling factors
	on both axis. Add setters for all the behaviour properties.

	* clutter/clutter-effect.h:
	* clutter/clutter-effect.c (clutter_effect_scale): Split the
	final scale factor to match the ClutterBehaviourScale changes. (#709)

	* tests/test-actors.c:
	* tests/test-effects.c:
	* tests/test-rotate.c:
	* tests/test-scale.c: Update after API change.

2008-01-16  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/cogl/cogl.h: Rename COGLhandleARB to COGLhandle.

	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/cogl/gl/cogl.c: Update GL implementation of COGL.

	* clutter/cogl/gles/cogl-defines.h:
	* clutter/cogl/gles/cogl.c: Update GLES implementation of COGL.

	* clutter/clutter-shader.c: Fix ClutterShader to use the new
	COGLhandle type instead of COGLhandlerARB.

2008-01-16  Emmanuele Bassi  <ebassi@openedhand.com>

	Define COGLhandleARB. (patch by Johan Bilien)

	* clutter/cogl/gles/cogl-defines.h: Define COGLhandleARB on
	GLES as well (using GLuint)

	* clutter/cogl/gles/cogl.c: Use COGLhandleARB.

2008-01-14  Tommi Komulainen  <tommi.komulainen@iki.fi>

	reviewed by: Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/osx/clutter-event-osx.c (_clutter_event_osx_put):
	Initialize ClutterEvent structure with zeroes (#672)

	The 'source' member was uninitialized and being referenced in
	clutter_do_event leading to crash.

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-scale.c: Improve test case for scaling (#684,
	Jaap A. Haitsma)

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-timeline.c (timeline_timeout_func): Fix
	check if the last frame was reached by skipping a frame (#654,
	Johan Bilien)

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-shader.c: Use correct format string for
	gssize. (#695, Tommi Komulainen)

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/cogl/gl/cogl.c (cogl_get_proc_address): Implement non-GLX
	version using GModule and looking up the symbol from the running
	process. It should work when linked to library providing the
	requested function. (#696, Tommi Komulainen)

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post-release bump to 0.5.3

	* README:
	* NEWS: Release 0.5.2

2008-01-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add clutter_model_insertv()

	* clutter/clutter-model.[ch] (clutter_model_insertv): Add a vector
	based insertion API, for language bindings

2008-01-12  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-effect.c (clutter_effect_rotate): Make the
	rotate effect work on the passed axis, instead of hardcoding
	the X axis. (#700, Neil Roberts)

2008-01-10  Øyvind Kolås  <pippin@gimp.org>

	Added COGLhandleARB since the underlying type on OSX is void*,
	patch from Tommi Komulainen <tommi.komulainen@iki.fi>, (#694)

	* clutter/cogl/gl/cogl-defines.h.in: Added COGLhandleARB typedef.
	* clutter/cogl/cogl.h:
	* clutter/cogl/gl/cogl.c:
	* clutter/clutter-shader.c: Use COGLhandleARB instead of COGLint when
	referring to program or shader handles.

2008-01-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/Makefile.am:
	* clutter/clutter.h:
	* clutter/clutter-list-model.[ch]: Complete the ClutterModelDefault
	to ClutterListModel rename by renaming the source files

2008-01-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model-default.[ch]: Rename ClutterModelDefault
	into ClutterListModel, to make it clear that the default
	ClutterModel implementation is list-based

	* tests/test-model.c: Update call

2008-01-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model-default.c:
	(clutter_model_default_new),
	(clutter_model_default_newv): Move the constructors in the
	right file

	* clutter/clutter-model-private.h: Add a private header for
	the ClutterModel implementations

	* clutter/clutter-model.c:
	(clutter_model_check_type),
	(clutter_model_set_n_columns),
	(clutter_model_set_column_type): Mark as private to Clutter,
	not static to ClutterModel

	* clutter/Makefile.am: Add clutter-model-private.h

2008-01-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c:
	(clutter_label_ensure_layout): Fix the ClutterUnits to Pango
	scale conversion.

2008-01-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.c:
	(clutter_model_appendv),
	(clutter_model_prependv): Fix the columns length pre-condition

2008-01-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model-default.[ch]: Remove the ClutterModelDefault
	iterator symbols from the public API; the iterator implementation
	is a detail of the default ClutterModel class

	* clutter.symbols: Update

2008-01-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.h:
	* clutter/clutter-model.c:
	(clutter_model_appendv),
	(clutter_model_prependv): Add vector based API for bindings.

	(clutter_model_get_column_name),
	(clutter_model_get_column_type),
	(clutter_model_set_sorting_column): Fix the check in the condition
	on the column index.

	* tests/test-scale.c (on_timeline_completed), (main): Fix spelling

	* clutter.symbols: Update public symbols

2008-01-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add clutter_actor_move_byu()

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	(clutter_actor_move_by),
	(clutter_actor_move_byu): Add a units-based variant of the
	clutter_actor_move_by() function

2008-01-02  Johan Bilien  <jobi@via.ecp.fr>

	reviewed by: Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Use AC_DEFINE_UNQUOTED to expand the
	variable. Fixes EGL backend build

2008-01-02  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Post release bump to 0.5.1

2008-01-02  Emmanuele Bassi  <ebassi@openedhand.com>

	* README:
	* NEWS: Release 0.5.0

2008-01-02  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model-default.c:
	(clutter_model_default_get_iter_at_row),
	(clutter_model_default_insert_row): Fix off-by-one errors

	(clutter_model_default_class_init):
	(clutter_model_default_remove_row): Move the actual removal of the
	row to...

	(clutter_model_default_row_removed): ... the signal class handler
	of ::row-removed; this way, signal handlers connected to
	::row-removed will get a valid iterator, while signal handlers
	connected to ::row-removed with the AFTER flag will get an updated
	model

2007-12-31  Tomas Frydrych  <tf@openedhand.com>

	* configure.ac:
	* clutter/Makefile.am:
	Added -no-undefined to libtool LDFLAGS for mingw/SDL backend, to
	allow building of shared libraries for win32.

2007-12-31  Tomas Frydrych  <tf@openedhand.com>

	* configure.ac:
	* clutter.pc.in:
	Added CLUTTER_REQUIRES automake var to allow deps in clutter.pc to
	be backend-specific.

2007-12-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c:
	(clutter_texture_unrealize): Do not read the pixels back if the
	texture is being destroyed

2007-12-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.c:
	(clutter_model_real_get_n_rows), (clutter_model_class_init),
	(clutter_model_get_n_rows): Provide a default implementation of
	the get_n_rows() method, so that subclasses do not strictly need
	to override it

2007-12-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(parse_rotation_array): Inline, and get the JsonArray as a parameter

	(parse_rotation): Update

	* clutter/clutter-script.c:
	(warn_missing_attribute): Fix for emacs-style warnings

	(clutter_script_parse_node): Remove an ifdeffed out section

	(clutter_script_construct_parameters),
	(clutter_script_construct_object): Rename get_parameters, so
	it's obvious what it does

2007-12-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-script.json: Fix the JSON syntax

2007-12-25  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-enum-types.c.in: Fix the template

2007-12-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-stage.c:
	* clutter/clutter-stage.h:
	* clutter/clutter-texture.c: Remove some of the remaining FIXMEs
	in the API documentation

2007-12-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-color.c:
	* clutter/clutter-event.c:
	* clutter/clutter-stage.c: Intern more strings using the I_() macro

	* clutter/clutter-enum-types.c.in: Call g_intern_static_string()
	in the enum types template

2007-12-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter.symbols: Add clutter_actor_set_clipu() and
	clutter_actor_get_clipu()

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	(clutter_actor_set_clipu), (clutter_actor_get_clipu): Add the
	new units-based versions of the clip accessors

	(clutter_actor_set_clip), (clutter_actor_get_clip): Reimplement
	the pixels-based clip accessors as proxies for the units-based
	ones

2007-12-24  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/cogl/cogl.h: Update cogl_clip_set() to accept the
	clip components as ClutterFixed values

	* clutter/cogl/gl/cogl.c (cogl_clip_set): Update the GL implementation
	of cogl_clip_set()

	* clutter/cogl/gles/cogl.c:
	(cogl_rectangle_internal): Provide an internal, inlined rectangle
	drawing	function using fixed point values, to be shared by
	cogl_clip_set() and cogl_rectangle()

	(cogl_clip_set), (cogl_rectangle): Update the GLES implementation
	of cogl_clip_set() and cogl_rectangle() to use the new internal
	rectangle drawing function

	* clutter/clutter-actor.c: Make the clip an array of ClutterUnit
	values instead of pixel-based; this allows higher precision and
	device independence

	(_clutter_actor_apply_modelview_transform): Pass the clip
	components converting from units to fixed point values, using
	the new cogl_clip_set() signature

	(clutter_actor_get_property), (clutter_actor_set_clip),
	(clutter_actor_get_clip): Update the accessors of the clip
	property

2007-12-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h: Remove the unused ::set_depth() and
	::get_depth() virtual functions. (#674, Murray Cumming)

2007-12-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-group.c:
	* clutter/clutter-group.h: Add the clutter_group_add() convenience
	function; it's now "undeprecated" and implemented as a macro

	* clutter/clutter-stage.h: Add clutter_stage_add() as a convenience
	macro

	* clutter/cogl/cogl.h: Include just the needed headers instead
	of the whole clutter.h; this avoids rebuild cogl when not needed

2007-12-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* Makefile.am: Move tests build before docs, to cut down the
	distcheck failure discovery

	* clutter.symbols: Add clutter_texture_set_area_from_rgb_data()

	* clutter/clutter-actor.c:
	* clutter/clutter-script.c:
	* clutter/clutter-texture.c:
	* clutter/json/json-generator.c:
	* clutter/json/json-parser.c: Compilation fixes for passing distcheck

	* tests/test-grab.c:
	* tests/test-score.c:
	* tests/test-script.c:
	* tests/test-shader.c:
	* tests/test-unproject.c: Ditto as above

2007-12-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c:
	(clutter_label_ensure_layout): Avoid rounding errors in the layout
	computing when switching between Clutter units and Pango units.

2007-12-19  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-texture.[ch]: (bug #675) added
	clutter_texture_set_area_from_rgb_data, sharing some of the
	initialization infrastructure with clutter_texture_set_from_rgb_data.

2007-12-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-container.c:
	(clutter_container_lower_child): Fix interface method call
	to actually call ClutterContainer::lower. (#670, Gwenole
	Beauchesne)

2007-12-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c:
	(clutter_label_query_coords): Return the bounding box set inside
	request_coords(), if any; otherwise, return the natural allocation
	of the label. (#678, reported by Gwenole Beauchesne)

	* tests/test-rotate.c: Align the label

2007-12-19  Tomas Frydrych  <tf@openedhand.com>

	* clutter/Makefile.am:
	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/pango/pangoclutter-render.c:
	* configure.ac:
	Fixes to allow cross-compilation with mingw (patch by Neil
	Roberts).
	Removed trailing whitespace.

2007-12-18  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-main.c: (generate_enter_leave_events): synthesize
	enter event (without related) and corresponding leave event when the
	actor the cursor is over has been destroyed.
	* clutter/clutter-event.c: (clutter_event_free): only unref the
	related_actor when it actually is set.

2007-12-18  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c:
	(unset_motion_last_actor),
	(generate_enter_leave_events): Attach a callback to the destroy
	signal on the last motion actor, so if it goes away while the
	pointer is in the middle of it we can unset the pointer.

	* clutter/clutter-private.h: Store the last motion actor inside
	the global context.

2007-12-17  Emmanuele Bassi <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_should_pick_paint),
	(clutter_actor_apply_transform_to_point): Fix the whitespace.

	(clutter_actor_set_rotation): Clarify that the coordinates of
	the centre of rotation are relative to the anchor point or,
	if not set, to the upper left corner of the bounding box.

2007-12-17  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-behaviour-ellipse.c:
	* clutter/clutter-behaviour-rotate.c:
	Clamping of start and end angles to <0, 360).

2007-12-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-path.c: Clarify the equivalence
	between the upper and lower bounds of the ClutterAlpha and
	the position in the path. (#634)

2007-12-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c: Mention the fact that a ClutterTexture
	will scale its contents to fit inside the requested bounding
	box. (#661)

2007-12-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Fix documentation for
	the ::captured-event signal. (#673)

2007-12-17  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Clarify the set_clip() method
	documentation, pointing out that the clip area origin is
	always the top-left corner of an actor.

2007-12-15  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-alpha.h:
	* clutter/clutter-event.h:
	* clutter/clutter-fixed.[ch]:
	* clutter/clutter-model.h:
	* clutter/clutter-shader.[ch]:
	* clutter/clutter-stage.c: Documentation fixes.

2007-12-15  Emmanuele Bassi <ebassi@openedhand.com>

	* clutter/clutter-model-default.c:
	(clutter_model_default_iter_next),
	(clutter_model_default_iter_prev): Do not instantiate a new
	iterator, and update the passed one instead, as we say we do
	in the documentation. This avoid leaking tons of iterators.

	* clutter/clutter-model.[ch]: Update the documentation.

	* tests/test-model.c: Prettify some output.

2007-12-14  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour.c:
	(clutter_knot_get_type): Use the I_() macro.

	* clutter/clutter-model.[ch]: Make ClutterModel and ClutterModelIter
	abstract classes; also, provide more virtual functions inside the
	ClutterModel vtable, to allow subclasses and language bindings to
	override the entire ClutterModel using other/native data types
	to store the rows.

	* clutter/clutter-model-default.[ch]: ClutterModelDefault is a
	default implementation of ClutterModel and ClutterModelIter using
	GSequence.

	* clutter/Makefile.am:
	* clutter/clutter.h: Build glue for ClutterModelDefault.

	* tests/test-model.c: Update for constructor changes.

	* tests/test-shader.c: Fix a typo.

2007-12-14  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/cogl/gles/cogl-defines.h:
	Add CLUTTER_COGL_HAS_GL/GLES defines

2007-12-11  Øyvind Kolås  <pippin@o-hand.com>

	Refined the ClutterShader API based on a patch from Emmanuele Bassi.

	* clutter/clutter-actor.c: (clutter_actor_paint),
	(clutter_actor_apply_shader): queue a redraw of actor when shader is
	set.
	* clutter/clutter-actor.h: indentation.
	* clutter/clutter-shader.[ch]: made the fragment and vertex shader
	sources properties. Report error through GError when binding shaders.
	* tests/test-shader.c: modified to use newer API.

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.c:
	(clutter_model_get_sorting_column): Fix wrong type check.

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.[ch]: Allow unsorting the model (passing
	-1 as the sorting column)

	(clutter_model_iter_get_valist): Do not initialise twice che
	return value.

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.c (clutter_model_iter_get_value): Initialise
	the passed GValue like the other getters do.

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.h:
	* clutter/clutter-model.c:
	(clutter_model_append_value),
	(clutter_model_prepend_value),
	(clutter_model_insert_value): Add a _value() variant for the
	insertion methods, for use of the language bindings.

	(clutter_model_append),
	(clutter_model_prepend),
	(clutter_model_insert): Do not return a boolean: insertion should
	never fail unless for a programming error, in which case we have
	plenty of warnings.

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-behaviour-ellipse.c:
	(clutter_behaviour_ellipse_get_angle_tilt),
	(clutter_behaviour_ellipse_get_angle_tiltx),
	(clutter_behaviour_ellipse_set_tilt): Fix a double conversion
	that was messing up the returned results. (#665)

2007-12-10  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_set_property),
	(clutter_actor_get_property),
	(clutter_actor_class_init): Add the rotation-* properties,
	controlling the rotation angle and center on each axis. (#614)

	(parse_rotation_array), (parse_rotation),
	(clutter_actor_parse_custom_node),
	(clutter_actor_set_custom_property),
	(clutter_scriptable_iface_init): Add a new "rotation" custom
	property for expressing the rotation along each axis in a
	compact way:

	  "rotation" : [
	    { "x-axis" : [ <angle>, [ <y>, <z> ] ] },
	    { "y-axis" : [ <angle>, [ <x>, <z> ] ] },
	    { "z-axis" : [ <angle>, [ <x>, <y> ] ] }
	  ]

	(clutter_geometry_get_type),(clutter_vertex_get_type),
	(clutter_actor_box_get_type): Use the I_() macro instead of
	directly calling g_intern_static_string().

	* clutter/clutter-entry.c (clutter_entry_request_coords):
	* clutter/clutter-label.c (clutter_label_ensure_layout),
	(clutter_label_request_coords): Use CLUTTER_UNITS_FROM_DEVICE()
	instead of CLUTTER_UNITS_FROM_INT(), as "device" means "pixels".

	* clutter/clutter-private.h: Add the I_() macro for intern
	static strings.

	* tests/test-script.json: Test the newly added "rotation"
	custom property.

2007-12-10  Tomas Frydrych  <tf@openedhand.com>

	* tests/Makefile.am:
	Fixed a typo.

2007-12-10  Tomas Frydrych  <tf@openedhand.com>

	* tests/test-viewport.c:
	* tests/Makefile.am:
	Added a simple viewport test.

2007-12-10  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	(_clutter_actor_apply_modelview_transform):
	Moved offset translation after rotation so that rotation coords
	are also relative to the offset point.

2007-12-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-events.c (input_cb):
	* tests/test-text.c (main): Fix compiler errors. (#592,
	Gwenole Beauchesne)

2007-12-09  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c: Document the values for full
	transparency and full opacity in the set_opacity()
	method. (#662)

	* clutter/clutter-behaviour-ellipse.c: Improve consistency
	in the apidoc.

2007-12-08  Emmanuele Bassi  <ebassi@openedhand.com>

	* configure.ac: Make libtool respect the -s switch of make
	and be quiet.

2007-12-07  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	(clutter_actor_get_sizeu),
	(clutter_actor_get_positionu): Add unit-based accessors to
	the size and position.

2007-12-07  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-behaviour-ellipse.c:
	(clutter_behaviour_ellipse_set_angle_start):
	(clutter_behaviour_ellipse_set_angle_end):
	(clutter_behaviour_ellipse_set_angle_tilt):
	(clutter_behaviour_ellipse_set_tilt):
	Removed strayed degree -> ClutterAngle conversions left over from
	API changes.

	(clutter_behaviour_ellipse_set_angle_tiltx):
	Removed stray printf.

2007-12-07  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-behaviour-ellipse.c:
	Fixed tilt setters and getters.

2007-12-06  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-fixed.c:
	* clutter/clutter-fixed.h:
	(clutter_sqrti):
	Added extra iteration to the Newton-Rapson algorithm for arguments
	lesser than 342 to improve precission.

2007-12-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-main.c:
	(clutter_set_motion_events_frequency): Never allow the motion
	events devlivery frequency to exceed the default frame rate.

2007-12-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/json/json-parser.[ch]: Use gssize, size we allow -1
	as a length (meaning "use the whole string").

	(json_parser_load_from_data): Use the passed length instead of
	using strlen() all the time.

	* clutter/clutter-script.[ch]: Ditto as above.

2007-12-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/pango/pangoclutter-render.c: Hush a compiler warning
	by removing a unused variable.

2007-12-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c (clutter_label_ensure_layout): If the
	label has a requested size, force it when ensuring the layout.

2007-12-06  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-unproject.c: Fix type comparison.

	* tests/test-score.c: Save the returned ids.

2007-12-05  Matthew Allum  <mallum@openedhand.com>

	reviewed by: <delete if not using a buddy>

	* clutter/pango/pangoclutter-render.c: (tc_get), (free_glyph_info),
	(draw_glyph), (draw_trapezoid), (pango_clutter_render_layout),
	(pango_clutter_render_layout_line),
	(pango_clutter_render_clear_caches), (prepare_run), (draw_begin):

2007-12-05  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.h: Rearrange declarations.

	* clutter/clutter-score.c: More documentation in the long
	description of the ClutterScore section.

	* clutter/clutter-debug.h:
	* clutter/clutter-main.c: Add the CLUTTER_DEBUG_SHADER flag,
	for debugging the shader calls.

	* clutter/clutter-feature.h: Fix the documentation of the
	feature flags.

	* clutter/Makefile.am: Remove trailing whitespace.

2007-12-05  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	* tests/Makefile.am:
	* tests/test-unproject:
	(clutter_actor_transform_stage_point):
	Added new function for translating stage coordinates into local
	actor coordinates.

2007-12-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.c: Better document ClutterScore
	and its API.

2007-12-04  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-score.[ch]: Reimplement ClutterScore using
	a N-ary tree to store the timelines. Remove clutter_score_add():
	the same functionality can be achieved by passing a NULL
	parent to clutter_score_append().

	* tests/test-score.c: Update ClutterScore test unit, and add
	debug printouts.

2007-12-04  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-shader.c: (bind_glsl_shader): use gchar instead of
	GLcharARB.

2007-12-03  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-shader.[ch]: do not include GL.h.

2007-12-03  Øyvind Kolås  <pippin@o-hand.com>

	Support for shaders in clutter. At the moment limited to drivers
	providing GLSL support.

	* clutter/cogl/cogl.h: added rather direct binding of needed for glsl
	shaders.
	* clutter/cogl/gl/cogl-defines.h.in:
	* clutter/cogl/gl/cogl.c:
	* clutter/cogl/gles/cogl-defines.h: added stubs.
	* clutter/cogl/gles/cogl.c: added stubs.

	* clutter/glx/clutter-stage-glx.c:
	(clutter_stage_glx_realize): unrelated memory management sanity fix.
	(clutter_stage_glx_unrealize): unbind all shaders on stage unrealize.

	* clutter/Makefile.am: added clutter-shader.[ch]
	* clutter/clutter-actor.[ch]: adding shader capability to
	actors.
	* clutter/clutter-feature.h: added CLUTTER_FEATURE_SHADERS_GLSL
	* clutter/clutter-private.h: added stack of shaders to context.
	* clutter/clutter-shader.[ch]: new.

	* tests/Makefile.am: added shader test.
	* tests/test-shader.c: (frame_cb), (main): simple shader test,
	cycle through the inline shader with right/left mouse buttons.

2007-12-03  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/glx/clutter-stage-glx.c: for extra sanity, set
	stage_x11->xvisinfo = NULL after XFree. Makes using the root window
	as foreign window possible.

2007-11-30  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-timeline.c: (clutter_timeline_get_delta): return the
	number of milliseconds passed between new-frame events instead of
	since new-frame events, thus making sure that the sum of _get_delta's
	returned for all new-frame events is equal to total time elapsed.

2007-11-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (parse_units),
	(clutter_actor_parse_custom_node): Do not allow using percentages
	of the stage on the stage itself, as it makes little to no
	sense.

	* clutter/clutter-script.c:
	(clutter_script_construct_object): Rearrange code.

	* tests/test-script.json: Do not set the size of the stage, to
	test for the stage size percentage.

2007-11-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.h: Complete the documentation of
	the ClutterModelClass structure members.

2007-11-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-timeline.h:
	* clutter/clutter-timeline.c
	(timeline_timeout_func),
	(clutter_timeline_get_delta): Add a function for retrieving
	the number of frames and the time (in milliseconds) elapsed
	since the last timeline ::new-frame signal. This can be useful
	for implementing a physics engine or just for knowing how if
	and how many frames have been skipped.

2007-11-30  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (parse_units),
	(clutter_actor_parse_custom_node),
	(clutter_scriptable_iface_init): Override the parsing code
	for the x, y, width and height properties of ClutterActor,
	to allow strings with modifiers when defining the position
	and/or the dimensions of an actor. Bare integers are assumed
	as pixels; floating point values in the [0, 1] interval are
	assumed as percentages; strings can have these modifiers:

	  - px - pixels
	  - mm - millimeters
	  - pt - points (at the current resolution)
	  - %  - percentage of the stage

	* clutter/clutter-units.h: Fix the conversion macros

	* tests/test-script.json: Test the new values.

2007-11-29  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-model.[ch]: Slight API change in the constructor
	functions for ClutterModel: clutter_model_new() now takes a list
	of GType/string pairs for both the column type and the column name.

	(clutter_model_set_n_columns),
	(clutter_model_set_names),
	(clutter_model_set_types): Subclasses of ClutterModel will be able
	to call clutter_model_set_types() and clutter_model_set_names() in
	any order, provided that they don't call each function more than
	once.

	* tests/test-model.c: Update the test case.

2007-11-29  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.h:
	* clutter/clutter-actor.c:
	Converted depth and rotation offsets to ClutterUnit.

	(clutter_actor_set_depthu):
	(clutter_actor_get_depthu):
	Additional ClutterUnit API.

	(_clutter_actor_apply_modelview_transform):
	Use cogl_translatex() in place of cogl_translate().

2007-11-29  Emmanuele Bassi  <ebassi@openedhand.com>

	* *: Add svn:ignore property to every directory, so that
	svn status starts being useful.

2007-11-29  Matthew Allum  <mallum@openedhand.com>

	* clutter/clutter-main.c: (generate_enter_leave_events):
	Minor formatting tweak.
	* configure.ac:
	Typo fix from Damien Lespiau (via mailing list)

2007-11-28  Emmanuele Bassi  <ebassi@openedhand.com>

	Add more introspection capabilities to the base model class

	* clutter/clutter-model.h:
	* clutter/clutter-model.c:
	(clutter_model_finalize): Do no leak the column types array.

	(clutter_model_get_n_columns): Function for getting the number
	of columns inside a model.

	(clutter_model_set_names): Add API for setting the names of the
	columns.

	(clutter_model_get_column_name),
	(_model_get_column_type): Add API for getting each column's name,
	and the default implementation for ClutterModel.

	(clutter_model_get_column_type),
	(_model_get_iter_at_row): Add API for getting each column's type,
	and the default implementation for ClutterModel.

	* clutter.symbols: Add ClutterModel and ClutterModelIter symbols,
	and keep the symbols file sorted.

2007-11-28  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-actor.h:
	(clutter_actor_set_positionu):
	(clutter_actor_set_sizeu):
	(clutter_actor_get_widthu):
	(clutter_actor_get_heightu):
	(clutter_actor_set_widthu):
	(clutter_actor_set_heightu):
	(clutter_actor_get_xu):
	(clutter_actor_get_yu):
	(clutter_actor_set_xu):
	(clutter_actor_set_yu):
	Expanded ClutterActor API with new ClutterUnit-base functions.

	* clutter/clutter-stage.c:
	* clutter/clutter-stage.h:
	(clutter_stage_get_resolution):
	(clutter_stage_get_resolutionx):
	New function to query stage resolution (floating and fixed point
	versions).

	* clutter/clutter-units.h:
	(CLUTTER_UNITS_FROM_STAGE_WIDTH_PERCENTAGE):
	(CLUTTER_UNITS_FROM_STAGE_HEIGHT_PERCENTAGE):
	(CLUTTER_UNITS_FROM_PARENT_WIDTH_PERCENTAGE):
	(CLUTTER_UNITS_FROM_PARENT_HEIGHT_PERCENTAGE):
	(CLUTTER_UNITS_FROM_MM):
	(CLUTTER_UNITS_FROM_MMX):
	(CLUTTER_UNITS_FROM_POINTS):
	(CLUTTER_UNITS_FROM_POINTSX):
	New macros for conversions to ClutterUnits.

	* clutter.symbols:
	Added:
		ClutterActor anchor_point functions,
		clutter_stage_get_resolution functions.

	Removed:
		clutter_actor_scale_with_gravity functions.

2007-11-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.[ch]: Documentation fixes.

2007-11-28  Emmanuele Bassi  <ebassi@openedhand.com>

	Remove the layout containers: they will be moved to a
	high-level library.

	* clutter/clutter.h:
	* clutter/Makefile.am: Remove layout and boxes from the
	build.

	* clutter/clutter-layout.[ch]: Remove the ClutterLayout
	interface.

	* clutter/clutter-box.[ch]:
	* clutter/clutter-hbox.[ch]:
	* clutter/clutter-vbox.[ch]: Remove ClutterBox and its
	subclasses.

	* clutter/clutter-label.c: Remove ClutterLayout implementation

	* clutter/clutter-script-private.h:
	* clutter/clutter-script-parser.c:
	* clutter/clutter-script.c:
	(clutter_script_parse_node): Remove special parsing for
	ClutterMargin and ClutterPadding.

	* clutter/clutter-types.h: Remove ClutterPadding and ClutterMargin.

	* tests/Makefile.am:
	* tests/test-boxes.c: Remove the boxes test case.

2007-11-28  Tomas Frydrych  <tf@openedhand.com>

	* clutter/NEWS:
	Started 0.6.0 section with comment on actor anchor point.

	* clutter/clutter/clutter-actor.c:
	* clutter/clutter/clutter-actor.h:
	* clutter/clutter/clutter-behaviour-scale.c:
	* clutter/clutter/clutter-deprecated.h:
	(clutter_actor_set_anchor_point):
	(clutter_actor_set_anchor_pointu):
	(clutter_actor_get_anchor_point):
	(clutter_actor_get_anchor_pointu):
	(clutter_actor_set_anchor_point_from_gravity):
	New anchor point API deprecating old gravity scaling, added
	comments on modelview matrix construction to ClutterActor
	documentation.

	(clutter_actor_set_scale_with_gravity):
	(clutter_actor_set_scale_with_gravityx):
	Deprecated; use clutter_actor_set_anchor_point_from_gravity() instead.

2007-11-28  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-effect.[ch]: Add clutter_effect_template_construct()
	function, for language bindings that need to set the alpha function
	but cannot call the clutter_effect_template_new() ctor themselves.

2007-11-27  Tomas Frydrych  <tf@openedhand.com>

	* clutter/clutter-behaviour-ellipse.c:
	* clutter/clutter-behaviour-ellipse.h:
	(clutter_behaviour_ellipse_get_angle_startx):
	(clutter_behaviour_ellipse_set_angle_startx):
	(clutter_behaviour_ellipse_get_angle_endx):
	(clutter_behaviour_ellipse_set_angle_endx):
	(clutter_behaviour_ellipse_get_angle_tiltx):
	(clutter_behaviour_ellipse_set_angle_tiltx):
	Changed to take and return angles in degrees represented as
	ClutterFixed.

2007-11-27  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_destroy): Remove the
	reference we hold on the actor, as it was preventing the finalization
	of every child on the stage.

2007-11-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-stage-x11.c:
	(clutter_stage_x11_set_cursor_visible): Restore the XFixes usage,
	as it now seems to be have been fixed.

2007-11-26  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_real_show),
	(clutter_actor_real_hide): Do not set the MAPPED flag on the actor
	if it is a top-level one (like ClutterStage); the backends are
	responsible for setting that flag, as it might be the result of an
	asynchronous operation (e.g. on X11).

	* clutter/eglnative/clutter-stage-egl.c:
	(clutter_stage_egl_show),
	(clutter_stage_egl_hide): Set/unset the CLUTTER_ACTOR_MAPPED flag
	on show and hide respectively.

	* clutter/osx/clutter-stage-osx.c:
	(clutter_stage_osx_show),
	(clutter_stage_osx_hide): Ditto as above.

	* clutter/sdl/clutter-stage-sdl.c:
	(clutter_stage_sdl_show),
	(clutter_stage_sdl_hide): Ditto as above, plus chain up to the
	parent class show/hide virtual functions.

	* clutter/x11/clutter-event-x11.c (event_translate): Use the MapNotify
	and UnmapNotify events to call the X11 stage map/unmap functions.

	* clutter/x11/clutter-stage-x11.[ch]:
	(clutter_stage_x11_set_fullscreen): Set the fullscreen_on_map flag
	with the fullscreen value.

	(clutter_stage_x11_map), (clutter_stage_x11_unmap): Set the MAPPED
	flag on the stage actor and redraw; also, if the fullscreen_on_map
	flag was set, call clutter_stage_fullscreen() as well. (#648)

	* tests/Makefile.am:
	* tests/test-fullscreen.c: Add a fullscreen test case for checking
	whether fullscreen works on every backend/platform.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	(clutter_actor_real_request_coords),
	(clutter_actor_request_coords),
	(clutter_actor_class_init): Provide a default ::request_coords()
	implementation in ClutterActor and use it to store the bounding
	box passed to clutter_actor_request_coords(). This makes the code
	more reliable and clean, and avoids a call to the subclass
	request_coords() method if the bounding box did not change. Now,
	every class overriding ClutterActor::request_coords() *must* chain
	up to the parent class method or the bounding box will not be
	saved inside the ClutterActor structure.

	* clutter/clutter-entry.c:
	* clutter/clutter-group.c:
	* clutter/clutter-hbox.c:
	* clutter/clutter-label.c:
	* clutter/clutter-texture.c:
	* clutter/clutter-vbox.c: Chain up to the parent class
	request_coords() method.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-event.h: Add more documentation.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* tests/test-event.c: Back out an accidental commit.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c:
	* clutter/clutter-alpha.c:
	* clutter/clutter-effect.c:
	* clutter/clutter-event.c:
	* clutter/clutter-event.h:
	* clutter/clutter-group.h:
	* clutter/clutter-model.c:,
	* clutter/clutter-script.c:
	* clutter/clutter-scriptable.h:
	* clutter/clutter-stage.c: Documentation fixes.

	* clutter/clutter-score.c: Fix implementation.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/x11/clutter-stage-x11.c: Chain up the hide and show
	to the parent's implementation.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-effect.[ch]: Update the effects API to remove
	the start value for most of them.

	(clutter_effect_move): Make it a simple "move from current
	position to new coordinates" effect.

	(clutter_effect_path): Rename from clutter_effect_move().

	(clutter_effect_rotate): Sync up with the new actor rotation API.

	* tests/test-effects.c: Regression test for the effects.

	* tests/Makefile.am: Build glue for test-effects

	* tests/test-behave.c: Emulate a full ramp by using a looping
	timeline changing its direction when reaching the last frame.

2007-11-23  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c (clutter_actor_destroy): Bail out
	if clutter_actor_destroy() was called on the stage: the stage
	is not for the user to destroy.

	* clutter/x11/clutter-backend-x11.c:
	* clutter/eglnative/clutter-backend-egl.c:
	* clutter/sdl/clutter-backend-sdl.c:
	* clutter/osx/clutter-backend-osx.c: Unset the top-level private
	flag on the stage when disposing it, so the backends can safely
	call clutter_actor_destroy().

	* clutter/clutter-private.h: Tweak the private flags accessors,
	to avoid the typecheck.

2007-11-22  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.c (clutter_label_new_full): Set the
	terminating NULL which was removed when applying patch for
	fixing #606. (#645, Gwenole Beauchesne)

2007-11-22  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-actor.c: mended a couple of typos in documentation.

2007-11-21  Matthew Allum  <mallum@openedhand.com>

	* clutter/cogl/gles/cogl.c: (cogl_fog_set):
	Minor fixes for fog on GLES.

2007-11-21  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/cogl/cogl.h: Add cogl_fog_set() abstracting the
	glFog() functions and enabling the GL_FOG flag.

	* clutter/cogl/gl/cogl.c: Add GL implementation of cogl_fog_set().

	* clutter/cogl/gles/cogl.c: Add GL/ES implementation of
	cogl_fog_set().

	* clutter.symbols: Add new symbols.

	* clutter/clutter-stage.h: Add API to enable depth cueing on
	the stage using a linear GL fog, and to set the parameters
	for it (#637).

	* clutter/clutter-stage.c (clutter_stage_paint): Enable the
	GL fog if the ClutterStage:use-fog property is true.

	* tests/test-depth.c: Test the new stage API.

2007-11-20  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-main.c: (event_click_count_generate): generalized
	click_count generation code.
	* tests/test-events.c: (input_cb): extended test to report click_count
	for release and scroll events as well as press events.

2007-11-20  Øyvind Kolås  <pippin@o-hand.com>

	* clutter/clutter-main.c: (clutter_do_event): avoid computing source
	of events if it is already set (for synthetic events.)
	* clutter/clutter-event.c: Add more information to the documentation
	of clutter_event_put.

2007-11-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* README: Add diff example command lines for submitting patches.

2007-11-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-actor.c::
	* clutter/clutter-behaviour-opacity.c:
	* clutter/clutter-clone-texture.c:
	* clutter/clutter-effect.c:
	* clutter/clutter-label.c: Remove the usage of G_PARAM_CONSTRUCT
	without an override for the ::construct virtual function; using
	G_PARAM_CONSTRUCT to set the default value of a property is not
	the recommended approach; default values are set inside the
	instance init function.

2007-11-20  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-texture.c (clutter_texture_init): Set filter-quality
	value to 1, to fix the regression caused when applying the patch for
	buf #616.

2007-11-19  Emmanuele Bassi  <ebassi@openedhand.com>

	* clutter/clutter-label.[ch]: Fix ClutterLabel size allocation when
	no bounding box has been provided, and store the box set by the
	user so that it can be reused when recomputing the layout. (#600)

